// **********************************************************************
//
// Copyright (c) 2003-2006 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************



#include "IPSServer/IPSServer.h"         //ҵͷļ
#include "IPSServer/VariantFactory.h"    //๤
#include "IPSServer/VariantI.h"          //๤
#include "IPSServer/IPSException.h"      //ҵϵͳ쳣ļ
#include "common/IPSUtil.h"              //ļ

#include "X_Define_Struct.h"             //ṹļ


using namespace std;
using namespace Ice;
using namespace InfoProcess;              //Ϣռ


///////////////////////////////////////////////////////////////////////////////
//        : CServer
//        : 
//  汾      : V1.0
//        : 2006-06-14
//    : 
//              Ice::Application̳Уʵ䴿麯runĄ̊́ϵͳ
//              ̣̼ж
//
//        : 
///////////////////////////////////////////////////////////////////////////////

class CServer : public Ice::Application
{
public:
	// ߳
    virtual int run(int, char*[]);
	
	// ҵ
	int  Connect2Server(void);

	// Ϣ
	void CServer::TestItemStateBatch(int i);

	//Item״̬
    InfoProcess::IPSItemStateMgtPrx     _itemStateMgt;  
    IceStorm::TopicManagerPrx     _tpcMng;                // IceStorm
    IPSStatePublisherPrx          _ItemStatePubPrx;       // Ŀ״̬
 

private:
	   // ICEͨ
    Ice::CommunicatorPtr    _communicator;
	
	 //߳˳־
	bool                    _bQuitFlag;       

};

///////////////////////////////////////////////////////////////////////////////
//  :   main
// ǰ汾 :   V1.0
//      :   wjy
//  :   2006-03-16
//  :
//              argc            ---     в
//              argv            ---     в
//      
//  :   
//              
//
// ֵ   :   
//              
//
// ˵ :   
//              C++Ӧõĳں
//              Ӧñ֤ͬһֻ̨һʵ
//              
// ޸ʷ :   
//                         
///////////////////////////////////////////////////////////////////////////////

int
main(int argc, char* argv[])
{
    CServer app;
    return app.main(argc, argv, "BackSvc.cfg");
}

///////////////////////////////////////////////////////////////////////////////
//  :   CServer::Connect2Server
// ǰ汾 :   V1.0
//      :   wjy
//  :   2006-03-16
//  :
//              
//      
//  :   
//              
//
// ֵ   :   int  0 ɹȡ
//              
//
// ˵ :   
//              ҵ,ȡĿԹĴ
//              
// ޸ʷ :   
//              
//
///////////////////////////////////////////////////////////////////////////////
int CServer::Connect2Server(void)
{
    
    //ȡItemĴϢ
    Ice::PropertiesPtr properties = communicator()->getProperties();
    
    if ( !properties )
    {
        cout << "ȡϢ" << endl;
        return -1;
    }
    
  /*  string proxy = properties->getProperty("InfoStateMgt.ItemStateMgt.Proxy");*/
    string proxy = properties->getProperty("IceStorm.TopicManager.Proxy");
    
	
    if(proxy.empty())
    {
        //ϢûϱϢ
        cout << "proxyItemStateMgtPropertyûá" << endl;
        return -1;
    }
    
    //õItem
   if(proxy.empty())
    {
        //ϢûϱϢ
        printf("proxyItemStateMgtPropertyûá\r\n");
        return -1;
    }
    
	IceStorm::TopicPrx tp = NULL;  

	try
	{
		_tpcMng = IceStorm::TopicManagerPrx::checkedCast(_communicator->stringToProxy(proxy)->ice_timeout(1000));
			
	} 
    catch (Ice::SocketException exS) 
    {
        ostringstream os;
        os << "ȡĿ״̬ϱӿʱʱ SocketException :" << exS;
        cout << os.str() << endl;
        
        //ACE_Guard<ACE_Thread_Mutex> guard(_prxISMutex);
        //GetIPSItemStateMgtPrx(sProxy);
    }
    catch (Ice::ObjectNotExistException exN) 
    {
        ostringstream os;
        os << "ȡĿ״̬ϱӿʱʱ ObjectNotExistException :" << exN;
        cout << os.str() << endl;
    }
    catch (Ice::ConnectionTimeoutException exT) 
    {
        ostringstream os;
        os << "ȡĿ״̬ϱӿʱʱ ConnectionTimeoutException :" << exT;
        cout << os.str() << endl;
    }
    catch (Ice::Exception ex) 
    {
        ostringstream os;
        os << "ȡĿ״̬ϱӿʱʱ Exception:" << ex;
        cout << os.str() << endl;
    }
	catch(...)
	{
		printf("ȡĿ״̬ϱӿʱ˴.\r\n");
	}   

	try
	{        
		// ǷѾ
		tp = _tpcMng->retrieve("IPS_DEFAULT_ITEM_STATE");	
	}
	catch(const IceStorm::NoSuchTopic& )
	{
		// ⲻڵĻ½        
		tp = _tpcMng->create("IPS_DEFAULT_ITEM_STATE");	
	}
	catch (...)
	{
		printf("ʧܡ\r\n");
	}

	try
	{
		//ȡָ
		Ice::ObjectPrx  pub = tp->getPublisher(); 
		pub = pub->ice_oneway()->ice_timeout(1000);
		_ItemStatePubPrx = IPSStatePublisherPrx::uncheckedCast(pub);
		
	}
	catch(...)
	{
		printf("ʧܡ\r\n");
	}
    
    
    return 0;
}
///////////////////////////////////////////////////////////////////////////////
//  :   CServer::TestItemStateBatch
// ǰ汾 :   V1.0
//      :   wjy
//  :   2006-03-16
//  :
//              int i           -- 
//      
//  :   
//              
// ֵ   :   
//              
//              
//
// ˵ :   
//              IPSItemStateSeq
//              
// ޸ʷ :   
//                         
///////////////////////////////////////////////////////////////////////////////
void CServer::TestItemStateBatch(int i)
{
    InfoProcess::IPSItemStateSeq                    isSeq;

	string str_head = "gyj.yw.dw.213810.";
	
	R_PINF r_PINF;

	r_PINF.terminalid = 213810;
	r_PINF.postype = 0;
	r_PINF.valid = 1;
	r_PINF.longitude = 11616.02 - (double)((double)i/100);
	r_PINF.latitude = 4004.998 - (double)((double)i/100);
	r_PINF.altitude = 66 + i;
	r_PINF.speed = 20;
	r_PINF.direction = 180;
	r_PINF.satnum = 6;


	string strpostime = IPSUtil::GetCurrTimeStr();
	
	sprintf(r_PINF.postime,"%s",strpostime.c_str());
	
	isSeq = r_PINF.toItemStateSeq(str_head);

    
    //1 һϢ
    cout << "ʼ" <<  i << endl;
	try
	{
		_ItemStatePubPrx->ReportItemState(isSeq);
	}
	catch (Ice::SocketException exS) 
    {
        ostringstream os;
        os << "״̬ͨӿڷ͵IceStormʱ SocketException :" << exS;
        cout << os.str() << endl;
        
        //ACE_Guard<ACE_Thread_Mutex> guard(_prxISMutex);
        //GetIPSItemStateMgtPrx(sProxy);
    }
    catch (Ice::ObjectNotExistException exN) 
    {
        ostringstream os;
        os << "״̬ͨӿڷ͵IceStormʱ ObjectNotExistException :" << exN;
        cout << os.str() << endl;
    }
    catch (Ice::ConnectionTimeoutException exT) 
    {
        ostringstream os;
        os << "״̬ͨӿڷ͵IceStormʱ ConnectionTimeoutException :" << exT;
        cout << os.str() << endl;
    }
    catch (Ice::Exception ex) 
    {
        ostringstream os;
        os << "״̬ͨӿڷ͵IceStormʱ Exception:" << ex;
        cout << os.str() << endl;
    }
    
    cout << "" << endl;

    return;
}


///////////////////////////////////////////////////////////////////////////////
//  :   CServer::run
// ǰ汾 :   V1.0
//      :   wjy
//  :   2006-03-16
//  :
//              argc            ---     в
//              argv            ---     в
//      
//  :   
//              
// ֵ   :   
//              0               ---     
//              0             ---     쳣
//
// ˵ :   
//              ̨ϵͳĽ
//              
// ޸ʷ :   
//                         
///////////////////////////////////////////////////////////////////////////////
int
CServer::run(int argc, char* argv[])
{

    _communicator = communicator();

	_bQuitFlag = false;
    
    //๤
    Ice::ObjectFactoryPtr factory = new CVariantFactory();
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantBoolean");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantByte");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantShort");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantInt");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantLong");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantFloat");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantDouble");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantString");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantCString");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantBlob");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantTime");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantShortVec");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantIntVec");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantLongVec");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantFloatVec");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantDoubleVec");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantVarVec");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantVarMap");
	
	if ( Connect2Server() )
    {
        cout << "ӵICEBOXʧܡ" << endl;
        return -1;
    }
    cout << "ɹӵICEBOX" << endl;

	int   i;
    
    i = 0;
    
    try
    {
        do
        {
            IceUtil::ThreadControl::sleep(IceUtil::Time::milliSeconds(5000));
            
            TestItemStateBatch(i);
            i++;
            if ( i >= 1119440)
            {
                _bQuitFlag = true;
            }
        } while(false == _bQuitFlag);
    }
    catch (IPSUpdateItemStateException* e)
    {
        cout << "񵽲Դ" << e->sReason << endl;
    }
    catch (Ice::Exception& exIce)
    {
        cout << "ICE쳣" << exIce << endl;
    }
	

    
    // These methods can be used to set a Ctrl+C Handler callback.
    //һIceUtil::CtrlCHandlerڸɾعرӦáȱʡΪ
    //This function creates an IceUtil::CtrlCHandler that shuts down the
    //    communicator when one of the monitored signals is raised.
    shutdownOnInterrupt();
    //destroyOnInterrupt();
    
    ///////////////////////////////////////////////////////////////////////////////
    try
    {
        cout << "̨׼" << endl;
        _communicator->waitForShutdown();
    }
    catch ( exception* e) 
    {
        string sReason;
        sReason = "̨ʱ˴";
        sReason += e->what();
        cout << sReason << endl;

    }
    catch ( ... ) 
    {
        string sReason;
        sReason = "̨ʱ˴";
        cout << sReason << endl;

    }
    
    cout << "ڴͷŹʼ" << endl;
       
    
    //ʹźűԡ
    ignoreInterrupt();
    cout << "̨ϵͳ˳׼ȫɣ˳С" << endl;

    
    return 0;
}
