// **********************************************************************
//
// Copyright (c) 2003-2006 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.1.0
// Generated from file `IPSItem.ice'

#ifndef __IPSItem_h__
#define __IPSItem_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>
#include <IPSVariant.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 301
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

namespace IceProxy
{

namespace InfoProcess
{

class IPSObject;
bool operator==(const IPSObject&, const IPSObject&);
bool operator!=(const IPSObject&, const IPSObject&);
bool operator<(const IPSObject&, const IPSObject&);
bool operator<=(const IPSObject&, const IPSObject&);
bool operator>(const IPSObject&, const IPSObject&);
bool operator>=(const IPSObject&, const IPSObject&);

class IPSItemDef;
bool operator==(const IPSItemDef&, const IPSItemDef&);
bool operator!=(const IPSItemDef&, const IPSItemDef&);
bool operator<(const IPSItemDef&, const IPSItemDef&);
bool operator<=(const IPSItemDef&, const IPSItemDef&);
bool operator>(const IPSItemDef&, const IPSItemDef&);
bool operator>=(const IPSItemDef&, const IPSItemDef&);

class IPSItemProperty;
bool operator==(const IPSItemProperty&, const IPSItemProperty&);
bool operator!=(const IPSItemProperty&, const IPSItemProperty&);
bool operator<(const IPSItemProperty&, const IPSItemProperty&);
bool operator<=(const IPSItemProperty&, const IPSItemProperty&);
bool operator>(const IPSItemProperty&, const IPSItemProperty&);
bool operator>=(const IPSItemProperty&, const IPSItemProperty&);

class PROPERTYDESC;
bool operator==(const PROPERTYDESC&, const PROPERTYDESC&);
bool operator!=(const PROPERTYDESC&, const PROPERTYDESC&);
bool operator<(const PROPERTYDESC&, const PROPERTYDESC&);
bool operator<=(const PROPERTYDESC&, const PROPERTYDESC&);
bool operator>(const PROPERTYDESC&, const PROPERTYDESC&);
bool operator>=(const PROPERTYDESC&, const PROPERTYDESC&);

class IPSItemState;
bool operator==(const IPSItemState&, const IPSItemState&);
bool operator!=(const IPSItemState&, const IPSItemState&);
bool operator<(const IPSItemState&, const IPSItemState&);
bool operator<=(const IPSItemState&, const IPSItemState&);
bool operator>(const IPSItemState&, const IPSItemState&);
bool operator>=(const IPSItemState&, const IPSItemState&);

}

}

namespace InfoProcess
{

class IPSObject;
bool operator==(const IPSObject&, const IPSObject&);
bool operator!=(const IPSObject&, const IPSObject&);
bool operator<(const IPSObject&, const IPSObject&);
bool operator<=(const IPSObject&, const IPSObject&);
bool operator>(const IPSObject&, const IPSObject&);
bool operator>=(const IPSObject&, const IPSObject&);

class IPSItemDef;
bool operator==(const IPSItemDef&, const IPSItemDef&);
bool operator!=(const IPSItemDef&, const IPSItemDef&);
bool operator<(const IPSItemDef&, const IPSItemDef&);
bool operator<=(const IPSItemDef&, const IPSItemDef&);
bool operator>(const IPSItemDef&, const IPSItemDef&);
bool operator>=(const IPSItemDef&, const IPSItemDef&);

class IPSItemProperty;
bool operator==(const IPSItemProperty&, const IPSItemProperty&);
bool operator!=(const IPSItemProperty&, const IPSItemProperty&);
bool operator<(const IPSItemProperty&, const IPSItemProperty&);
bool operator<=(const IPSItemProperty&, const IPSItemProperty&);
bool operator>(const IPSItemProperty&, const IPSItemProperty&);
bool operator>=(const IPSItemProperty&, const IPSItemProperty&);

class PROPERTYDESC;
bool operator==(const PROPERTYDESC&, const PROPERTYDESC&);
bool operator!=(const PROPERTYDESC&, const PROPERTYDESC&);
bool operator<(const PROPERTYDESC&, const PROPERTYDESC&);
bool operator<=(const PROPERTYDESC&, const PROPERTYDESC&);
bool operator>(const PROPERTYDESC&, const PROPERTYDESC&);
bool operator>=(const PROPERTYDESC&, const PROPERTYDESC&);

class IPSItemState;
bool operator==(const IPSItemState&, const IPSItemState&);
bool operator!=(const IPSItemState&, const IPSItemState&);
bool operator<(const IPSItemState&, const IPSItemState&);
bool operator<=(const IPSItemState&, const IPSItemState&);
bool operator>(const IPSItemState&, const IPSItemState&);
bool operator>=(const IPSItemState&, const IPSItemState&);

}

namespace IceInternal
{

void incRef(::InfoProcess::IPSObject*);
void decRef(::InfoProcess::IPSObject*);

void incRef(::IceProxy::InfoProcess::IPSObject*);
void decRef(::IceProxy::InfoProcess::IPSObject*);

void incRef(::InfoProcess::IPSItemDef*);
void decRef(::InfoProcess::IPSItemDef*);

void incRef(::IceProxy::InfoProcess::IPSItemDef*);
void decRef(::IceProxy::InfoProcess::IPSItemDef*);

void incRef(::InfoProcess::IPSItemProperty*);
void decRef(::InfoProcess::IPSItemProperty*);

void incRef(::IceProxy::InfoProcess::IPSItemProperty*);
void decRef(::IceProxy::InfoProcess::IPSItemProperty*);

void incRef(::InfoProcess::PROPERTYDESC*);
void decRef(::InfoProcess::PROPERTYDESC*);

void incRef(::IceProxy::InfoProcess::PROPERTYDESC*);
void decRef(::IceProxy::InfoProcess::PROPERTYDESC*);

void incRef(::InfoProcess::IPSItemState*);
void decRef(::InfoProcess::IPSItemState*);

void incRef(::IceProxy::InfoProcess::IPSItemState*);
void decRef(::IceProxy::InfoProcess::IPSItemState*);

}

namespace InfoProcess
{

typedef ::IceInternal::Handle< ::InfoProcess::IPSObject> IPSObjectPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSObject> IPSObjectPrx;

void __write(::IceInternal::BasicStream*, const IPSObjectPrx&);
void __read(::IceInternal::BasicStream*, IPSObjectPrx&);
void __write(::IceInternal::BasicStream*, const IPSObjectPtr&);
void __patch__IPSObjectPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const IPSObjectPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const IPSObjectPtr&);
void __decRefUnsafe(IPSObjectPtr&);
void __clearHandleUnsafe(IPSObjectPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSItemDef> IPSItemDefPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSItemDef> IPSItemDefPrx;

void __write(::IceInternal::BasicStream*, const IPSItemDefPrx&);
void __read(::IceInternal::BasicStream*, IPSItemDefPrx&);
void __write(::IceInternal::BasicStream*, const IPSItemDefPtr&);
void __patch__IPSItemDefPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const IPSItemDefPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const IPSItemDefPtr&);
void __decRefUnsafe(IPSItemDefPtr&);
void __clearHandleUnsafe(IPSItemDefPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSItemProperty> IPSItemPropertyPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSItemProperty> IPSItemPropertyPrx;

void __write(::IceInternal::BasicStream*, const IPSItemPropertyPrx&);
void __read(::IceInternal::BasicStream*, IPSItemPropertyPrx&);
void __write(::IceInternal::BasicStream*, const IPSItemPropertyPtr&);
void __patch__IPSItemPropertyPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const IPSItemPropertyPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const IPSItemPropertyPtr&);
void __decRefUnsafe(IPSItemPropertyPtr&);
void __clearHandleUnsafe(IPSItemPropertyPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::PROPERTYDESC> PROPERTYDESCPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::PROPERTYDESC> PROPERTYDESCPrx;

void __write(::IceInternal::BasicStream*, const PROPERTYDESCPrx&);
void __read(::IceInternal::BasicStream*, PROPERTYDESCPrx&);
void __write(::IceInternal::BasicStream*, const PROPERTYDESCPtr&);
void __patch__PROPERTYDESCPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const PROPERTYDESCPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const PROPERTYDESCPtr&);
void __decRefUnsafe(PROPERTYDESCPtr&);
void __clearHandleUnsafe(PROPERTYDESCPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSItemState> IPSItemStatePtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSItemState> IPSItemStatePrx;

void __write(::IceInternal::BasicStream*, const IPSItemStatePrx&);
void __read(::IceInternal::BasicStream*, IPSItemStatePrx&);
void __write(::IceInternal::BasicStream*, const IPSItemStatePtr&);
void __patch__IPSItemStatePtr(void*, ::Ice::ObjectPtr&);

void __addObject(const IPSItemStatePtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const IPSItemStatePtr&);
void __decRefUnsafe(IPSItemStatePtr&);
void __clearHandleUnsafe(IPSItemStatePtr&);

}

namespace InfoProcess
{

typedef ::std::vector< ::InfoProcess::IPSItemDefPtr> IPSItemDefSeq;

class __U__IPSItemDefSeq { };
void __write(::IceInternal::BasicStream*, const ::InfoProcess::IPSItemDefPtr*, const ::InfoProcess::IPSItemDefPtr*, __U__IPSItemDefSeq);
void __read(::IceInternal::BasicStream*, IPSItemDefSeq&, __U__IPSItemDefSeq);

typedef ::std::vector< ::InfoProcess::IPSItemPropertyPtr> IPSItemPropertySeq;

class __U__IPSItemPropertySeq { };
void __write(::IceInternal::BasicStream*, const ::InfoProcess::IPSItemPropertyPtr*, const ::InfoProcess::IPSItemPropertyPtr*, __U__IPSItemPropertySeq);
void __read(::IceInternal::BasicStream*, IPSItemPropertySeq&, __U__IPSItemPropertySeq);

typedef ::std::map< ::Ice::Int, ::InfoProcess::PROPERTYDESCPtr> PropertyDescDict;

class __U__PropertyDescDict { };
void __write(::IceInternal::BasicStream*, const PropertyDescDict&, __U__PropertyDescDict);
void __read(::IceInternal::BasicStream*, PropertyDescDict&, __U__PropertyDescDict);

typedef ::std::vector< ::InfoProcess::IPSItemStatePtr> IPSItemStateSeq;

class __U__IPSItemStateSeq { };
void __write(::IceInternal::BasicStream*, const ::InfoProcess::IPSItemStatePtr*, const ::InfoProcess::IPSItemStatePtr*, __U__IPSItemStateSeq);
void __read(::IceInternal::BasicStream*, IPSItemStateSeq&, __U__IPSItemStateSeq);

}

namespace IceProxy
{

namespace InfoProcess
{

class IPSObject : virtual public ::IceProxy::Ice::Object
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSItemDef : virtual public ::IceProxy::InfoProcess::IPSObject
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSItemProperty : virtual public ::IceProxy::InfoProcess::IPSObject
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class PROPERTYDESC : virtual public ::IceProxy::InfoProcess::IPSObject
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSItemState : virtual public ::IceProxy::InfoProcess::IPSObject
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

}

}

namespace IceDelegate
{

namespace InfoProcess
{

class IPSObject : virtual public ::IceDelegate::Ice::Object
{
public:
};

class IPSItemDef : virtual public ::IceDelegate::InfoProcess::IPSObject
{
public:
};

class IPSItemProperty : virtual public ::IceDelegate::InfoProcess::IPSObject
{
public:
};

class PROPERTYDESC : virtual public ::IceDelegate::InfoProcess::IPSObject
{
public:
};

class IPSItemState : virtual public ::IceDelegate::InfoProcess::IPSObject
{
public:
};

}

}

namespace IceDelegateM
{

namespace InfoProcess
{

class IPSObject : virtual public ::IceDelegate::InfoProcess::IPSObject,
		  virtual public ::IceDelegateM::Ice::Object
{
public:
};

class IPSItemDef : virtual public ::IceDelegate::InfoProcess::IPSItemDef,
		   virtual public ::IceDelegateM::InfoProcess::IPSObject
{
public:
};

class IPSItemProperty : virtual public ::IceDelegate::InfoProcess::IPSItemProperty,
			virtual public ::IceDelegateM::InfoProcess::IPSObject
{
public:
};

class PROPERTYDESC : virtual public ::IceDelegate::InfoProcess::PROPERTYDESC,
		     virtual public ::IceDelegateM::InfoProcess::IPSObject
{
public:
};

class IPSItemState : virtual public ::IceDelegate::InfoProcess::IPSItemState,
		     virtual public ::IceDelegateM::InfoProcess::IPSObject
{
public:
};

}

}

namespace IceDelegateD
{

namespace InfoProcess
{

class IPSObject : virtual public ::IceDelegate::InfoProcess::IPSObject,
		  virtual public ::IceDelegateD::Ice::Object
{
public:
};

class IPSItemDef : virtual public ::IceDelegate::InfoProcess::IPSItemDef,
		   virtual public ::IceDelegateD::InfoProcess::IPSObject
{
public:
};

class IPSItemProperty : virtual public ::IceDelegate::InfoProcess::IPSItemProperty,
			virtual public ::IceDelegateD::InfoProcess::IPSObject
{
public:
};

class PROPERTYDESC : virtual public ::IceDelegate::InfoProcess::PROPERTYDESC,
		     virtual public ::IceDelegateD::InfoProcess::IPSObject
{
public:
};

class IPSItemState : virtual public ::IceDelegate::InfoProcess::IPSItemState,
		     virtual public ::IceDelegateD::InfoProcess::IPSObject
{
public:
};

}

}

namespace InfoProcess
{

class IPSObject : virtual public ::Ice::Object
{
public:

    typedef IPSObjectPrx ProxyType;
    typedef IPSObjectPtr PointerType;
    
    IPSObject() {}
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();
};

static ::InfoProcess::IPSObject __IPSObject_init;

void __patch__IPSObjectPtr(void*, ::Ice::ObjectPtr&);

class IPSItemDef : virtual public ::InfoProcess::IPSObject
{
public:

    typedef IPSItemDefPrx ProxyType;
    typedef IPSItemDefPtr PointerType;
    
    IPSItemDef() {}
    IPSItemDef(const ::std::string&, const ::std::string&, bool, const ::InfoProcess::VariantPtr&, ::InfoProcess::VARTYPE);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void __incRef();
    virtual void __decRef();
    virtual void __addObject(::IceInternal::GCCountMap&);
    virtual bool __usesClasses();
    virtual void __gcReachable(::IceInternal::GCCountMap&) const;
    virtual void __gcClear();
    ::std::string szItemID;
    ::std::string szDispName;
    bool bActive;
    ::InfoProcess::VariantPtr vValue;
    ::InfoProcess::VARTYPE vtRequestedDataType;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();
};

void __patch__IPSItemDefPtr(void*, ::Ice::ObjectPtr&);

class IPSItemProperty : virtual public ::InfoProcess::IPSObject
{
public:

    typedef IPSItemPropertyPrx ProxyType;
    typedef IPSItemPropertyPtr PointerType;
    
    IPSItemProperty() {}
    IPSItemProperty(::InfoProcess::VARTYPE, ::Ice::Int, const ::std::string&, const ::std::string&, const ::InfoProcess::VariantPtr&);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void __incRef();
    virtual void __decRef();
    virtual void __addObject(::IceInternal::GCCountMap&);
    virtual bool __usesClasses();
    virtual void __gcReachable(::IceInternal::GCCountMap&) const;
    virtual void __gcClear();
    ::InfoProcess::VARTYPE vtDataType;
    ::Ice::Int nPropertyID;
    ::std::string szItemID;
    ::std::string szDescription;
    ::InfoProcess::VariantPtr vValue;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();
};

void __patch__IPSItemPropertyPtr(void*, ::Ice::ObjectPtr&);

class PROPERTYDESC : virtual public ::InfoProcess::IPSObject
{
public:

    typedef PROPERTYDESCPrx ProxyType;
    typedef PROPERTYDESCPtr PointerType;
    
    PROPERTYDESC() {}
    PROPERTYDESC(const ::std::string&, ::InfoProcess::VARTYPE);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::std::string Desc;
    ::InfoProcess::VARTYPE Type;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();
};

void __patch__PROPERTYDESCPtr(void*, ::Ice::ObjectPtr&);

class IPSItemState : virtual public ::InfoProcess::IPSObject
{
public:

    typedef IPSItemStatePrx ProxyType;
    typedef IPSItemStatePtr PointerType;
    
    IPSItemState() {}
    IPSItemState(const ::std::string&, ::Ice::Long, ::Ice::Int, const ::InfoProcess::VariantPtr&);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void __incRef();
    virtual void __decRef();
    virtual void __addObject(::IceInternal::GCCountMap&);
    virtual bool __usesClasses();
    virtual void __gcReachable(::IceInternal::GCCountMap&) const;
    virtual void __gcClear();
    ::std::string szItemID;
    ::Ice::Long lTimeStamp;
    ::Ice::Int nQuality;
    ::InfoProcess::VariantPtr vDataValue;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();
};

void __patch__IPSItemStatePtr(void*, ::Ice::ObjectPtr&);

}

#endif
