// **********************************************************************
//
// Copyright (c) 2003-2006 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.1.0
// Generated from file `IPSServer.ice'

#ifndef __IPSServer_h__
#define __IPSServer_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/OutgoingAsync.h>
#include <Ice/Incoming.h>
#include <Ice/IncomingAsync.h>
#include <Ice/Direct.h>
#include <Ice/UserExceptionFactory.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>
#include <IPSVariant.h>
#include <IPSItem.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 301
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

namespace IceProxy
{

namespace InfoProcess
{

class IPSEIDSet;
bool operator==(const IPSEIDSet&, const IPSEIDSet&);
bool operator!=(const IPSEIDSet&, const IPSEIDSet&);
bool operator<(const IPSEIDSet&, const IPSEIDSet&);
bool operator<=(const IPSEIDSet&, const IPSEIDSet&);
bool operator>(const IPSEIDSet&, const IPSEIDSet&);
bool operator>=(const IPSEIDSet&, const IPSEIDSet&);

class IPSAlarmItem;
bool operator==(const IPSAlarmItem&, const IPSAlarmItem&);
bool operator!=(const IPSAlarmItem&, const IPSAlarmItem&);
bool operator<(const IPSAlarmItem&, const IPSAlarmItem&);
bool operator<=(const IPSAlarmItem&, const IPSAlarmItem&);
bool operator>(const IPSAlarmItem&, const IPSAlarmItem&);
bool operator>=(const IPSAlarmItem&, const IPSAlarmItem&);

class IPSBrowseElement;
bool operator==(const IPSBrowseElement&, const IPSBrowseElement&);
bool operator!=(const IPSBrowseElement&, const IPSBrowseElement&);
bool operator<(const IPSBrowseElement&, const IPSBrowseElement&);
bool operator<=(const IPSBrowseElement&, const IPSBrowseElement&);
bool operator>(const IPSBrowseElement&, const IPSBrowseElement&);
bool operator>=(const IPSBrowseElement&, const IPSBrowseElement&);

class IPSBackupLogic;
bool operator==(const IPSBackupLogic&, const IPSBackupLogic&);
bool operator!=(const IPSBackupLogic&, const IPSBackupLogic&);
bool operator<(const IPSBackupLogic&, const IPSBackupLogic&);
bool operator<=(const IPSBackupLogic&, const IPSBackupLogic&);
bool operator>(const IPSBackupLogic&, const IPSBackupLogic&);
bool operator>=(const IPSBackupLogic&, const IPSBackupLogic&);

class Agent;
bool operator==(const Agent&, const Agent&);
bool operator!=(const Agent&, const Agent&);
bool operator<(const Agent&, const Agent&);
bool operator<=(const Agent&, const Agent&);
bool operator>(const Agent&, const Agent&);
bool operator>=(const Agent&, const Agent&);

class IPSInterface;
bool operator==(const IPSInterface&, const IPSInterface&);
bool operator!=(const IPSInterface&, const IPSInterface&);
bool operator<(const IPSInterface&, const IPSInterface&);
bool operator<=(const IPSInterface&, const IPSInterface&);
bool operator>(const IPSInterface&, const IPSInterface&);
bool operator>=(const IPSInterface&, const IPSInterface&);

class IPSServer;
bool operator==(const IPSServer&, const IPSServer&);
bool operator!=(const IPSServer&, const IPSServer&);
bool operator<(const IPSServer&, const IPSServer&);
bool operator<=(const IPSServer&, const IPSServer&);
bool operator>(const IPSServer&, const IPSServer&);
bool operator>=(const IPSServer&, const IPSServer&);

class IPSBackupLogicMgt;
bool operator==(const IPSBackupLogicMgt&, const IPSBackupLogicMgt&);
bool operator!=(const IPSBackupLogicMgt&, const IPSBackupLogicMgt&);
bool operator<(const IPSBackupLogicMgt&, const IPSBackupLogicMgt&);
bool operator<=(const IPSBackupLogicMgt&, const IPSBackupLogicMgt&);
bool operator>(const IPSBackupLogicMgt&, const IPSBackupLogicMgt&);
bool operator>=(const IPSBackupLogicMgt&, const IPSBackupLogicMgt&);

class IPSItemStateMgt;
bool operator==(const IPSItemStateMgt&, const IPSItemStateMgt&);
bool operator!=(const IPSItemStateMgt&, const IPSItemStateMgt&);
bool operator<(const IPSItemStateMgt&, const IPSItemStateMgt&);
bool operator<=(const IPSItemStateMgt&, const IPSItemStateMgt&);
bool operator>(const IPSItemStateMgt&, const IPSItemStateMgt&);
bool operator>=(const IPSItemStateMgt&, const IPSItemStateMgt&);

class IPSItemMgt;
bool operator==(const IPSItemMgt&, const IPSItemMgt&);
bool operator!=(const IPSItemMgt&, const IPSItemMgt&);
bool operator<(const IPSItemMgt&, const IPSItemMgt&);
bool operator<=(const IPSItemMgt&, const IPSItemMgt&);
bool operator>(const IPSItemMgt&, const IPSItemMgt&);
bool operator>=(const IPSItemMgt&, const IPSItemMgt&);

class IPSSysStateMng;
bool operator==(const IPSSysStateMng&, const IPSSysStateMng&);
bool operator!=(const IPSSysStateMng&, const IPSSysStateMng&);
bool operator<(const IPSSysStateMng&, const IPSSysStateMng&);
bool operator<=(const IPSSysStateMng&, const IPSSysStateMng&);
bool operator>(const IPSSysStateMng&, const IPSSysStateMng&);
bool operator>=(const IPSSysStateMng&, const IPSSysStateMng&);

class IPSItemPropertyMgt;
bool operator==(const IPSItemPropertyMgt&, const IPSItemPropertyMgt&);
bool operator!=(const IPSItemPropertyMgt&, const IPSItemPropertyMgt&);
bool operator<(const IPSItemPropertyMgt&, const IPSItemPropertyMgt&);
bool operator<=(const IPSItemPropertyMgt&, const IPSItemPropertyMgt&);
bool operator>(const IPSItemPropertyMgt&, const IPSItemPropertyMgt&);
bool operator>=(const IPSItemPropertyMgt&, const IPSItemPropertyMgt&);

class IPSBrowser;
bool operator==(const IPSBrowser&, const IPSBrowser&);
bool operator!=(const IPSBrowser&, const IPSBrowser&);
bool operator<(const IPSBrowser&, const IPSBrowser&);
bool operator<=(const IPSBrowser&, const IPSBrowser&);
bool operator>(const IPSBrowser&, const IPSBrowser&);
bool operator>=(const IPSBrowser&, const IPSBrowser&);

class IPSAlarmMng;
bool operator==(const IPSAlarmMng&, const IPSAlarmMng&);
bool operator!=(const IPSAlarmMng&, const IPSAlarmMng&);
bool operator<(const IPSAlarmMng&, const IPSAlarmMng&);
bool operator<=(const IPSAlarmMng&, const IPSAlarmMng&);
bool operator>(const IPSAlarmMng&, const IPSAlarmMng&);
bool operator>=(const IPSAlarmMng&, const IPSAlarmMng&);

class IPSLoginMng;
bool operator==(const IPSLoginMng&, const IPSLoginMng&);
bool operator!=(const IPSLoginMng&, const IPSLoginMng&);
bool operator<(const IPSLoginMng&, const IPSLoginMng&);
bool operator<=(const IPSLoginMng&, const IPSLoginMng&);
bool operator>(const IPSLoginMng&, const IPSLoginMng&);
bool operator>=(const IPSLoginMng&, const IPSLoginMng&);

class IPSControlCmdMng;
bool operator==(const IPSControlCmdMng&, const IPSControlCmdMng&);
bool operator!=(const IPSControlCmdMng&, const IPSControlCmdMng&);
bool operator<(const IPSControlCmdMng&, const IPSControlCmdMng&);
bool operator<=(const IPSControlCmdMng&, const IPSControlCmdMng&);
bool operator>(const IPSControlCmdMng&, const IPSControlCmdMng&);
bool operator>=(const IPSControlCmdMng&, const IPSControlCmdMng&);

class IPSSupportMng;
bool operator==(const IPSSupportMng&, const IPSSupportMng&);
bool operator!=(const IPSSupportMng&, const IPSSupportMng&);
bool operator<(const IPSSupportMng&, const IPSSupportMng&);
bool operator<=(const IPSSupportMng&, const IPSSupportMng&);
bool operator>(const IPSSupportMng&, const IPSSupportMng&);
bool operator>=(const IPSSupportMng&, const IPSSupportMng&);

class IPSStatePublisher;
bool operator==(const IPSStatePublisher&, const IPSStatePublisher&);
bool operator!=(const IPSStatePublisher&, const IPSStatePublisher&);
bool operator<(const IPSStatePublisher&, const IPSStatePublisher&);
bool operator<=(const IPSStatePublisher&, const IPSStatePublisher&);
bool operator>(const IPSStatePublisher&, const IPSStatePublisher&);
bool operator>=(const IPSStatePublisher&, const IPSStatePublisher&);

class IPSAlarmPublisher;
bool operator==(const IPSAlarmPublisher&, const IPSAlarmPublisher&);
bool operator!=(const IPSAlarmPublisher&, const IPSAlarmPublisher&);
bool operator<(const IPSAlarmPublisher&, const IPSAlarmPublisher&);
bool operator<=(const IPSAlarmPublisher&, const IPSAlarmPublisher&);
bool operator>(const IPSAlarmPublisher&, const IPSAlarmPublisher&);
bool operator>=(const IPSAlarmPublisher&, const IPSAlarmPublisher&);

class IPSItemDefPublisher;
bool operator==(const IPSItemDefPublisher&, const IPSItemDefPublisher&);
bool operator!=(const IPSItemDefPublisher&, const IPSItemDefPublisher&);
bool operator<(const IPSItemDefPublisher&, const IPSItemDefPublisher&);
bool operator<=(const IPSItemDefPublisher&, const IPSItemDefPublisher&);
bool operator>(const IPSItemDefPublisher&, const IPSItemDefPublisher&);
bool operator>=(const IPSItemDefPublisher&, const IPSItemDefPublisher&);

class IPSItemPropPublisher;
bool operator==(const IPSItemPropPublisher&, const IPSItemPropPublisher&);
bool operator!=(const IPSItemPropPublisher&, const IPSItemPropPublisher&);
bool operator<(const IPSItemPropPublisher&, const IPSItemPropPublisher&);
bool operator<=(const IPSItemPropPublisher&, const IPSItemPropPublisher&);
bool operator>(const IPSItemPropPublisher&, const IPSItemPropPublisher&);
bool operator>=(const IPSItemPropPublisher&, const IPSItemPropPublisher&);

class IPSObjPublisher;
bool operator==(const IPSObjPublisher&, const IPSObjPublisher&);
bool operator!=(const IPSObjPublisher&, const IPSObjPublisher&);
bool operator<(const IPSObjPublisher&, const IPSObjPublisher&);
bool operator<=(const IPSObjPublisher&, const IPSObjPublisher&);
bool operator>(const IPSObjPublisher&, const IPSObjPublisher&);
bool operator>=(const IPSObjPublisher&, const IPSObjPublisher&);

class IPSBackupFile;
bool operator==(const IPSBackupFile&, const IPSBackupFile&);
bool operator!=(const IPSBackupFile&, const IPSBackupFile&);
bool operator<(const IPSBackupFile&, const IPSBackupFile&);
bool operator<=(const IPSBackupFile&, const IPSBackupFile&);
bool operator>(const IPSBackupFile&, const IPSBackupFile&);
bool operator>=(const IPSBackupFile&, const IPSBackupFile&);

class IPSBackupMgt;
bool operator==(const IPSBackupMgt&, const IPSBackupMgt&);
bool operator!=(const IPSBackupMgt&, const IPSBackupMgt&);
bool operator<(const IPSBackupMgt&, const IPSBackupMgt&);
bool operator<=(const IPSBackupMgt&, const IPSBackupMgt&);
bool operator>(const IPSBackupMgt&, const IPSBackupMgt&);
bool operator>=(const IPSBackupMgt&, const IPSBackupMgt&);

class IPSRestoreMgt;
bool operator==(const IPSRestoreMgt&, const IPSRestoreMgt&);
bool operator!=(const IPSRestoreMgt&, const IPSRestoreMgt&);
bool operator<(const IPSRestoreMgt&, const IPSRestoreMgt&);
bool operator<=(const IPSRestoreMgt&, const IPSRestoreMgt&);
bool operator>(const IPSRestoreMgt&, const IPSRestoreMgt&);
bool operator>=(const IPSRestoreMgt&, const IPSRestoreMgt&);

class IPSDataIO;
bool operator==(const IPSDataIO&, const IPSDataIO&);
bool operator!=(const IPSDataIO&, const IPSDataIO&);
bool operator<(const IPSDataIO&, const IPSDataIO&);
bool operator<=(const IPSDataIO&, const IPSDataIO&);
bool operator>(const IPSDataIO&, const IPSDataIO&);
bool operator>=(const IPSDataIO&, const IPSDataIO&);

}

}

namespace InfoProcess
{

class IPSEIDSet;
bool operator==(const IPSEIDSet&, const IPSEIDSet&);
bool operator!=(const IPSEIDSet&, const IPSEIDSet&);
bool operator<(const IPSEIDSet&, const IPSEIDSet&);
bool operator<=(const IPSEIDSet&, const IPSEIDSet&);
bool operator>(const IPSEIDSet&, const IPSEIDSet&);
bool operator>=(const IPSEIDSet&, const IPSEIDSet&);

class IPSAlarmItem;
bool operator==(const IPSAlarmItem&, const IPSAlarmItem&);
bool operator!=(const IPSAlarmItem&, const IPSAlarmItem&);
bool operator<(const IPSAlarmItem&, const IPSAlarmItem&);
bool operator<=(const IPSAlarmItem&, const IPSAlarmItem&);
bool operator>(const IPSAlarmItem&, const IPSAlarmItem&);
bool operator>=(const IPSAlarmItem&, const IPSAlarmItem&);

class IPSBrowseElement;
bool operator==(const IPSBrowseElement&, const IPSBrowseElement&);
bool operator!=(const IPSBrowseElement&, const IPSBrowseElement&);
bool operator<(const IPSBrowseElement&, const IPSBrowseElement&);
bool operator<=(const IPSBrowseElement&, const IPSBrowseElement&);
bool operator>(const IPSBrowseElement&, const IPSBrowseElement&);
bool operator>=(const IPSBrowseElement&, const IPSBrowseElement&);

class IPSBackupLogic;
bool operator==(const IPSBackupLogic&, const IPSBackupLogic&);
bool operator!=(const IPSBackupLogic&, const IPSBackupLogic&);
bool operator<(const IPSBackupLogic&, const IPSBackupLogic&);
bool operator<=(const IPSBackupLogic&, const IPSBackupLogic&);
bool operator>(const IPSBackupLogic&, const IPSBackupLogic&);
bool operator>=(const IPSBackupLogic&, const IPSBackupLogic&);

class Agent;
bool operator==(const Agent&, const Agent&);
bool operator!=(const Agent&, const Agent&);
bool operator<(const Agent&, const Agent&);
bool operator<=(const Agent&, const Agent&);
bool operator>(const Agent&, const Agent&);
bool operator>=(const Agent&, const Agent&);

class IPSInterface;
bool operator==(const IPSInterface&, const IPSInterface&);
bool operator!=(const IPSInterface&, const IPSInterface&);
bool operator<(const IPSInterface&, const IPSInterface&);
bool operator<=(const IPSInterface&, const IPSInterface&);
bool operator>(const IPSInterface&, const IPSInterface&);
bool operator>=(const IPSInterface&, const IPSInterface&);

class IPSServer;
bool operator==(const IPSServer&, const IPSServer&);
bool operator!=(const IPSServer&, const IPSServer&);
bool operator<(const IPSServer&, const IPSServer&);
bool operator<=(const IPSServer&, const IPSServer&);
bool operator>(const IPSServer&, const IPSServer&);
bool operator>=(const IPSServer&, const IPSServer&);

class IPSBackupLogicMgt;
bool operator==(const IPSBackupLogicMgt&, const IPSBackupLogicMgt&);
bool operator!=(const IPSBackupLogicMgt&, const IPSBackupLogicMgt&);
bool operator<(const IPSBackupLogicMgt&, const IPSBackupLogicMgt&);
bool operator<=(const IPSBackupLogicMgt&, const IPSBackupLogicMgt&);
bool operator>(const IPSBackupLogicMgt&, const IPSBackupLogicMgt&);
bool operator>=(const IPSBackupLogicMgt&, const IPSBackupLogicMgt&);

class IPSItemStateMgt;
bool operator==(const IPSItemStateMgt&, const IPSItemStateMgt&);
bool operator!=(const IPSItemStateMgt&, const IPSItemStateMgt&);
bool operator<(const IPSItemStateMgt&, const IPSItemStateMgt&);
bool operator<=(const IPSItemStateMgt&, const IPSItemStateMgt&);
bool operator>(const IPSItemStateMgt&, const IPSItemStateMgt&);
bool operator>=(const IPSItemStateMgt&, const IPSItemStateMgt&);

class IPSItemMgt;
bool operator==(const IPSItemMgt&, const IPSItemMgt&);
bool operator!=(const IPSItemMgt&, const IPSItemMgt&);
bool operator<(const IPSItemMgt&, const IPSItemMgt&);
bool operator<=(const IPSItemMgt&, const IPSItemMgt&);
bool operator>(const IPSItemMgt&, const IPSItemMgt&);
bool operator>=(const IPSItemMgt&, const IPSItemMgt&);

class IPSSysStateMng;
bool operator==(const IPSSysStateMng&, const IPSSysStateMng&);
bool operator!=(const IPSSysStateMng&, const IPSSysStateMng&);
bool operator<(const IPSSysStateMng&, const IPSSysStateMng&);
bool operator<=(const IPSSysStateMng&, const IPSSysStateMng&);
bool operator>(const IPSSysStateMng&, const IPSSysStateMng&);
bool operator>=(const IPSSysStateMng&, const IPSSysStateMng&);

class IPSItemPropertyMgt;
bool operator==(const IPSItemPropertyMgt&, const IPSItemPropertyMgt&);
bool operator!=(const IPSItemPropertyMgt&, const IPSItemPropertyMgt&);
bool operator<(const IPSItemPropertyMgt&, const IPSItemPropertyMgt&);
bool operator<=(const IPSItemPropertyMgt&, const IPSItemPropertyMgt&);
bool operator>(const IPSItemPropertyMgt&, const IPSItemPropertyMgt&);
bool operator>=(const IPSItemPropertyMgt&, const IPSItemPropertyMgt&);

class IPSBrowser;
bool operator==(const IPSBrowser&, const IPSBrowser&);
bool operator!=(const IPSBrowser&, const IPSBrowser&);
bool operator<(const IPSBrowser&, const IPSBrowser&);
bool operator<=(const IPSBrowser&, const IPSBrowser&);
bool operator>(const IPSBrowser&, const IPSBrowser&);
bool operator>=(const IPSBrowser&, const IPSBrowser&);

class IPSAlarmMng;
bool operator==(const IPSAlarmMng&, const IPSAlarmMng&);
bool operator!=(const IPSAlarmMng&, const IPSAlarmMng&);
bool operator<(const IPSAlarmMng&, const IPSAlarmMng&);
bool operator<=(const IPSAlarmMng&, const IPSAlarmMng&);
bool operator>(const IPSAlarmMng&, const IPSAlarmMng&);
bool operator>=(const IPSAlarmMng&, const IPSAlarmMng&);

class IPSLoginMng;
bool operator==(const IPSLoginMng&, const IPSLoginMng&);
bool operator!=(const IPSLoginMng&, const IPSLoginMng&);
bool operator<(const IPSLoginMng&, const IPSLoginMng&);
bool operator<=(const IPSLoginMng&, const IPSLoginMng&);
bool operator>(const IPSLoginMng&, const IPSLoginMng&);
bool operator>=(const IPSLoginMng&, const IPSLoginMng&);

class IPSControlCmdMng;
bool operator==(const IPSControlCmdMng&, const IPSControlCmdMng&);
bool operator!=(const IPSControlCmdMng&, const IPSControlCmdMng&);
bool operator<(const IPSControlCmdMng&, const IPSControlCmdMng&);
bool operator<=(const IPSControlCmdMng&, const IPSControlCmdMng&);
bool operator>(const IPSControlCmdMng&, const IPSControlCmdMng&);
bool operator>=(const IPSControlCmdMng&, const IPSControlCmdMng&);

class IPSSupportMng;
bool operator==(const IPSSupportMng&, const IPSSupportMng&);
bool operator!=(const IPSSupportMng&, const IPSSupportMng&);
bool operator<(const IPSSupportMng&, const IPSSupportMng&);
bool operator<=(const IPSSupportMng&, const IPSSupportMng&);
bool operator>(const IPSSupportMng&, const IPSSupportMng&);
bool operator>=(const IPSSupportMng&, const IPSSupportMng&);

class IPSStatePublisher;
bool operator==(const IPSStatePublisher&, const IPSStatePublisher&);
bool operator!=(const IPSStatePublisher&, const IPSStatePublisher&);
bool operator<(const IPSStatePublisher&, const IPSStatePublisher&);
bool operator<=(const IPSStatePublisher&, const IPSStatePublisher&);
bool operator>(const IPSStatePublisher&, const IPSStatePublisher&);
bool operator>=(const IPSStatePublisher&, const IPSStatePublisher&);

class IPSAlarmPublisher;
bool operator==(const IPSAlarmPublisher&, const IPSAlarmPublisher&);
bool operator!=(const IPSAlarmPublisher&, const IPSAlarmPublisher&);
bool operator<(const IPSAlarmPublisher&, const IPSAlarmPublisher&);
bool operator<=(const IPSAlarmPublisher&, const IPSAlarmPublisher&);
bool operator>(const IPSAlarmPublisher&, const IPSAlarmPublisher&);
bool operator>=(const IPSAlarmPublisher&, const IPSAlarmPublisher&);

class IPSItemDefPublisher;
bool operator==(const IPSItemDefPublisher&, const IPSItemDefPublisher&);
bool operator!=(const IPSItemDefPublisher&, const IPSItemDefPublisher&);
bool operator<(const IPSItemDefPublisher&, const IPSItemDefPublisher&);
bool operator<=(const IPSItemDefPublisher&, const IPSItemDefPublisher&);
bool operator>(const IPSItemDefPublisher&, const IPSItemDefPublisher&);
bool operator>=(const IPSItemDefPublisher&, const IPSItemDefPublisher&);

class IPSItemPropPublisher;
bool operator==(const IPSItemPropPublisher&, const IPSItemPropPublisher&);
bool operator!=(const IPSItemPropPublisher&, const IPSItemPropPublisher&);
bool operator<(const IPSItemPropPublisher&, const IPSItemPropPublisher&);
bool operator<=(const IPSItemPropPublisher&, const IPSItemPropPublisher&);
bool operator>(const IPSItemPropPublisher&, const IPSItemPropPublisher&);
bool operator>=(const IPSItemPropPublisher&, const IPSItemPropPublisher&);

class IPSObjPublisher;
bool operator==(const IPSObjPublisher&, const IPSObjPublisher&);
bool operator!=(const IPSObjPublisher&, const IPSObjPublisher&);
bool operator<(const IPSObjPublisher&, const IPSObjPublisher&);
bool operator<=(const IPSObjPublisher&, const IPSObjPublisher&);
bool operator>(const IPSObjPublisher&, const IPSObjPublisher&);
bool operator>=(const IPSObjPublisher&, const IPSObjPublisher&);

class IPSBackupFile;
bool operator==(const IPSBackupFile&, const IPSBackupFile&);
bool operator!=(const IPSBackupFile&, const IPSBackupFile&);
bool operator<(const IPSBackupFile&, const IPSBackupFile&);
bool operator<=(const IPSBackupFile&, const IPSBackupFile&);
bool operator>(const IPSBackupFile&, const IPSBackupFile&);
bool operator>=(const IPSBackupFile&, const IPSBackupFile&);

class IPSBackupMgt;
bool operator==(const IPSBackupMgt&, const IPSBackupMgt&);
bool operator!=(const IPSBackupMgt&, const IPSBackupMgt&);
bool operator<(const IPSBackupMgt&, const IPSBackupMgt&);
bool operator<=(const IPSBackupMgt&, const IPSBackupMgt&);
bool operator>(const IPSBackupMgt&, const IPSBackupMgt&);
bool operator>=(const IPSBackupMgt&, const IPSBackupMgt&);

class IPSRestoreMgt;
bool operator==(const IPSRestoreMgt&, const IPSRestoreMgt&);
bool operator!=(const IPSRestoreMgt&, const IPSRestoreMgt&);
bool operator<(const IPSRestoreMgt&, const IPSRestoreMgt&);
bool operator<=(const IPSRestoreMgt&, const IPSRestoreMgt&);
bool operator>(const IPSRestoreMgt&, const IPSRestoreMgt&);
bool operator>=(const IPSRestoreMgt&, const IPSRestoreMgt&);

class IPSDataIO;
bool operator==(const IPSDataIO&, const IPSDataIO&);
bool operator!=(const IPSDataIO&, const IPSDataIO&);
bool operator<(const IPSDataIO&, const IPSDataIO&);
bool operator<=(const IPSDataIO&, const IPSDataIO&);
bool operator>(const IPSDataIO&, const IPSDataIO&);
bool operator>=(const IPSDataIO&, const IPSDataIO&);

}

namespace IceInternal
{

void incRef(::InfoProcess::IPSEIDSet*);
void decRef(::InfoProcess::IPSEIDSet*);

void incRef(::IceProxy::InfoProcess::IPSEIDSet*);
void decRef(::IceProxy::InfoProcess::IPSEIDSet*);

void incRef(::InfoProcess::IPSAlarmItem*);
void decRef(::InfoProcess::IPSAlarmItem*);

void incRef(::IceProxy::InfoProcess::IPSAlarmItem*);
void decRef(::IceProxy::InfoProcess::IPSAlarmItem*);

void incRef(::InfoProcess::IPSBrowseElement*);
void decRef(::InfoProcess::IPSBrowseElement*);

void incRef(::IceProxy::InfoProcess::IPSBrowseElement*);
void decRef(::IceProxy::InfoProcess::IPSBrowseElement*);

void incRef(::InfoProcess::IPSBackupLogic*);
void decRef(::InfoProcess::IPSBackupLogic*);

void incRef(::IceProxy::InfoProcess::IPSBackupLogic*);
void decRef(::IceProxy::InfoProcess::IPSBackupLogic*);

void incRef(::InfoProcess::Agent*);
void decRef(::InfoProcess::Agent*);

void incRef(::IceProxy::InfoProcess::Agent*);
void decRef(::IceProxy::InfoProcess::Agent*);

void incRef(::InfoProcess::IPSInterface*);
void decRef(::InfoProcess::IPSInterface*);

void incRef(::IceProxy::InfoProcess::IPSInterface*);
void decRef(::IceProxy::InfoProcess::IPSInterface*);

void incRef(::InfoProcess::IPSServer*);
void decRef(::InfoProcess::IPSServer*);

void incRef(::IceProxy::InfoProcess::IPSServer*);
void decRef(::IceProxy::InfoProcess::IPSServer*);

void incRef(::InfoProcess::IPSBackupLogicMgt*);
void decRef(::InfoProcess::IPSBackupLogicMgt*);

void incRef(::IceProxy::InfoProcess::IPSBackupLogicMgt*);
void decRef(::IceProxy::InfoProcess::IPSBackupLogicMgt*);

void incRef(::InfoProcess::IPSItemStateMgt*);
void decRef(::InfoProcess::IPSItemStateMgt*);

void incRef(::IceProxy::InfoProcess::IPSItemStateMgt*);
void decRef(::IceProxy::InfoProcess::IPSItemStateMgt*);

void incRef(::InfoProcess::IPSItemMgt*);
void decRef(::InfoProcess::IPSItemMgt*);

void incRef(::IceProxy::InfoProcess::IPSItemMgt*);
void decRef(::IceProxy::InfoProcess::IPSItemMgt*);

void incRef(::InfoProcess::IPSSysStateMng*);
void decRef(::InfoProcess::IPSSysStateMng*);

void incRef(::IceProxy::InfoProcess::IPSSysStateMng*);
void decRef(::IceProxy::InfoProcess::IPSSysStateMng*);

void incRef(::InfoProcess::IPSItemPropertyMgt*);
void decRef(::InfoProcess::IPSItemPropertyMgt*);

void incRef(::IceProxy::InfoProcess::IPSItemPropertyMgt*);
void decRef(::IceProxy::InfoProcess::IPSItemPropertyMgt*);

void incRef(::InfoProcess::IPSBrowser*);
void decRef(::InfoProcess::IPSBrowser*);

void incRef(::IceProxy::InfoProcess::IPSBrowser*);
void decRef(::IceProxy::InfoProcess::IPSBrowser*);

void incRef(::InfoProcess::IPSAlarmMng*);
void decRef(::InfoProcess::IPSAlarmMng*);

void incRef(::IceProxy::InfoProcess::IPSAlarmMng*);
void decRef(::IceProxy::InfoProcess::IPSAlarmMng*);

void incRef(::InfoProcess::IPSLoginMng*);
void decRef(::InfoProcess::IPSLoginMng*);

void incRef(::IceProxy::InfoProcess::IPSLoginMng*);
void decRef(::IceProxy::InfoProcess::IPSLoginMng*);

void incRef(::InfoProcess::IPSControlCmdMng*);
void decRef(::InfoProcess::IPSControlCmdMng*);

void incRef(::IceProxy::InfoProcess::IPSControlCmdMng*);
void decRef(::IceProxy::InfoProcess::IPSControlCmdMng*);

void incRef(::InfoProcess::IPSSupportMng*);
void decRef(::InfoProcess::IPSSupportMng*);

void incRef(::IceProxy::InfoProcess::IPSSupportMng*);
void decRef(::IceProxy::InfoProcess::IPSSupportMng*);

void incRef(::InfoProcess::IPSStatePublisher*);
void decRef(::InfoProcess::IPSStatePublisher*);

void incRef(::IceProxy::InfoProcess::IPSStatePublisher*);
void decRef(::IceProxy::InfoProcess::IPSStatePublisher*);

void incRef(::InfoProcess::IPSAlarmPublisher*);
void decRef(::InfoProcess::IPSAlarmPublisher*);

void incRef(::IceProxy::InfoProcess::IPSAlarmPublisher*);
void decRef(::IceProxy::InfoProcess::IPSAlarmPublisher*);

void incRef(::InfoProcess::IPSItemDefPublisher*);
void decRef(::InfoProcess::IPSItemDefPublisher*);

void incRef(::IceProxy::InfoProcess::IPSItemDefPublisher*);
void decRef(::IceProxy::InfoProcess::IPSItemDefPublisher*);

void incRef(::InfoProcess::IPSItemPropPublisher*);
void decRef(::InfoProcess::IPSItemPropPublisher*);

void incRef(::IceProxy::InfoProcess::IPSItemPropPublisher*);
void decRef(::IceProxy::InfoProcess::IPSItemPropPublisher*);

void incRef(::InfoProcess::IPSObjPublisher*);
void decRef(::InfoProcess::IPSObjPublisher*);

void incRef(::IceProxy::InfoProcess::IPSObjPublisher*);
void decRef(::IceProxy::InfoProcess::IPSObjPublisher*);

void incRef(::InfoProcess::IPSBackupFile*);
void decRef(::InfoProcess::IPSBackupFile*);

void incRef(::IceProxy::InfoProcess::IPSBackupFile*);
void decRef(::IceProxy::InfoProcess::IPSBackupFile*);

void incRef(::InfoProcess::IPSBackupMgt*);
void decRef(::InfoProcess::IPSBackupMgt*);

void incRef(::IceProxy::InfoProcess::IPSBackupMgt*);
void decRef(::IceProxy::InfoProcess::IPSBackupMgt*);

void incRef(::InfoProcess::IPSRestoreMgt*);
void decRef(::InfoProcess::IPSRestoreMgt*);

void incRef(::IceProxy::InfoProcess::IPSRestoreMgt*);
void decRef(::IceProxy::InfoProcess::IPSRestoreMgt*);

void incRef(::InfoProcess::IPSDataIO*);
void decRef(::InfoProcess::IPSDataIO*);

void incRef(::IceProxy::InfoProcess::IPSDataIO*);
void decRef(::IceProxy::InfoProcess::IPSDataIO*);

}

namespace InfoProcess
{

typedef ::IceInternal::Handle< ::InfoProcess::IPSEIDSet> IPSEIDSetPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSEIDSet> IPSEIDSetPrx;

void __write(::IceInternal::BasicStream*, const IPSEIDSetPrx&);
void __read(::IceInternal::BasicStream*, IPSEIDSetPrx&);
void __write(::IceInternal::BasicStream*, const IPSEIDSetPtr&);
void __patch__IPSEIDSetPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const IPSEIDSetPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const IPSEIDSetPtr&);
void __decRefUnsafe(IPSEIDSetPtr&);
void __clearHandleUnsafe(IPSEIDSetPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSAlarmItem> IPSAlarmItemPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSAlarmItem> IPSAlarmItemPrx;

void __write(::IceInternal::BasicStream*, const IPSAlarmItemPrx&);
void __read(::IceInternal::BasicStream*, IPSAlarmItemPrx&);
void __write(::IceInternal::BasicStream*, const IPSAlarmItemPtr&);
void __patch__IPSAlarmItemPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const IPSAlarmItemPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const IPSAlarmItemPtr&);
void __decRefUnsafe(IPSAlarmItemPtr&);
void __clearHandleUnsafe(IPSAlarmItemPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSBrowseElement> IPSBrowseElementPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSBrowseElement> IPSBrowseElementPrx;

void __write(::IceInternal::BasicStream*, const IPSBrowseElementPrx&);
void __read(::IceInternal::BasicStream*, IPSBrowseElementPrx&);
void __write(::IceInternal::BasicStream*, const IPSBrowseElementPtr&);
void __patch__IPSBrowseElementPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const IPSBrowseElementPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const IPSBrowseElementPtr&);
void __decRefUnsafe(IPSBrowseElementPtr&);
void __clearHandleUnsafe(IPSBrowseElementPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSBackupLogic> IPSBackupLogicPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSBackupLogic> IPSBackupLogicPrx;

void __write(::IceInternal::BasicStream*, const IPSBackupLogicPrx&);
void __read(::IceInternal::BasicStream*, IPSBackupLogicPrx&);
void __write(::IceInternal::BasicStream*, const IPSBackupLogicPtr&);
void __patch__IPSBackupLogicPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const IPSBackupLogicPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const IPSBackupLogicPtr&);
void __decRefUnsafe(IPSBackupLogicPtr&);
void __clearHandleUnsafe(IPSBackupLogicPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::Agent> AgentPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::Agent> AgentPrx;

void __write(::IceInternal::BasicStream*, const AgentPrx&);
void __read(::IceInternal::BasicStream*, AgentPrx&);
void __write(::IceInternal::BasicStream*, const AgentPtr&);
void __patch__AgentPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSInterface> IPSInterfacePtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSInterface> IPSInterfacePrx;

void __write(::IceInternal::BasicStream*, const IPSInterfacePrx&);
void __read(::IceInternal::BasicStream*, IPSInterfacePrx&);
void __write(::IceInternal::BasicStream*, const IPSInterfacePtr&);
void __patch__IPSInterfacePtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSServer> IPSServerPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSServer> IPSServerPrx;

void __write(::IceInternal::BasicStream*, const IPSServerPrx&);
void __read(::IceInternal::BasicStream*, IPSServerPrx&);
void __write(::IceInternal::BasicStream*, const IPSServerPtr&);
void __patch__IPSServerPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSBackupLogicMgt> IPSBackupLogicMgtPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSBackupLogicMgt> IPSBackupLogicMgtPrx;

void __write(::IceInternal::BasicStream*, const IPSBackupLogicMgtPrx&);
void __read(::IceInternal::BasicStream*, IPSBackupLogicMgtPrx&);
void __write(::IceInternal::BasicStream*, const IPSBackupLogicMgtPtr&);
void __patch__IPSBackupLogicMgtPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSItemStateMgt> IPSItemStateMgtPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSItemStateMgt> IPSItemStateMgtPrx;

void __write(::IceInternal::BasicStream*, const IPSItemStateMgtPrx&);
void __read(::IceInternal::BasicStream*, IPSItemStateMgtPrx&);
void __write(::IceInternal::BasicStream*, const IPSItemStateMgtPtr&);
void __patch__IPSItemStateMgtPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSItemMgt> IPSItemMgtPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSItemMgt> IPSItemMgtPrx;

void __write(::IceInternal::BasicStream*, const IPSItemMgtPrx&);
void __read(::IceInternal::BasicStream*, IPSItemMgtPrx&);
void __write(::IceInternal::BasicStream*, const IPSItemMgtPtr&);
void __patch__IPSItemMgtPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSSysStateMng> IPSSysStateMngPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSSysStateMng> IPSSysStateMngPrx;

void __write(::IceInternal::BasicStream*, const IPSSysStateMngPrx&);
void __read(::IceInternal::BasicStream*, IPSSysStateMngPrx&);
void __write(::IceInternal::BasicStream*, const IPSSysStateMngPtr&);
void __patch__IPSSysStateMngPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSItemPropertyMgt> IPSItemPropertyMgtPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSItemPropertyMgt> IPSItemPropertyMgtPrx;

void __write(::IceInternal::BasicStream*, const IPSItemPropertyMgtPrx&);
void __read(::IceInternal::BasicStream*, IPSItemPropertyMgtPrx&);
void __write(::IceInternal::BasicStream*, const IPSItemPropertyMgtPtr&);
void __patch__IPSItemPropertyMgtPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSBrowser> IPSBrowserPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSBrowser> IPSBrowserPrx;

void __write(::IceInternal::BasicStream*, const IPSBrowserPrx&);
void __read(::IceInternal::BasicStream*, IPSBrowserPrx&);
void __write(::IceInternal::BasicStream*, const IPSBrowserPtr&);
void __patch__IPSBrowserPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSAlarmMng> IPSAlarmMngPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSAlarmMng> IPSAlarmMngPrx;

void __write(::IceInternal::BasicStream*, const IPSAlarmMngPrx&);
void __read(::IceInternal::BasicStream*, IPSAlarmMngPrx&);
void __write(::IceInternal::BasicStream*, const IPSAlarmMngPtr&);
void __patch__IPSAlarmMngPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSLoginMng> IPSLoginMngPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSLoginMng> IPSLoginMngPrx;

void __write(::IceInternal::BasicStream*, const IPSLoginMngPrx&);
void __read(::IceInternal::BasicStream*, IPSLoginMngPrx&);
void __write(::IceInternal::BasicStream*, const IPSLoginMngPtr&);
void __patch__IPSLoginMngPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSControlCmdMng> IPSControlCmdMngPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSControlCmdMng> IPSControlCmdMngPrx;

void __write(::IceInternal::BasicStream*, const IPSControlCmdMngPrx&);
void __read(::IceInternal::BasicStream*, IPSControlCmdMngPrx&);
void __write(::IceInternal::BasicStream*, const IPSControlCmdMngPtr&);
void __patch__IPSControlCmdMngPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSSupportMng> IPSSupportMngPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSSupportMng> IPSSupportMngPrx;

void __write(::IceInternal::BasicStream*, const IPSSupportMngPrx&);
void __read(::IceInternal::BasicStream*, IPSSupportMngPrx&);
void __write(::IceInternal::BasicStream*, const IPSSupportMngPtr&);
void __patch__IPSSupportMngPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSStatePublisher> IPSStatePublisherPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSStatePublisher> IPSStatePublisherPrx;

void __write(::IceInternal::BasicStream*, const IPSStatePublisherPrx&);
void __read(::IceInternal::BasicStream*, IPSStatePublisherPrx&);
void __write(::IceInternal::BasicStream*, const IPSStatePublisherPtr&);
void __patch__IPSStatePublisherPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSAlarmPublisher> IPSAlarmPublisherPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSAlarmPublisher> IPSAlarmPublisherPrx;

void __write(::IceInternal::BasicStream*, const IPSAlarmPublisherPrx&);
void __read(::IceInternal::BasicStream*, IPSAlarmPublisherPrx&);
void __write(::IceInternal::BasicStream*, const IPSAlarmPublisherPtr&);
void __patch__IPSAlarmPublisherPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSItemDefPublisher> IPSItemDefPublisherPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSItemDefPublisher> IPSItemDefPublisherPrx;

void __write(::IceInternal::BasicStream*, const IPSItemDefPublisherPrx&);
void __read(::IceInternal::BasicStream*, IPSItemDefPublisherPrx&);
void __write(::IceInternal::BasicStream*, const IPSItemDefPublisherPtr&);
void __patch__IPSItemDefPublisherPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSItemPropPublisher> IPSItemPropPublisherPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSItemPropPublisher> IPSItemPropPublisherPrx;

void __write(::IceInternal::BasicStream*, const IPSItemPropPublisherPrx&);
void __read(::IceInternal::BasicStream*, IPSItemPropPublisherPrx&);
void __write(::IceInternal::BasicStream*, const IPSItemPropPublisherPtr&);
void __patch__IPSItemPropPublisherPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSObjPublisher> IPSObjPublisherPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSObjPublisher> IPSObjPublisherPrx;

void __write(::IceInternal::BasicStream*, const IPSObjPublisherPrx&);
void __read(::IceInternal::BasicStream*, IPSObjPublisherPrx&);
void __write(::IceInternal::BasicStream*, const IPSObjPublisherPtr&);
void __patch__IPSObjPublisherPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSBackupFile> IPSBackupFilePtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSBackupFile> IPSBackupFilePrx;

void __write(::IceInternal::BasicStream*, const IPSBackupFilePrx&);
void __read(::IceInternal::BasicStream*, IPSBackupFilePrx&);
void __write(::IceInternal::BasicStream*, const IPSBackupFilePtr&);
void __patch__IPSBackupFilePtr(void*, ::Ice::ObjectPtr&);

void __addObject(const IPSBackupFilePtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const IPSBackupFilePtr&);
void __decRefUnsafe(IPSBackupFilePtr&);
void __clearHandleUnsafe(IPSBackupFilePtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSBackupMgt> IPSBackupMgtPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSBackupMgt> IPSBackupMgtPrx;

void __write(::IceInternal::BasicStream*, const IPSBackupMgtPrx&);
void __read(::IceInternal::BasicStream*, IPSBackupMgtPrx&);
void __write(::IceInternal::BasicStream*, const IPSBackupMgtPtr&);
void __patch__IPSBackupMgtPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSRestoreMgt> IPSRestoreMgtPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSRestoreMgt> IPSRestoreMgtPrx;

void __write(::IceInternal::BasicStream*, const IPSRestoreMgtPrx&);
void __read(::IceInternal::BasicStream*, IPSRestoreMgtPrx&);
void __write(::IceInternal::BasicStream*, const IPSRestoreMgtPtr&);
void __patch__IPSRestoreMgtPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::IPSDataIO> IPSDataIOPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::IPSDataIO> IPSDataIOPrx;

void __write(::IceInternal::BasicStream*, const IPSDataIOPrx&);
void __read(::IceInternal::BasicStream*, IPSDataIOPrx&);
void __write(::IceInternal::BasicStream*, const IPSDataIOPtr&);
void __patch__IPSDataIOPtr(void*, ::Ice::ObjectPtr&);

}

namespace InfoProcess
{

const ::Ice::Int IPSErrorUndefined = -100;

const ::Ice::Int IPSErrorExists = -101;

const ::Ice::Int IPSErrorNotExist = -102;

const ::Ice::Int IPSErrorParentNotExist = -103;

const ::Ice::Int IPSErrorOpenDB = -104;

const ::Ice::Int IPSErrorDBExecute = -105;

const ::Ice::Int IPSErrorVariantType = -106;

class IPSException : public ::Ice::UserException
{
public:

    IPSException() {}
    explicit IPSException(const ::std::string&);

    virtual const ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    ::std::string sReason;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

static IPSException __IPSException_init;

class UndefinedException : public ::InfoProcess::IPSException
{
public:

    UndefinedException() {}
    explicit UndefinedException(const ::std::string&);

    virtual const ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class IPSLoginException : public ::InfoProcess::IPSException
{
public:

    IPSLoginException() {}
    explicit IPSLoginException(const ::std::string&);

    virtual const ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class IPSLogoutException : public ::InfoProcess::IPSException
{
public:

    IPSLogoutException() {}
    explicit IPSLogoutException(const ::std::string&);

    virtual const ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class IPSUpdateItemStateException : public ::InfoProcess::IPSException
{
public:

    IPSUpdateItemStateException() {}
    explicit IPSUpdateItemStateException(const ::std::string&);

    virtual const ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class IPSUpdateLogicException : public ::InfoProcess::IPSException
{
public:

    IPSUpdateLogicException() {}
    explicit IPSUpdateLogicException(const ::std::string&);

    virtual const ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class IPSCheckLogicValidException : public ::InfoProcess::IPSException
{
public:

    IPSCheckLogicValidException() {}
    explicit IPSCheckLogicValidException(const ::std::string&);

    virtual const ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class IPSUpdateBatchItemStatesException : public ::InfoProcess::IPSException
{
public:

    IPSUpdateBatchItemStatesException() {}
    explicit IPSUpdateBatchItemStatesException(const ::std::string&);

    virtual const ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class IPSGetAllItemStatesException : public ::InfoProcess::IPSException
{
public:

    IPSGetAllItemStatesException() {}
    explicit IPSGetAllItemStatesException(const ::std::string&);

    virtual const ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class IPSGetSpecfiedItemStatesException : public ::InfoProcess::IPSException
{
public:

    IPSGetSpecfiedItemStatesException() {}
    explicit IPSGetSpecfiedItemStatesException(const ::std::string&);

    virtual const ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

typedef ::std::vector< ::InfoProcess::IPSEIDSetPtr> IPSEIDSetSeq;

class __U__IPSEIDSetSeq { };
void __write(::IceInternal::BasicStream*, const ::InfoProcess::IPSEIDSetPtr*, const ::InfoProcess::IPSEIDSetPtr*, __U__IPSEIDSetSeq);
void __read(::IceInternal::BasicStream*, IPSEIDSetSeq&, __U__IPSEIDSetSeq);

typedef ::std::map< ::std::string, ::InfoProcess::IPSEIDSetPtr> IPSEIDMap;

class __U__IPSEIDMap { };
void __write(::IceInternal::BasicStream*, const IPSEIDMap&, __U__IPSEIDMap);
void __read(::IceInternal::BasicStream*, IPSEIDMap&, __U__IPSEIDMap);

struct IPSLoginCfgInfo
{
    ::Ice::Long timeOut;
    ::Ice::Long timeInterval;
    bool bNeedUpdateLogin;

    bool operator==(const IPSLoginCfgInfo&) const;
    bool operator!=(const IPSLoginCfgInfo&) const;
    bool operator<(const IPSLoginCfgInfo&) const;
    bool operator<=(const IPSLoginCfgInfo& __rhs) const
    {
	return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const IPSLoginCfgInfo& __rhs) const
    {
	return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const IPSLoginCfgInfo& __rhs) const
    {
	return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::InfoProcess::IPSAlarmItemPtr> IPSAlarmItemSeq;

class __U__IPSAlarmItemSeq { };
void __write(::IceInternal::BasicStream*, const ::InfoProcess::IPSAlarmItemPtr*, const ::InfoProcess::IPSAlarmItemPtr*, __U__IPSAlarmItemSeq);
void __read(::IceInternal::BasicStream*, IPSAlarmItemSeq&, __U__IPSAlarmItemSeq);

enum IPSBROWSEDIRECTION
{
    IPSBROWSEUP,
    IPSBROWSEDOWN,
    IPSBROWSETO
};

void __write(::IceInternal::BasicStream*, IPSBROWSEDIRECTION);
void __read(::IceInternal::BasicStream*, IPSBROWSEDIRECTION&);

enum IPSBROWSEFILTER
{
    IPSBROWSEFILTERITEM,
    IPSBROWSEFILTERCHILDREN,
    IPSBROWSEFILTERGRANDSON,
    IPSBROWSEFILTERSIBLING
};

void __write(::IceInternal::BasicStream*, IPSBROWSEFILTER);
void __read(::IceInternal::BasicStream*, IPSBROWSEFILTER&);

enum IPSOBJOPERATIONTYPE
{
    IPSOBJADD,
    IPSOBJMODIFY,
    IPSOBJDELETE,
    IPSALARMCONFIRM
};

void __write(::IceInternal::BasicStream*, IPSOBJOPERATIONTYPE);
void __read(::IceInternal::BasicStream*, IPSOBJOPERATIONTYPE&);

enum IPSLOGINTYPE
{
    IPSLOGINPWDPLAIN,
    IPSLOGINPWDENCRYPT
};

void __write(::IceInternal::BasicStream*, IPSLOGINTYPE);
void __read(::IceInternal::BasicStream*, IPSLOGINTYPE&);

enum IPSCMPTYPE
{
    IPSDBCMPXIAOYU,
    IPSDBCMPXIAOYUANDDENGYU,
    IPSDBCMPDENGYU,
    IPSDBCMPDAYU,
    IPSDBCMPDAYUANDDENGYU,
    IPSDBCMPFANWEINODY,
    IPSDBCMPFANWEIZDY,
    IPSDBCMPFANWEIYDY,
    IPSDBCMPFANWEIANDDY,
    IPSDBCMPIN,
    IPSDBCMPNOIN,
    IPSDBCMPMOHUPIPEI
};

void __write(::IceInternal::BasicStream*, IPSCMPTYPE);
void __read(::IceInternal::BasicStream*, IPSCMPTYPE&);

typedef ::std::vector< ::InfoProcess::IPSCMPTYPE> IPSCMPTYPESeq;

class __U__IPSCMPTYPESeq { };
void __write(::IceInternal::BasicStream*, const ::InfoProcess::IPSCMPTYPE*, const ::InfoProcess::IPSCMPTYPE*, __U__IPSCMPTYPESeq);
void __read(::IceInternal::BasicStream*, IPSCMPTYPESeq&, __U__IPSCMPTYPESeq);

enum IPSCMPOP
{
    IPSCMPOPAND,
    IPSCMPOPOR,
    IPSCMPOPNULL,
    IPSCMPOPNOT
};

void __write(::IceInternal::BasicStream*, IPSCMPOP);
void __read(::IceInternal::BasicStream*, IPSCMPOP&);

typedef ::std::vector< ::InfoProcess::IPSBrowseElementPtr> IPSBrowseElementSeq;

class __U__IPSBrowseElementSeq { };
void __write(::IceInternal::BasicStream*, const ::InfoProcess::IPSBrowseElementPtr*, const ::InfoProcess::IPSBrowseElementPtr*, __U__IPSBrowseElementSeq);
void __read(::IceInternal::BasicStream*, IPSBrowseElementSeq&, __U__IPSBrowseElementSeq);

typedef ::std::map< ::std::string, ::std::string> S2SDict;

class __U__S2SDict { };
void __write(::IceInternal::BasicStream*, const S2SDict&, __U__S2SDict);
void __read(::IceInternal::BasicStream*, S2SDict&, __U__S2SDict);

typedef ::std::map< ::std::string, ::Ice::StringSeq> StringToStringSeqMap;

class __U__StringToStringSeqMap { };
void __write(::IceInternal::BasicStream*, const StringToStringSeqMap&, __U__StringToStringSeqMap);
void __read(::IceInternal::BasicStream*, StringToStringSeqMap&, __U__StringToStringSeqMap);

typedef ::std::map< ::std::string, ::InfoProcess::S2SDict> S2DMap;

class __U__S2DMap { };
void __write(::IceInternal::BasicStream*, const S2DMap&, __U__S2DMap);
void __read(::IceInternal::BasicStream*, S2DMap&, __U__S2DMap);

struct FORM
{
    ::std::string sName;
    ::Ice::Int crPaperColor;
    ::Ice::Int crGridColor;
    ::std::string sScriptText;
    ::InfoProcess::StringToStringSeqMap mapCtrlName2ItemIDs;
    ::Ice::ByteSeq byCompoundFile;

    bool operator==(const FORM&) const;
    bool operator!=(const FORM&) const;
    bool operator<(const FORM&) const;
    bool operator<=(const FORM& __rhs) const
    {
	return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const FORM& __rhs) const
    {
	return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const FORM& __rhs) const
    {
	return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::InfoProcess::FORM> FormSeq;

class __U__FormSeq { };
void __write(::IceInternal::BasicStream*, const ::InfoProcess::FORM*, const ::InfoProcess::FORM*, __U__FormSeq);
void __read(::IceInternal::BasicStream*, FormSeq&, __U__FormSeq);

struct FIELD
{
    ::std::string sName;
    ::InfoProcess::VariantPtr vValue;

    bool operator==(const FIELD&) const;
    bool operator!=(const FIELD&) const;
    bool operator<(const FIELD&) const;
    bool operator<=(const FIELD& __rhs) const
    {
	return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const FIELD& __rhs) const
    {
	return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const FIELD& __rhs) const
    {
	return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

typedef ::std::map< ::std::string, ::InfoProcess::VariantPtr> IPSRecord;

class __U__IPSRecord { };
void __write(::IceInternal::BasicStream*, const IPSRecord&, __U__IPSRecord);
void __read(::IceInternal::BasicStream*, IPSRecord&, __U__IPSRecord);

typedef ::std::vector< ::InfoProcess::IPSRecord> IPSRecordset;

class __U__IPSRecordset { };
void __write(::IceInternal::BasicStream*, const ::InfoProcess::IPSRecord*, const ::InfoProcess::IPSRecord*, __U__IPSRecordset);
void __read(::IceInternal::BasicStream*, IPSRecordset&, __U__IPSRecordset);

typedef ::std::vector< ::InfoProcess::IPSBackupFilePtr> IPSBackupFileSeq;

class __U__IPSBackupFileSeq { };
void __write(::IceInternal::BasicStream*, const ::InfoProcess::IPSBackupFilePtr*, const ::InfoProcess::IPSBackupFilePtr*, __U__IPSBackupFileSeq);
void __read(::IceInternal::BasicStream*, IPSBackupFileSeq&, __U__IPSBackupFileSeq);

}

namespace InfoProcess
{

class AMD_IPSBackupLogicMgt_UpdateLogic : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSBackupLogicMgt_UpdateLogic> AMD_IPSBackupLogicMgt_UpdateLogicPtr;

class AMD_IPSBackupLogicMgt_CheckLogicValid : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSBackupLogicMgt_CheckLogicValid> AMD_IPSBackupLogicMgt_CheckLogicValidPtr;

class AMD_IPSItemStateMgt_UpdateItemState : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSItemStateMgt_UpdateItemState> AMD_IPSItemStateMgt_UpdateItemStatePtr;

class AMD_IPSItemStateMgt_UpdateBatchItemStates : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSItemStateMgt_UpdateBatchItemStates> AMD_IPSItemStateMgt_UpdateBatchItemStatesPtr;

class AMD_IPSItemStateMgt_GetAllItemStates : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSItemStateSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSItemStateMgt_GetAllItemStates> AMD_IPSItemStateMgt_GetAllItemStatesPtr;

class AMD_IPSItemStateMgt_GetSpecfiedItemStates : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSItemStateSeq&, const ::Ice::StringSeq&, const ::Ice::IntSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSItemStateMgt_GetSpecfiedItemStates> AMD_IPSItemStateMgt_GetSpecfiedItemStatesPtr;

class AMD_IPSItemMgt_AddItems : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&, const ::Ice::IntSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSItemMgt_AddItems> AMD_IPSItemMgt_AddItemsPtr;

class AMD_IPSItemMgt_ModifyItems : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&, const ::Ice::IntSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSItemMgt_ModifyItems> AMD_IPSItemMgt_ModifyItemsPtr;

class AMD_IPSItemMgt_RemoveItems : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&, const ::Ice::IntSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSItemMgt_RemoveItems> AMD_IPSItemMgt_RemoveItemsPtr;

class AMD_IPSSysStateMng_GetCurSysState : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSItemStateSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSSysStateMng_GetCurSysState> AMD_IPSSysStateMng_GetCurSysStatePtr;

class AMD_IPSItemPropertyMgt_AddItemProperties : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&, const ::Ice::IntSeq&, const ::Ice::IntSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSItemPropertyMgt_AddItemProperties> AMD_IPSItemPropertyMgt_AddItemPropertiesPtr;

class AMD_IPSItemPropertyMgt_ModifyItemProperties : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&, const ::Ice::IntSeq&, const ::Ice::IntSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSItemPropertyMgt_ModifyItemProperties> AMD_IPSItemPropertyMgt_ModifyItemPropertiesPtr;

class AMD_IPSItemPropertyMgt_RemoveItemProperties : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&, const ::Ice::IntSeq&, const ::Ice::IntSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSItemPropertyMgt_RemoveItemProperties> AMD_IPSItemPropertyMgt_RemoveItemPropertiesPtr;

class AMD_IPSBrowser_GetProperties : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSItemPropertySeq&, const ::Ice::IntSeq&, const ::Ice::IntSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSBrowser_GetProperties> AMD_IPSBrowser_GetPropertiesPtr;

class AMD_IPSBrowser_GetPropertyDesc : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::InfoProcess::PropertyDescDict&, const ::Ice::IntSeq&, const ::Ice::IntSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSBrowser_GetPropertyDesc> AMD_IPSBrowser_GetPropertyDescPtr;

class AMD_IPSBrowser_GetVariantTypeDesc : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::InfoProcess::VarTypeDescDict&, const ::InfoProcess::VARTYPESeq&, const ::Ice::IntSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSBrowser_GetVariantTypeDesc> AMD_IPSBrowser_GetVariantTypeDescPtr;

class AMD_IPSBrowser_Browse : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSBrowseElementSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSBrowser_Browse> AMD_IPSBrowser_BrowsePtr;

class AMD_IPSBrowser_Browse4Seq : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSBrowseElementSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSBrowser_Browse4Seq> AMD_IPSBrowser_Browse4SeqPtr;

class AMI_IPSBrowser_GetItemIDsByItemProperty : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    void __invoke(const ::InfoProcess::IPSBrowserPrx&, const ::std::string&, ::InfoProcess::IPSCMPOP, const ::Ice::IntSeq&, const ::InfoProcess::IPSCMPTYPESeq&, const ::InfoProcess::VariantSeq&, const ::Ice::Context&);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::InfoProcess::AMI_IPSBrowser_GetItemIDsByItemProperty> AMI_IPSBrowser_GetItemIDsByItemPropertyPtr;

class AMD_IPSBrowser_GetItemIDsByItemProperty : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSBrowser_GetItemIDsByItemProperty> AMD_IPSBrowser_GetItemIDsByItemPropertyPtr;

class AMI_IPSBrowser_GetItemStatesByItemProperty : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSItemStateSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    void __invoke(const ::InfoProcess::IPSBrowserPrx&, const ::std::string&, ::InfoProcess::IPSCMPOP, const ::Ice::IntSeq&, const ::InfoProcess::IPSCMPTYPESeq&, const ::InfoProcess::VariantSeq&, ::Ice::Long, ::Ice::Long, const ::Ice::Context&);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::InfoProcess::AMI_IPSBrowser_GetItemStatesByItemProperty> AMI_IPSBrowser_GetItemStatesByItemPropertyPtr;

class AMD_IPSBrowser_GetItemStatesByItemProperty : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSItemStateSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSBrowser_GetItemStatesByItemProperty> AMD_IPSBrowser_GetItemStatesByItemPropertyPtr;

class AMI_IPSBrowser_GetItemStatesByItemState : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSItemStateSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    void __invoke(const ::InfoProcess::IPSBrowserPrx&, const ::std::string&, ::InfoProcess::IPSCMPOP, const ::InfoProcess::IPSItemStateSeq&, const ::InfoProcess::IPSCMPTYPESeq&, ::Ice::Long, ::Ice::Long, const ::Ice::Context&);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::InfoProcess::AMI_IPSBrowser_GetItemStatesByItemState> AMI_IPSBrowser_GetItemStatesByItemStatePtr;

class AMD_IPSBrowser_GetItemStatesByItemState : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSItemStateSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSBrowser_GetItemStatesByItemState> AMD_IPSBrowser_GetItemStatesByItemStatePtr;

class AMD_IPSAlarmMng_ReadAlarm : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSAlarmItemSeq&, const ::Ice::StringSeq&, const ::Ice::IntSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSAlarmMng_ReadAlarm> AMD_IPSAlarmMng_ReadAlarmPtr;

class AMD_IPSAlarmMng_ConfirmAlarm : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, ::Ice::Int) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSAlarmMng_ConfirmAlarm> AMD_IPSAlarmMng_ConfirmAlarmPtr;

class AMD_IPSAlarmMng_BatchConfirmAlarm : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&, const ::Ice::IntSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSAlarmMng_BatchConfirmAlarm> AMD_IPSAlarmMng_BatchConfirmAlarmPtr;

class AMD_IPSAlarmMng_DeleteAlarm : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, ::Ice::Int) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSAlarmMng_DeleteAlarm> AMD_IPSAlarmMng_DeleteAlarmPtr;

class AMD_IPSAlarmMng_BatchDeleteAlarm : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&, const ::Ice::IntSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSAlarmMng_BatchDeleteAlarm> AMD_IPSAlarmMng_BatchDeleteAlarmPtr;

class AMD_IPSAlarmMng_GetCurAlarm : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSAlarmItemSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSAlarmMng_GetCurAlarm> AMD_IPSAlarmMng_GetCurAlarmPtr;

class AMD_IPSAlarmMng_ReportAlarm : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSAlarmMng_ReportAlarm> AMD_IPSAlarmMng_ReportAlarmPtr;

class AMD_IPSControlCmdMng_Write : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSItemStateSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSControlCmdMng_Write> AMD_IPSControlCmdMng_WritePtr;

class AMD_IPSSupportMng_EnumObj : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSRecordset&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSSupportMng_EnumObj> AMD_IPSSupportMng_EnumObjPtr;

class AMD_IPSSupportMng_AddObj : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSRecordset&, const ::Ice::IntSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSSupportMng_AddObj> AMD_IPSSupportMng_AddObjPtr;

class AMD_IPSSupportMng_ModifyObj : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSRecordset&, const ::Ice::IntSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSSupportMng_ModifyObj> AMD_IPSSupportMng_ModifyObjPtr;

class AMD_IPSSupportMng_DelObj : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSRecordset&, const ::Ice::IntSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSSupportMng_DelObj> AMD_IPSSupportMng_DelObjPtr;

class AMD_IPSBackupMgt_BackupOriginPacket : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSBackupMgt_BackupOriginPacket> AMD_IPSBackupMgt_BackupOriginPacketPtr;

class AMD_IPSBackupMgt_BackupFileData : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSBackupMgt_BackupFileData> AMD_IPSBackupMgt_BackupFileDataPtr;

class AMD_IPSRestoreMgt_RestoreFileData : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(const ::InfoProcess::IPSBackupFileSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSRestoreMgt_RestoreFileData> AMD_IPSRestoreMgt_RestoreFileDataPtr;

class AMI_IPSDataIO_Read : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSItemStateSeq&, const ::Ice::StringSeq&, const ::Ice::IntSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    void __invoke(const ::InfoProcess::IPSDataIOPrx&, const ::Ice::StringSeq&, const ::Ice::Context&);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::InfoProcess::AMI_IPSDataIO_Read> AMI_IPSDataIO_ReadPtr;

class AMD_IPSDataIO_Read : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSItemStateSeq&, const ::Ice::StringSeq&, const ::Ice::IntSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSDataIO_Read> AMD_IPSDataIO_ReadPtr;

class AMI_IPSDataIO_Write : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&, const ::Ice::IntSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    void __invoke(const ::InfoProcess::IPSDataIOPrx&, const ::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::InfoProcess::AMI_IPSDataIO_Write> AMI_IPSDataIO_WritePtr;

class AMD_IPSDataIO_Write : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&, const ::Ice::IntSeq&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::InfoProcess::AMD_IPSDataIO_Write> AMD_IPSDataIO_WritePtr;

}

namespace IceAsync
{

namespace InfoProcess
{

class AMD_IPSBackupLogicMgt_UpdateLogic : public ::InfoProcess::AMD_IPSBackupLogicMgt_UpdateLogic, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSBackupLogicMgt_UpdateLogic(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSBackupLogicMgt_CheckLogicValid : public ::InfoProcess::AMD_IPSBackupLogicMgt_CheckLogicValid, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSBackupLogicMgt_CheckLogicValid(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSItemStateMgt_UpdateItemState : public ::InfoProcess::AMD_IPSItemStateMgt_UpdateItemState, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSItemStateMgt_UpdateItemState(::IceInternal::Incoming&);

    virtual void ice_response();
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSItemStateMgt_UpdateBatchItemStates : public ::InfoProcess::AMD_IPSItemStateMgt_UpdateBatchItemStates, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSItemStateMgt_UpdateBatchItemStates(::IceInternal::Incoming&);

    virtual void ice_response();
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSItemStateMgt_GetAllItemStates : public ::InfoProcess::AMD_IPSItemStateMgt_GetAllItemStates, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSItemStateMgt_GetAllItemStates(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSItemStateSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSItemStateMgt_GetSpecfiedItemStates : public ::InfoProcess::AMD_IPSItemStateMgt_GetSpecfiedItemStates, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSItemStateMgt_GetSpecfiedItemStates(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSItemStateSeq&, const ::Ice::StringSeq&, const ::Ice::IntSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSItemMgt_AddItems : public ::InfoProcess::AMD_IPSItemMgt_AddItems, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSItemMgt_AddItems(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&, const ::Ice::IntSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSItemMgt_ModifyItems : public ::InfoProcess::AMD_IPSItemMgt_ModifyItems, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSItemMgt_ModifyItems(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&, const ::Ice::IntSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSItemMgt_RemoveItems : public ::InfoProcess::AMD_IPSItemMgt_RemoveItems, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSItemMgt_RemoveItems(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&, const ::Ice::IntSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSSysStateMng_GetCurSysState : public ::InfoProcess::AMD_IPSSysStateMng_GetCurSysState, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSSysStateMng_GetCurSysState(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSItemStateSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSItemPropertyMgt_AddItemProperties : public ::InfoProcess::AMD_IPSItemPropertyMgt_AddItemProperties, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSItemPropertyMgt_AddItemProperties(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&, const ::Ice::IntSeq&, const ::Ice::IntSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSItemPropertyMgt_ModifyItemProperties : public ::InfoProcess::AMD_IPSItemPropertyMgt_ModifyItemProperties, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSItemPropertyMgt_ModifyItemProperties(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&, const ::Ice::IntSeq&, const ::Ice::IntSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSItemPropertyMgt_RemoveItemProperties : public ::InfoProcess::AMD_IPSItemPropertyMgt_RemoveItemProperties, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSItemPropertyMgt_RemoveItemProperties(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&, const ::Ice::IntSeq&, const ::Ice::IntSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSBrowser_GetProperties : public ::InfoProcess::AMD_IPSBrowser_GetProperties, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSBrowser_GetProperties(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSItemPropertySeq&, const ::Ice::IntSeq&, const ::Ice::IntSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSBrowser_GetPropertyDesc : public ::InfoProcess::AMD_IPSBrowser_GetPropertyDesc, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSBrowser_GetPropertyDesc(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::InfoProcess::PropertyDescDict&, const ::Ice::IntSeq&, const ::Ice::IntSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSBrowser_GetVariantTypeDesc : public ::InfoProcess::AMD_IPSBrowser_GetVariantTypeDesc, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSBrowser_GetVariantTypeDesc(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::InfoProcess::VarTypeDescDict&, const ::InfoProcess::VARTYPESeq&, const ::Ice::IntSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSBrowser_Browse : public ::InfoProcess::AMD_IPSBrowser_Browse, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSBrowser_Browse(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSBrowseElementSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSBrowser_Browse4Seq : public ::InfoProcess::AMD_IPSBrowser_Browse4Seq, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSBrowser_Browse4Seq(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSBrowseElementSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSBrowser_GetItemIDsByItemProperty : public ::InfoProcess::AMD_IPSBrowser_GetItemIDsByItemProperty, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSBrowser_GetItemIDsByItemProperty(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSBrowser_GetItemStatesByItemProperty : public ::InfoProcess::AMD_IPSBrowser_GetItemStatesByItemProperty, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSBrowser_GetItemStatesByItemProperty(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSItemStateSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSBrowser_GetItemStatesByItemState : public ::InfoProcess::AMD_IPSBrowser_GetItemStatesByItemState, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSBrowser_GetItemStatesByItemState(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSItemStateSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSAlarmMng_ReadAlarm : public ::InfoProcess::AMD_IPSAlarmMng_ReadAlarm, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSAlarmMng_ReadAlarm(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSAlarmItemSeq&, const ::Ice::StringSeq&, const ::Ice::IntSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSAlarmMng_ConfirmAlarm : public ::InfoProcess::AMD_IPSAlarmMng_ConfirmAlarm, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSAlarmMng_ConfirmAlarm(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, ::Ice::Int);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSAlarmMng_BatchConfirmAlarm : public ::InfoProcess::AMD_IPSAlarmMng_BatchConfirmAlarm, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSAlarmMng_BatchConfirmAlarm(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&, const ::Ice::IntSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSAlarmMng_DeleteAlarm : public ::InfoProcess::AMD_IPSAlarmMng_DeleteAlarm, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSAlarmMng_DeleteAlarm(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, ::Ice::Int);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSAlarmMng_BatchDeleteAlarm : public ::InfoProcess::AMD_IPSAlarmMng_BatchDeleteAlarm, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSAlarmMng_BatchDeleteAlarm(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&, const ::Ice::IntSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSAlarmMng_GetCurAlarm : public ::InfoProcess::AMD_IPSAlarmMng_GetCurAlarm, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSAlarmMng_GetCurAlarm(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSAlarmItemSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSAlarmMng_ReportAlarm : public ::InfoProcess::AMD_IPSAlarmMng_ReportAlarm, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSAlarmMng_ReportAlarm(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSControlCmdMng_Write : public ::InfoProcess::AMD_IPSControlCmdMng_Write, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSControlCmdMng_Write(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSItemStateSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSSupportMng_EnumObj : public ::InfoProcess::AMD_IPSSupportMng_EnumObj, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSSupportMng_EnumObj(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSRecordset&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSSupportMng_AddObj : public ::InfoProcess::AMD_IPSSupportMng_AddObj, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSSupportMng_AddObj(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSRecordset&, const ::Ice::IntSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSSupportMng_ModifyObj : public ::InfoProcess::AMD_IPSSupportMng_ModifyObj, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSSupportMng_ModifyObj(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSRecordset&, const ::Ice::IntSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSSupportMng_DelObj : public ::InfoProcess::AMD_IPSSupportMng_DelObj, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSSupportMng_DelObj(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSRecordset&, const ::Ice::IntSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSBackupMgt_BackupOriginPacket : public ::InfoProcess::AMD_IPSBackupMgt_BackupOriginPacket, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSBackupMgt_BackupOriginPacket(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSBackupMgt_BackupFileData : public ::InfoProcess::AMD_IPSBackupMgt_BackupFileData, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSBackupMgt_BackupFileData(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSRestoreMgt_RestoreFileData : public ::InfoProcess::AMD_IPSRestoreMgt_RestoreFileData, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSRestoreMgt_RestoreFileData(::IceInternal::Incoming&);

    virtual void ice_response(const ::InfoProcess::IPSBackupFileSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSDataIO_Read : public ::InfoProcess::AMD_IPSDataIO_Read, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSDataIO_Read(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::InfoProcess::IPSItemStateSeq&, const ::Ice::StringSeq&, const ::Ice::IntSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class AMD_IPSDataIO_Write : public ::InfoProcess::AMD_IPSDataIO_Write, public ::IceInternal::IncomingAsync
{
public:

    AMD_IPSDataIO_Write(::IceInternal::Incoming&);

    virtual void ice_response(::Ice::Int, const ::Ice::StringSeq&, const ::Ice::IntSeq&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

}

}

namespace IceProxy
{

namespace InfoProcess
{

class IPSEIDSet : virtual public ::IceProxy::InfoProcess::IPSObject
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSAlarmItem : virtual public ::IceProxy::InfoProcess::IPSObject
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSBrowseElement : virtual public ::IceProxy::Ice::Object
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSBackupLogic : virtual public ::IceProxy::Ice::Object
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class Agent : virtual public ::IceProxy::Ice::Object
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSInterface : virtual public ::IceProxy::Ice::Object
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSServer : virtual public ::IceProxy::InfoProcess::IPSInterface
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSBackupLogicMgt : virtual public ::IceProxy::InfoProcess::IPSInterface
{
public:

    ::Ice::Int UpdateLogic(const ::InfoProcess::IPSBackupLogicPtr& bkLogic)
    {
	return UpdateLogic(bkLogic, __defaultContext());
    }
    ::Ice::Int UpdateLogic(const ::InfoProcess::IPSBackupLogicPtr&, const ::Ice::Context&);

    ::Ice::Int CheckLogicValid(const ::InfoProcess::IPSBackupLogicPtr& bkLogic)
    {
	return CheckLogicValid(bkLogic, __defaultContext());
    }
    ::Ice::Int CheckLogicValid(const ::InfoProcess::IPSBackupLogicPtr&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSItemStateMgt : virtual public ::IceProxy::InfoProcess::IPSInterface
{
public:

    void UpdateItemState(const ::InfoProcess::IPSItemStatePtr& item)
    {
	UpdateItemState(item, __defaultContext());
    }
    void UpdateItemState(const ::InfoProcess::IPSItemStatePtr&, const ::Ice::Context&);

    void UpdateBatchItemStates(const ::std::pair<const ::InfoProcess::IPSItemStatePtr*, const ::InfoProcess::IPSItemStatePtr*>& items)
    {
	UpdateBatchItemStates(items, __defaultContext());
    }
    void UpdateBatchItemStates(const ::std::pair<const ::InfoProcess::IPSItemStatePtr*, const ::InfoProcess::IPSItemStatePtr*>&, const ::Ice::Context&);

    ::Ice::Int GetAllItemStates(::InfoProcess::IPSItemStateSeq& itemStateSeq)
    {
	return GetAllItemStates(itemStateSeq, __defaultContext());
    }
    ::Ice::Int GetAllItemStates(::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&);

    ::Ice::Int GetSpecfiedItemStates(const ::Ice::StringSeq& sItemIDs, ::InfoProcess::IPSItemStateSeq& itemStateSeq, ::Ice::StringSeq& sErrorItemIDs, ::Ice::IntSeq& nErrorCodes)
    {
	return GetSpecfiedItemStates(sItemIDs, itemStateSeq, sErrorItemIDs, nErrorCodes, __defaultContext());
    }
    ::Ice::Int GetSpecfiedItemStates(const ::Ice::StringSeq&, ::InfoProcess::IPSItemStateSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSItemMgt : virtual public ::IceProxy::InfoProcess::IPSInterface
{
public:

    ::Ice::Int AddItems(const ::InfoProcess::IPSItemDefSeq& Items, ::Ice::StringSeq& sErrorItemIDs, ::Ice::IntSeq& nErrorCodes)
    {
	return AddItems(Items, sErrorItemIDs, nErrorCodes, __defaultContext());
    }
    ::Ice::Int AddItems(const ::InfoProcess::IPSItemDefSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    ::Ice::Int ModifyItems(const ::InfoProcess::IPSItemDefSeq& Items, ::Ice::StringSeq& sErrorItemIDs, ::Ice::IntSeq& nErrorCodes)
    {
	return ModifyItems(Items, sErrorItemIDs, nErrorCodes, __defaultContext());
    }
    ::Ice::Int ModifyItems(const ::InfoProcess::IPSItemDefSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    ::Ice::Int RemoveItems(const ::Ice::StringSeq& szItemIDs, ::Ice::StringSeq& sErrorItemIDs, ::Ice::IntSeq& nErrorCodes)
    {
	return RemoveItems(szItemIDs, sErrorItemIDs, nErrorCodes, __defaultContext());
    }
    ::Ice::Int RemoveItems(const ::Ice::StringSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSSysStateMng : virtual public ::IceProxy::InfoProcess::IPSInterface
{
public:

    ::Ice::Int GetCurSysState(::InfoProcess::IPSItemStateSeq& isSeq)
    {
	return GetCurSysState(isSeq, __defaultContext());
    }
    ::Ice::Int GetCurSysState(::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSItemPropertyMgt : virtual public ::IceProxy::InfoProcess::IPSInterface
{
public:

    ::Ice::Int AddItemProperties(const ::InfoProcess::IPSItemPropertySeq& ItemProperties, ::Ice::StringSeq& szErrorItemIDs, ::Ice::IntSeq& nErrorPropertyIDs, ::Ice::IntSeq& nErrorCodes)
    {
	return AddItemProperties(ItemProperties, szErrorItemIDs, nErrorPropertyIDs, nErrorCodes, __defaultContext());
    }
    ::Ice::Int AddItemProperties(const ::InfoProcess::IPSItemPropertySeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    ::Ice::Int ModifyItemProperties(const ::InfoProcess::IPSItemPropertySeq& ItemProperties, ::Ice::StringSeq& szErrorItemIDs, ::Ice::IntSeq& nErrorPropertyIDs, ::Ice::IntSeq& nErrorCodes)
    {
	return ModifyItemProperties(ItemProperties, szErrorItemIDs, nErrorPropertyIDs, nErrorCodes, __defaultContext());
    }
    ::Ice::Int ModifyItemProperties(const ::InfoProcess::IPSItemPropertySeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    ::Ice::Int RemoveItemProperties(const ::InfoProcess::IPSItemPropertySeq& ItemProperties, ::Ice::StringSeq& szErrorItemIDs, ::Ice::IntSeq& nErrorPropertyIDs, ::Ice::IntSeq& nErrorCodes)
    {
	return RemoveItemProperties(ItemProperties, szErrorItemIDs, nErrorPropertyIDs, nErrorCodes, __defaultContext());
    }
    ::Ice::Int RemoveItemProperties(const ::InfoProcess::IPSItemPropertySeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, ::Ice::IntSeq&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSBrowser : virtual public ::IceProxy::InfoProcess::IPSInterface
{
public:

    ::Ice::Int GetProperties(const ::std::string& szItem, const ::Ice::IntSeq& nPropertyIDs, ::InfoProcess::IPSItemPropertySeq& ItemProperties, ::Ice::IntSeq& ErrorIPIDs, ::Ice::IntSeq& nErrorCodes)
    {
	return GetProperties(szItem, nPropertyIDs, ItemProperties, ErrorIPIDs, nErrorCodes, __defaultContext());
    }
    ::Ice::Int GetProperties(const ::std::string&, const ::Ice::IntSeq&, ::InfoProcess::IPSItemPropertySeq&, ::Ice::IntSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    ::Ice::Int GetPropertyDesc(const ::Ice::IntSeq& nPropertyIDs, ::InfoProcess::PropertyDescDict& PropertyDescs, ::Ice::IntSeq& nErrorPropIDs, ::Ice::IntSeq& nErrorCodes)
    {
	return GetPropertyDesc(nPropertyIDs, PropertyDescs, nErrorPropIDs, nErrorCodes, __defaultContext());
    }
    ::Ice::Int GetPropertyDesc(const ::Ice::IntSeq&, ::InfoProcess::PropertyDescDict&, ::Ice::IntSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    ::Ice::Int GetVariantTypeDesc(const ::InfoProcess::VARTYPESeq& nVarTypes, ::InfoProcess::VarTypeDescDict& VarTypes, ::InfoProcess::VARTYPESeq& nErrorVarTypes, ::Ice::IntSeq& nErrorCodes)
    {
	return GetVariantTypeDesc(nVarTypes, VarTypes, nErrorVarTypes, nErrorCodes, __defaultContext());
    }
    ::Ice::Int GetVariantTypeDesc(const ::InfoProcess::VARTYPESeq&, ::InfoProcess::VarTypeDescDict&, ::InfoProcess::VARTYPESeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    ::Ice::Int Browse(const ::std::string& szItemID, ::InfoProcess::IPSBROWSEFILTER dwBrowseFilter, const ::std::string& szElementNameFilter, bool bReturnAllProperties, const ::Ice::IntSeq& dwPropertyIDs, ::InfoProcess::IPSBrowseElementSeq& BrowseElements)
    {
	return Browse(szItemID, dwBrowseFilter, szElementNameFilter, bReturnAllProperties, dwPropertyIDs, BrowseElements, __defaultContext());
    }
    ::Ice::Int Browse(const ::std::string&, ::InfoProcess::IPSBROWSEFILTER, const ::std::string&, bool, const ::Ice::IntSeq&, ::InfoProcess::IPSBrowseElementSeq&, const ::Ice::Context&);

    ::Ice::Int Browse4Seq(const ::Ice::StringSeq& szItemIDs, ::InfoProcess::IPSBROWSEFILTER dwBrowseFilter, const ::std::string& szElementNameFilter, bool bReturnAllProperties, const ::Ice::IntSeq& dwPropertyIDs, ::InfoProcess::IPSBrowseElementSeq& BrowseElements)
    {
	return Browse4Seq(szItemIDs, dwBrowseFilter, szElementNameFilter, bReturnAllProperties, dwPropertyIDs, BrowseElements, __defaultContext());
    }
    ::Ice::Int Browse4Seq(const ::Ice::StringSeq&, ::InfoProcess::IPSBROWSEFILTER, const ::std::string&, bool, const ::Ice::IntSeq&, ::InfoProcess::IPSBrowseElementSeq&, const ::Ice::Context&);

    ::Ice::Int GetItemIDsByItemProperty(const ::std::string& ItemID, ::InfoProcess::IPSCMPOP cmpOP, const ::Ice::IntSeq& PropertyIDs, const ::InfoProcess::IPSCMPTYPESeq& cmpTypes, const ::InfoProcess::VariantSeq& varSeq, ::Ice::StringSeq& ItemIDs)
    {
	return GetItemIDsByItemProperty(ItemID, cmpOP, PropertyIDs, cmpTypes, varSeq, ItemIDs, __defaultContext());
    }
    ::Ice::Int GetItemIDsByItemProperty(const ::std::string&, ::InfoProcess::IPSCMPOP, const ::Ice::IntSeq&, const ::InfoProcess::IPSCMPTYPESeq&, const ::InfoProcess::VariantSeq&, ::Ice::StringSeq&, const ::Ice::Context&);
    void GetItemIDsByItemProperty_async(const ::InfoProcess::AMI_IPSBrowser_GetItemIDsByItemPropertyPtr&, const ::std::string&, ::InfoProcess::IPSCMPOP, const ::Ice::IntSeq&, const ::InfoProcess::IPSCMPTYPESeq&, const ::InfoProcess::VariantSeq&);
    void GetItemIDsByItemProperty_async(const ::InfoProcess::AMI_IPSBrowser_GetItemIDsByItemPropertyPtr&, const ::std::string&, ::InfoProcess::IPSCMPOP, const ::Ice::IntSeq&, const ::InfoProcess::IPSCMPTYPESeq&, const ::InfoProcess::VariantSeq&, const ::Ice::Context&);

    ::Ice::Int GetItemStatesByItemProperty(const ::std::string& ItemID, ::InfoProcess::IPSCMPOP cmpOP, const ::Ice::IntSeq& PropertyIDs, const ::InfoProcess::IPSCMPTYPESeq& cmpTypes, const ::InfoProcess::VariantSeq& varSeq, ::Ice::Long lStartTime, ::Ice::Long lEndTime, ::InfoProcess::IPSItemStateSeq& ItemStates)
    {
	return GetItemStatesByItemProperty(ItemID, cmpOP, PropertyIDs, cmpTypes, varSeq, lStartTime, lEndTime, ItemStates, __defaultContext());
    }
    ::Ice::Int GetItemStatesByItemProperty(const ::std::string&, ::InfoProcess::IPSCMPOP, const ::Ice::IntSeq&, const ::InfoProcess::IPSCMPTYPESeq&, const ::InfoProcess::VariantSeq&, ::Ice::Long, ::Ice::Long, ::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&);
    void GetItemStatesByItemProperty_async(const ::InfoProcess::AMI_IPSBrowser_GetItemStatesByItemPropertyPtr&, const ::std::string&, ::InfoProcess::IPSCMPOP, const ::Ice::IntSeq&, const ::InfoProcess::IPSCMPTYPESeq&, const ::InfoProcess::VariantSeq&, ::Ice::Long, ::Ice::Long);
    void GetItemStatesByItemProperty_async(const ::InfoProcess::AMI_IPSBrowser_GetItemStatesByItemPropertyPtr&, const ::std::string&, ::InfoProcess::IPSCMPOP, const ::Ice::IntSeq&, const ::InfoProcess::IPSCMPTYPESeq&, const ::InfoProcess::VariantSeq&, ::Ice::Long, ::Ice::Long, const ::Ice::Context&);

    ::Ice::Int GetItemStatesByItemState(const ::std::string& ItemID, ::InfoProcess::IPSCMPOP cmpOP, const ::InfoProcess::IPSItemStateSeq& CXItemStateSeq, const ::InfoProcess::IPSCMPTYPESeq& cmpTypes, ::Ice::Long lStartTime, ::Ice::Long lEndTime, ::InfoProcess::IPSItemStateSeq& ItemStates)
    {
	return GetItemStatesByItemState(ItemID, cmpOP, CXItemStateSeq, cmpTypes, lStartTime, lEndTime, ItemStates, __defaultContext());
    }
    ::Ice::Int GetItemStatesByItemState(const ::std::string&, ::InfoProcess::IPSCMPOP, const ::InfoProcess::IPSItemStateSeq&, const ::InfoProcess::IPSCMPTYPESeq&, ::Ice::Long, ::Ice::Long, ::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&);
    void GetItemStatesByItemState_async(const ::InfoProcess::AMI_IPSBrowser_GetItemStatesByItemStatePtr&, const ::std::string&, ::InfoProcess::IPSCMPOP, const ::InfoProcess::IPSItemStateSeq&, const ::InfoProcess::IPSCMPTYPESeq&, ::Ice::Long, ::Ice::Long);
    void GetItemStatesByItemState_async(const ::InfoProcess::AMI_IPSBrowser_GetItemStatesByItemStatePtr&, const ::std::string&, ::InfoProcess::IPSCMPOP, const ::InfoProcess::IPSItemStateSeq&, const ::InfoProcess::IPSCMPTYPESeq&, ::Ice::Long, ::Ice::Long, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSAlarmMng : virtual public ::IceProxy::InfoProcess::IPSInterface
{
public:

    ::Ice::Int ReadAlarm(const ::Ice::StringSeq& AlarmIDs, ::InfoProcess::IPSAlarmItemSeq& aiSeq, ::Ice::StringSeq& sErrorItemIDs, ::Ice::IntSeq& nErrorCodes)
    {
	return ReadAlarm(AlarmIDs, aiSeq, sErrorItemIDs, nErrorCodes, __defaultContext());
    }
    ::Ice::Int ReadAlarm(const ::Ice::StringSeq&, ::InfoProcess::IPSAlarmItemSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    ::Ice::Int ConfirmAlarm(const ::std::string& sAlarmID, ::Ice::Int& nErrorCode)
    {
	return ConfirmAlarm(sAlarmID, nErrorCode, __defaultContext());
    }
    ::Ice::Int ConfirmAlarm(const ::std::string&, ::Ice::Int&, const ::Ice::Context&);

    ::Ice::Int BatchConfirmAlarm(const ::Ice::StringSeq& AlarmIDs, ::Ice::StringSeq& sErrorItemIDs, ::Ice::IntSeq& nErrorCodes)
    {
	return BatchConfirmAlarm(AlarmIDs, sErrorItemIDs, nErrorCodes, __defaultContext());
    }
    ::Ice::Int BatchConfirmAlarm(const ::Ice::StringSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    ::Ice::Int DeleteAlarm(const ::std::string& sAlarmID, ::Ice::Int& nErrorCode)
    {
	return DeleteAlarm(sAlarmID, nErrorCode, __defaultContext());
    }
    ::Ice::Int DeleteAlarm(const ::std::string&, ::Ice::Int&, const ::Ice::Context&);

    ::Ice::Int BatchDeleteAlarm(const ::Ice::StringSeq& AlarmIDs, ::Ice::StringSeq& sErrorAlarmIDs, ::Ice::IntSeq& nErrorCodes)
    {
	return BatchDeleteAlarm(AlarmIDs, sErrorAlarmIDs, nErrorCodes, __defaultContext());
    }
    ::Ice::Int BatchDeleteAlarm(const ::Ice::StringSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    ::Ice::Int GetCurAlarm(::InfoProcess::IPSAlarmItemSeq& aiSeq)
    {
	return GetCurAlarm(aiSeq, __defaultContext());
    }
    ::Ice::Int GetCurAlarm(::InfoProcess::IPSAlarmItemSeq&, const ::Ice::Context&);

    ::Ice::Int ReportAlarm(const ::InfoProcess::IPSAlarmItemSeq& aiSeq)
    {
	return ReportAlarm(aiSeq, __defaultContext());
    }
    ::Ice::Int ReportAlarm(const ::InfoProcess::IPSAlarmItemSeq&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSLoginMng : virtual public ::IceProxy::InfoProcess::IPSInterface
{
public:

    ::Ice::Int OperatorLogin(const ::std::string& UsrName, const ::std::string& Pwd, ::InfoProcess::IPSLOGINTYPE LoginType, ::std::string& EID, ::Ice::Long& LoginTime, ::InfoProcess::IPSLoginCfgInfo& svrCfgInfo)
    {
	return OperatorLogin(UsrName, Pwd, LoginType, EID, LoginTime, svrCfgInfo, __defaultContext());
    }
    ::Ice::Int OperatorLogin(const ::std::string&, const ::std::string&, ::InfoProcess::IPSLOGINTYPE, ::std::string&, ::Ice::Long&, ::InfoProcess::IPSLoginCfgInfo&, const ::Ice::Context&);

    ::Ice::Int OperatorLogout()
    {
	return OperatorLogout(__defaultContext());
    }
    ::Ice::Int OperatorLogout(const ::Ice::Context&);

    ::Ice::Int DeliverLogin(const ::std::string& UsrName, const ::std::string& Pwd, const ::std::string& UsrName1, const ::std::string& Pwd1, ::InfoProcess::IPSLOGINTYPE LoginType, const ::std::string& sDutyMemo, ::std::string& EID, ::Ice::Long& LoginTime, ::InfoProcess::IPSLoginCfgInfo& svrCfgInfo)
    {
	return DeliverLogin(UsrName, Pwd, UsrName1, Pwd1, LoginType, sDutyMemo, EID, LoginTime, svrCfgInfo, __defaultContext());
    }
    ::Ice::Int DeliverLogin(const ::std::string&, const ::std::string&, const ::std::string&, const ::std::string&, ::InfoProcess::IPSLOGINTYPE, const ::std::string&, ::std::string&, ::Ice::Long&, ::InfoProcess::IPSLoginCfgInfo&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSControlCmdMng : virtual public ::IceProxy::InfoProcess::IPSInterface
{
public:

    ::Ice::Int Write(const ::InfoProcess::IPSItemDefSeq& ItemDefs, ::InfoProcess::IPSItemStateSeq& isResult)
    {
	return Write(ItemDefs, isResult, __defaultContext());
    }
    ::Ice::Int Write(const ::InfoProcess::IPSItemDefSeq&, ::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSSupportMng : virtual public ::IceProxy::InfoProcess::IPSInterface
{
public:

    ::Ice::Int EnumObj(const ::std::string& sObjType, const ::std::string& sFilters, ::InfoProcess::IPSRecordset& rs)
    {
	return EnumObj(sObjType, sFilters, rs, __defaultContext());
    }
    ::Ice::Int EnumObj(const ::std::string&, const ::std::string&, ::InfoProcess::IPSRecordset&, const ::Ice::Context&);

    ::Ice::Int AddObj(const ::std::string& sObjType, const ::InfoProcess::IPSRecordset& rs, ::InfoProcess::IPSRecordset& rsErr, ::Ice::IntSeq& iErrSeq)
    {
	return AddObj(sObjType, rs, rsErr, iErrSeq, __defaultContext());
    }
    ::Ice::Int AddObj(const ::std::string&, const ::InfoProcess::IPSRecordset&, ::InfoProcess::IPSRecordset&, ::Ice::IntSeq&, const ::Ice::Context&);

    ::Ice::Int ModifyObj(const ::std::string& sObjType, const ::InfoProcess::IPSRecordset& rs, ::InfoProcess::IPSRecordset& rsErr, ::Ice::IntSeq& iErrSeq)
    {
	return ModifyObj(sObjType, rs, rsErr, iErrSeq, __defaultContext());
    }
    ::Ice::Int ModifyObj(const ::std::string&, const ::InfoProcess::IPSRecordset&, ::InfoProcess::IPSRecordset&, ::Ice::IntSeq&, const ::Ice::Context&);

    ::Ice::Int DelObj(const ::std::string& sObjType, const ::InfoProcess::IPSRecordset& rs, ::InfoProcess::IPSRecordset& rsErr, ::Ice::IntSeq& iErrSeq)
    {
	return DelObj(sObjType, rs, rsErr, iErrSeq, __defaultContext());
    }
    ::Ice::Int DelObj(const ::std::string&, const ::InfoProcess::IPSRecordset&, ::InfoProcess::IPSRecordset&, ::Ice::IntSeq&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSStatePublisher : virtual public ::IceProxy::InfoProcess::IPSInterface
{
public:

    void ReportItemState(const ::InfoProcess::IPSItemStateSeq& isSeq)
    {
	ReportItemState(isSeq, __defaultContext());
    }
    void ReportItemState(const ::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSAlarmPublisher : virtual public ::IceProxy::InfoProcess::IPSInterface
{
public:

    void ReportAlarm(const ::InfoProcess::IPSAlarmItemSeq& aiSeq, ::InfoProcess::IPSOBJOPERATIONTYPE iOT)
    {
	ReportAlarm(aiSeq, iOT, __defaultContext());
    }
    void ReportAlarm(const ::InfoProcess::IPSAlarmItemSeq&, ::InfoProcess::IPSOBJOPERATIONTYPE, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSItemDefPublisher : virtual public ::IceProxy::InfoProcess::IPSInterface
{
public:

    void ReportItemDef(const ::InfoProcess::IPSItemDefSeq& idSeq, ::InfoProcess::IPSOBJOPERATIONTYPE iOT)
    {
	ReportItemDef(idSeq, iOT, __defaultContext());
    }
    void ReportItemDef(const ::InfoProcess::IPSItemDefSeq&, ::InfoProcess::IPSOBJOPERATIONTYPE, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSItemPropPublisher : virtual public ::IceProxy::InfoProcess::IPSInterface
{
public:

    void ReportItemProp(const ::InfoProcess::IPSItemPropertySeq& ipSeq, ::InfoProcess::IPSOBJOPERATIONTYPE iOT)
    {
	ReportItemProp(ipSeq, iOT, __defaultContext());
    }
    void ReportItemProp(const ::InfoProcess::IPSItemPropertySeq&, ::InfoProcess::IPSOBJOPERATIONTYPE, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSObjPublisher : virtual public ::IceProxy::InfoProcess::IPSInterface
{
public:

    void ReportObj(const ::InfoProcess::IPSRecordset& rs, const ::std::string& sObjType, ::InfoProcess::IPSOBJOPERATIONTYPE iOT)
    {
	ReportObj(rs, sObjType, iOT, __defaultContext());
    }
    void ReportObj(const ::InfoProcess::IPSRecordset&, const ::std::string&, ::InfoProcess::IPSOBJOPERATIONTYPE, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSBackupFile : virtual public ::IceProxy::InfoProcess::IPSObject
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSBackupMgt : virtual public ::IceProxy::InfoProcess::IPSInterface
{
public:

    ::Ice::Int BackupOriginPacket(const ::Ice::ByteSeq& data, ::Ice::Int iLen)
    {
	return BackupOriginPacket(data, iLen, __defaultContext());
    }
    ::Ice::Int BackupOriginPacket(const ::Ice::ByteSeq&, ::Ice::Int, const ::Ice::Context&);

    ::Ice::Int BackupFileData(const ::InfoProcess::IPSBackupFileSeq& fq)
    {
	return BackupFileData(fq, __defaultContext());
    }
    ::Ice::Int BackupFileData(const ::InfoProcess::IPSBackupFileSeq&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSRestoreMgt : virtual public ::IceProxy::InfoProcess::IPSInterface
{
public:

    void RestoreFileData(const ::std::string& sDataID, ::Ice::Long lStartTime, ::Ice::Long EndTime, ::InfoProcess::IPSBackupFileSeq& fq)
    {
	RestoreFileData(sDataID, lStartTime, EndTime, fq, __defaultContext());
    }
    void RestoreFileData(const ::std::string&, ::Ice::Long, ::Ice::Long, ::InfoProcess::IPSBackupFileSeq&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class IPSDataIO : virtual public ::IceProxy::InfoProcess::IPSInterface
{
public:

    ::Ice::Int Read(const ::Ice::StringSeq& ItemIDs, ::InfoProcess::IPSItemStateSeq& ItemValues, ::Ice::StringSeq& sErrorItemIDs, ::Ice::IntSeq& nErrorCodes)
    {
	return Read(ItemIDs, ItemValues, sErrorItemIDs, nErrorCodes, __defaultContext());
    }
    ::Ice::Int Read(const ::Ice::StringSeq&, ::InfoProcess::IPSItemStateSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);
    void Read_async(const ::InfoProcess::AMI_IPSDataIO_ReadPtr&, const ::Ice::StringSeq&);
    void Read_async(const ::InfoProcess::AMI_IPSDataIO_ReadPtr&, const ::Ice::StringSeq&, const ::Ice::Context&);

    ::Ice::Int Write(const ::InfoProcess::IPSItemStateSeq& ItemValues, ::Ice::StringSeq& sErrorItemIDs, ::Ice::IntSeq& nErrorCodes)
    {
	return Write(ItemValues, sErrorItemIDs, nErrorCodes, __defaultContext());
    }
    ::Ice::Int Write(const ::InfoProcess::IPSItemStateSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);
    void Write_async(const ::InfoProcess::AMI_IPSDataIO_WritePtr&, const ::InfoProcess::IPSItemStateSeq&);
    void Write_async(const ::InfoProcess::AMI_IPSDataIO_WritePtr&, const ::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

}

}

namespace IceDelegate
{

namespace InfoProcess
{

class IPSEIDSet : virtual public ::IceDelegate::InfoProcess::IPSObject
{
public:
};

class IPSAlarmItem : virtual public ::IceDelegate::InfoProcess::IPSObject
{
public:
};

class IPSBrowseElement : virtual public ::IceDelegate::Ice::Object
{
public:
};

class IPSBackupLogic : virtual public ::IceDelegate::Ice::Object
{
public:
};

class Agent : virtual public ::IceDelegate::Ice::Object
{
public:
};

class IPSInterface : virtual public ::IceDelegate::Ice::Object
{
public:
};

class IPSServer : virtual public ::IceDelegate::InfoProcess::IPSInterface
{
public:
};

class IPSBackupLogicMgt : virtual public ::IceDelegate::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int UpdateLogic(const ::InfoProcess::IPSBackupLogicPtr&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int CheckLogicValid(const ::InfoProcess::IPSBackupLogicPtr&, const ::Ice::Context&) = 0;
};

class IPSItemStateMgt : virtual public ::IceDelegate::InfoProcess::IPSInterface
{
public:

    virtual void UpdateItemState(const ::InfoProcess::IPSItemStatePtr&, const ::Ice::Context&) = 0;

    virtual void UpdateBatchItemStates(const ::std::pair<const ::InfoProcess::IPSItemStatePtr*, const ::InfoProcess::IPSItemStatePtr*>&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int GetAllItemStates(::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int GetSpecfiedItemStates(const ::Ice::StringSeq&, ::InfoProcess::IPSItemStateSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&) = 0;
};

class IPSItemMgt : virtual public ::IceDelegate::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int AddItems(const ::InfoProcess::IPSItemDefSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int ModifyItems(const ::InfoProcess::IPSItemDefSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int RemoveItems(const ::Ice::StringSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&) = 0;
};

class IPSSysStateMng : virtual public ::IceDelegate::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int GetCurSysState(::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&) = 0;
};

class IPSItemPropertyMgt : virtual public ::IceDelegate::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int AddItemProperties(const ::InfoProcess::IPSItemPropertySeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, ::Ice::IntSeq&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int ModifyItemProperties(const ::InfoProcess::IPSItemPropertySeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, ::Ice::IntSeq&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int RemoveItemProperties(const ::InfoProcess::IPSItemPropertySeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, ::Ice::IntSeq&, const ::Ice::Context&) = 0;
};

class IPSBrowser : virtual public ::IceDelegate::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int GetProperties(const ::std::string&, const ::Ice::IntSeq&, ::InfoProcess::IPSItemPropertySeq&, ::Ice::IntSeq&, ::Ice::IntSeq&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int GetPropertyDesc(const ::Ice::IntSeq&, ::InfoProcess::PropertyDescDict&, ::Ice::IntSeq&, ::Ice::IntSeq&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int GetVariantTypeDesc(const ::InfoProcess::VARTYPESeq&, ::InfoProcess::VarTypeDescDict&, ::InfoProcess::VARTYPESeq&, ::Ice::IntSeq&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int Browse(const ::std::string&, ::InfoProcess::IPSBROWSEFILTER, const ::std::string&, bool, const ::Ice::IntSeq&, ::InfoProcess::IPSBrowseElementSeq&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int Browse4Seq(const ::Ice::StringSeq&, ::InfoProcess::IPSBROWSEFILTER, const ::std::string&, bool, const ::Ice::IntSeq&, ::InfoProcess::IPSBrowseElementSeq&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int GetItemIDsByItemProperty(const ::std::string&, ::InfoProcess::IPSCMPOP, const ::Ice::IntSeq&, const ::InfoProcess::IPSCMPTYPESeq&, const ::InfoProcess::VariantSeq&, ::Ice::StringSeq&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int GetItemStatesByItemProperty(const ::std::string&, ::InfoProcess::IPSCMPOP, const ::Ice::IntSeq&, const ::InfoProcess::IPSCMPTYPESeq&, const ::InfoProcess::VariantSeq&, ::Ice::Long, ::Ice::Long, ::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int GetItemStatesByItemState(const ::std::string&, ::InfoProcess::IPSCMPOP, const ::InfoProcess::IPSItemStateSeq&, const ::InfoProcess::IPSCMPTYPESeq&, ::Ice::Long, ::Ice::Long, ::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&) = 0;
};

class IPSAlarmMng : virtual public ::IceDelegate::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int ReadAlarm(const ::Ice::StringSeq&, ::InfoProcess::IPSAlarmItemSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int ConfirmAlarm(const ::std::string&, ::Ice::Int&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int BatchConfirmAlarm(const ::Ice::StringSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int DeleteAlarm(const ::std::string&, ::Ice::Int&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int BatchDeleteAlarm(const ::Ice::StringSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int GetCurAlarm(::InfoProcess::IPSAlarmItemSeq&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int ReportAlarm(const ::InfoProcess::IPSAlarmItemSeq&, const ::Ice::Context&) = 0;
};

class IPSLoginMng : virtual public ::IceDelegate::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int OperatorLogin(const ::std::string&, const ::std::string&, ::InfoProcess::IPSLOGINTYPE, ::std::string&, ::Ice::Long&, ::InfoProcess::IPSLoginCfgInfo&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int OperatorLogout(const ::Ice::Context&) = 0;

    virtual ::Ice::Int DeliverLogin(const ::std::string&, const ::std::string&, const ::std::string&, const ::std::string&, ::InfoProcess::IPSLOGINTYPE, const ::std::string&, ::std::string&, ::Ice::Long&, ::InfoProcess::IPSLoginCfgInfo&, const ::Ice::Context&) = 0;
};

class IPSControlCmdMng : virtual public ::IceDelegate::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int Write(const ::InfoProcess::IPSItemDefSeq&, ::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&) = 0;
};

class IPSSupportMng : virtual public ::IceDelegate::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int EnumObj(const ::std::string&, const ::std::string&, ::InfoProcess::IPSRecordset&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int AddObj(const ::std::string&, const ::InfoProcess::IPSRecordset&, ::InfoProcess::IPSRecordset&, ::Ice::IntSeq&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int ModifyObj(const ::std::string&, const ::InfoProcess::IPSRecordset&, ::InfoProcess::IPSRecordset&, ::Ice::IntSeq&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int DelObj(const ::std::string&, const ::InfoProcess::IPSRecordset&, ::InfoProcess::IPSRecordset&, ::Ice::IntSeq&, const ::Ice::Context&) = 0;
};

class IPSStatePublisher : virtual public ::IceDelegate::InfoProcess::IPSInterface
{
public:

    virtual void ReportItemState(const ::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&) = 0;
};

class IPSAlarmPublisher : virtual public ::IceDelegate::InfoProcess::IPSInterface
{
public:

    virtual void ReportAlarm(const ::InfoProcess::IPSAlarmItemSeq&, ::InfoProcess::IPSOBJOPERATIONTYPE, const ::Ice::Context&) = 0;
};

class IPSItemDefPublisher : virtual public ::IceDelegate::InfoProcess::IPSInterface
{
public:

    virtual void ReportItemDef(const ::InfoProcess::IPSItemDefSeq&, ::InfoProcess::IPSOBJOPERATIONTYPE, const ::Ice::Context&) = 0;
};

class IPSItemPropPublisher : virtual public ::IceDelegate::InfoProcess::IPSInterface
{
public:

    virtual void ReportItemProp(const ::InfoProcess::IPSItemPropertySeq&, ::InfoProcess::IPSOBJOPERATIONTYPE, const ::Ice::Context&) = 0;
};

class IPSObjPublisher : virtual public ::IceDelegate::InfoProcess::IPSInterface
{
public:

    virtual void ReportObj(const ::InfoProcess::IPSRecordset&, const ::std::string&, ::InfoProcess::IPSOBJOPERATIONTYPE, const ::Ice::Context&) = 0;
};

class IPSBackupFile : virtual public ::IceDelegate::InfoProcess::IPSObject
{
public:
};

class IPSBackupMgt : virtual public ::IceDelegate::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int BackupOriginPacket(const ::Ice::ByteSeq&, ::Ice::Int, const ::Ice::Context&) = 0;

    virtual ::Ice::Int BackupFileData(const ::InfoProcess::IPSBackupFileSeq&, const ::Ice::Context&) = 0;
};

class IPSRestoreMgt : virtual public ::IceDelegate::InfoProcess::IPSInterface
{
public:

    virtual void RestoreFileData(const ::std::string&, ::Ice::Long, ::Ice::Long, ::InfoProcess::IPSBackupFileSeq&, const ::Ice::Context&) = 0;
};

class IPSDataIO : virtual public ::IceDelegate::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int Read(const ::Ice::StringSeq&, ::InfoProcess::IPSItemStateSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int Write(const ::InfoProcess::IPSItemStateSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&) = 0;
};

}

}

namespace IceDelegateM
{

namespace InfoProcess
{

class IPSEIDSet : virtual public ::IceDelegate::InfoProcess::IPSEIDSet,
		  virtual public ::IceDelegateM::InfoProcess::IPSObject
{
public:
};

class IPSAlarmItem : virtual public ::IceDelegate::InfoProcess::IPSAlarmItem,
		     virtual public ::IceDelegateM::InfoProcess::IPSObject
{
public:
};

class IPSBrowseElement : virtual public ::IceDelegate::InfoProcess::IPSBrowseElement,
			 virtual public ::IceDelegateM::Ice::Object
{
public:
};

class IPSBackupLogic : virtual public ::IceDelegate::InfoProcess::IPSBackupLogic,
		       virtual public ::IceDelegateM::Ice::Object
{
public:
};

class Agent : virtual public ::IceDelegate::InfoProcess::Agent,
	      virtual public ::IceDelegateM::Ice::Object
{
public:
};

class IPSInterface : virtual public ::IceDelegate::InfoProcess::IPSInterface,
		     virtual public ::IceDelegateM::Ice::Object
{
public:
};

class IPSServer : virtual public ::IceDelegate::InfoProcess::IPSServer,
		  virtual public ::IceDelegateM::InfoProcess::IPSInterface
{
public:
};

class IPSBackupLogicMgt : virtual public ::IceDelegate::InfoProcess::IPSBackupLogicMgt,
			  virtual public ::IceDelegateM::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int UpdateLogic(const ::InfoProcess::IPSBackupLogicPtr&, const ::Ice::Context&);

    virtual ::Ice::Int CheckLogicValid(const ::InfoProcess::IPSBackupLogicPtr&, const ::Ice::Context&);
};

class IPSItemStateMgt : virtual public ::IceDelegate::InfoProcess::IPSItemStateMgt,
			virtual public ::IceDelegateM::InfoProcess::IPSInterface
{
public:

    virtual void UpdateItemState(const ::InfoProcess::IPSItemStatePtr&, const ::Ice::Context&);

    virtual void UpdateBatchItemStates(const ::std::pair<const ::InfoProcess::IPSItemStatePtr*, const ::InfoProcess::IPSItemStatePtr*>&, const ::Ice::Context&);

    virtual ::Ice::Int GetAllItemStates(::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&);

    virtual ::Ice::Int GetSpecfiedItemStates(const ::Ice::StringSeq&, ::InfoProcess::IPSItemStateSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);
};

class IPSItemMgt : virtual public ::IceDelegate::InfoProcess::IPSItemMgt,
		   virtual public ::IceDelegateM::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int AddItems(const ::InfoProcess::IPSItemDefSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int ModifyItems(const ::InfoProcess::IPSItemDefSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int RemoveItems(const ::Ice::StringSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);
};

class IPSSysStateMng : virtual public ::IceDelegate::InfoProcess::IPSSysStateMng,
		       virtual public ::IceDelegateM::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int GetCurSysState(::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&);
};

class IPSItemPropertyMgt : virtual public ::IceDelegate::InfoProcess::IPSItemPropertyMgt,
			   virtual public ::IceDelegateM::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int AddItemProperties(const ::InfoProcess::IPSItemPropertySeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int ModifyItemProperties(const ::InfoProcess::IPSItemPropertySeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int RemoveItemProperties(const ::InfoProcess::IPSItemPropertySeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, ::Ice::IntSeq&, const ::Ice::Context&);
};

class IPSBrowser : virtual public ::IceDelegate::InfoProcess::IPSBrowser,
		   virtual public ::IceDelegateM::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int GetProperties(const ::std::string&, const ::Ice::IntSeq&, ::InfoProcess::IPSItemPropertySeq&, ::Ice::IntSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int GetPropertyDesc(const ::Ice::IntSeq&, ::InfoProcess::PropertyDescDict&, ::Ice::IntSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int GetVariantTypeDesc(const ::InfoProcess::VARTYPESeq&, ::InfoProcess::VarTypeDescDict&, ::InfoProcess::VARTYPESeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int Browse(const ::std::string&, ::InfoProcess::IPSBROWSEFILTER, const ::std::string&, bool, const ::Ice::IntSeq&, ::InfoProcess::IPSBrowseElementSeq&, const ::Ice::Context&);

    virtual ::Ice::Int Browse4Seq(const ::Ice::StringSeq&, ::InfoProcess::IPSBROWSEFILTER, const ::std::string&, bool, const ::Ice::IntSeq&, ::InfoProcess::IPSBrowseElementSeq&, const ::Ice::Context&);

    virtual ::Ice::Int GetItemIDsByItemProperty(const ::std::string&, ::InfoProcess::IPSCMPOP, const ::Ice::IntSeq&, const ::InfoProcess::IPSCMPTYPESeq&, const ::InfoProcess::VariantSeq&, ::Ice::StringSeq&, const ::Ice::Context&);

    virtual ::Ice::Int GetItemStatesByItemProperty(const ::std::string&, ::InfoProcess::IPSCMPOP, const ::Ice::IntSeq&, const ::InfoProcess::IPSCMPTYPESeq&, const ::InfoProcess::VariantSeq&, ::Ice::Long, ::Ice::Long, ::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&);

    virtual ::Ice::Int GetItemStatesByItemState(const ::std::string&, ::InfoProcess::IPSCMPOP, const ::InfoProcess::IPSItemStateSeq&, const ::InfoProcess::IPSCMPTYPESeq&, ::Ice::Long, ::Ice::Long, ::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&);
};

class IPSAlarmMng : virtual public ::IceDelegate::InfoProcess::IPSAlarmMng,
		    virtual public ::IceDelegateM::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int ReadAlarm(const ::Ice::StringSeq&, ::InfoProcess::IPSAlarmItemSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int ConfirmAlarm(const ::std::string&, ::Ice::Int&, const ::Ice::Context&);

    virtual ::Ice::Int BatchConfirmAlarm(const ::Ice::StringSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int DeleteAlarm(const ::std::string&, ::Ice::Int&, const ::Ice::Context&);

    virtual ::Ice::Int BatchDeleteAlarm(const ::Ice::StringSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int GetCurAlarm(::InfoProcess::IPSAlarmItemSeq&, const ::Ice::Context&);

    virtual ::Ice::Int ReportAlarm(const ::InfoProcess::IPSAlarmItemSeq&, const ::Ice::Context&);
};

class IPSLoginMng : virtual public ::IceDelegate::InfoProcess::IPSLoginMng,
		    virtual public ::IceDelegateM::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int OperatorLogin(const ::std::string&, const ::std::string&, ::InfoProcess::IPSLOGINTYPE, ::std::string&, ::Ice::Long&, ::InfoProcess::IPSLoginCfgInfo&, const ::Ice::Context&);

    virtual ::Ice::Int OperatorLogout(const ::Ice::Context&);

    virtual ::Ice::Int DeliverLogin(const ::std::string&, const ::std::string&, const ::std::string&, const ::std::string&, ::InfoProcess::IPSLOGINTYPE, const ::std::string&, ::std::string&, ::Ice::Long&, ::InfoProcess::IPSLoginCfgInfo&, const ::Ice::Context&);
};

class IPSControlCmdMng : virtual public ::IceDelegate::InfoProcess::IPSControlCmdMng,
			 virtual public ::IceDelegateM::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int Write(const ::InfoProcess::IPSItemDefSeq&, ::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&);
};

class IPSSupportMng : virtual public ::IceDelegate::InfoProcess::IPSSupportMng,
		      virtual public ::IceDelegateM::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int EnumObj(const ::std::string&, const ::std::string&, ::InfoProcess::IPSRecordset&, const ::Ice::Context&);

    virtual ::Ice::Int AddObj(const ::std::string&, const ::InfoProcess::IPSRecordset&, ::InfoProcess::IPSRecordset&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int ModifyObj(const ::std::string&, const ::InfoProcess::IPSRecordset&, ::InfoProcess::IPSRecordset&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int DelObj(const ::std::string&, const ::InfoProcess::IPSRecordset&, ::InfoProcess::IPSRecordset&, ::Ice::IntSeq&, const ::Ice::Context&);
};

class IPSStatePublisher : virtual public ::IceDelegate::InfoProcess::IPSStatePublisher,
			  virtual public ::IceDelegateM::InfoProcess::IPSInterface
{
public:

    virtual void ReportItemState(const ::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&);
};

class IPSAlarmPublisher : virtual public ::IceDelegate::InfoProcess::IPSAlarmPublisher,
			  virtual public ::IceDelegateM::InfoProcess::IPSInterface
{
public:

    virtual void ReportAlarm(const ::InfoProcess::IPSAlarmItemSeq&, ::InfoProcess::IPSOBJOPERATIONTYPE, const ::Ice::Context&);
};

class IPSItemDefPublisher : virtual public ::IceDelegate::InfoProcess::IPSItemDefPublisher,
			    virtual public ::IceDelegateM::InfoProcess::IPSInterface
{
public:

    virtual void ReportItemDef(const ::InfoProcess::IPSItemDefSeq&, ::InfoProcess::IPSOBJOPERATIONTYPE, const ::Ice::Context&);
};

class IPSItemPropPublisher : virtual public ::IceDelegate::InfoProcess::IPSItemPropPublisher,
			     virtual public ::IceDelegateM::InfoProcess::IPSInterface
{
public:

    virtual void ReportItemProp(const ::InfoProcess::IPSItemPropertySeq&, ::InfoProcess::IPSOBJOPERATIONTYPE, const ::Ice::Context&);
};

class IPSObjPublisher : virtual public ::IceDelegate::InfoProcess::IPSObjPublisher,
			virtual public ::IceDelegateM::InfoProcess::IPSInterface
{
public:

    virtual void ReportObj(const ::InfoProcess::IPSRecordset&, const ::std::string&, ::InfoProcess::IPSOBJOPERATIONTYPE, const ::Ice::Context&);
};

class IPSBackupFile : virtual public ::IceDelegate::InfoProcess::IPSBackupFile,
		      virtual public ::IceDelegateM::InfoProcess::IPSObject
{
public:
};

class IPSBackupMgt : virtual public ::IceDelegate::InfoProcess::IPSBackupMgt,
		     virtual public ::IceDelegateM::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int BackupOriginPacket(const ::Ice::ByteSeq&, ::Ice::Int, const ::Ice::Context&);

    virtual ::Ice::Int BackupFileData(const ::InfoProcess::IPSBackupFileSeq&, const ::Ice::Context&);
};

class IPSRestoreMgt : virtual public ::IceDelegate::InfoProcess::IPSRestoreMgt,
		      virtual public ::IceDelegateM::InfoProcess::IPSInterface
{
public:

    virtual void RestoreFileData(const ::std::string&, ::Ice::Long, ::Ice::Long, ::InfoProcess::IPSBackupFileSeq&, const ::Ice::Context&);
};

class IPSDataIO : virtual public ::IceDelegate::InfoProcess::IPSDataIO,
		  virtual public ::IceDelegateM::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int Read(const ::Ice::StringSeq&, ::InfoProcess::IPSItemStateSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int Write(const ::InfoProcess::IPSItemStateSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);
};

}

}

namespace IceDelegateD
{

namespace InfoProcess
{

class IPSEIDSet : virtual public ::IceDelegate::InfoProcess::IPSEIDSet,
		  virtual public ::IceDelegateD::InfoProcess::IPSObject
{
public:
};

class IPSAlarmItem : virtual public ::IceDelegate::InfoProcess::IPSAlarmItem,
		     virtual public ::IceDelegateD::InfoProcess::IPSObject
{
public:
};

class IPSBrowseElement : virtual public ::IceDelegate::InfoProcess::IPSBrowseElement,
			 virtual public ::IceDelegateD::Ice::Object
{
public:
};

class IPSBackupLogic : virtual public ::IceDelegate::InfoProcess::IPSBackupLogic,
		       virtual public ::IceDelegateD::Ice::Object
{
public:
};

class Agent : virtual public ::IceDelegate::InfoProcess::Agent,
	      virtual public ::IceDelegateD::Ice::Object
{
public:
};

class IPSInterface : virtual public ::IceDelegate::InfoProcess::IPSInterface,
		     virtual public ::IceDelegateD::Ice::Object
{
public:
};

class IPSServer : virtual public ::IceDelegate::InfoProcess::IPSServer,
		  virtual public ::IceDelegateD::InfoProcess::IPSInterface
{
public:
};

class IPSBackupLogicMgt : virtual public ::IceDelegate::InfoProcess::IPSBackupLogicMgt,
			  virtual public ::IceDelegateD::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int UpdateLogic(const ::InfoProcess::IPSBackupLogicPtr&, const ::Ice::Context&);

    virtual ::Ice::Int CheckLogicValid(const ::InfoProcess::IPSBackupLogicPtr&, const ::Ice::Context&);
};

class IPSItemStateMgt : virtual public ::IceDelegate::InfoProcess::IPSItemStateMgt,
			virtual public ::IceDelegateD::InfoProcess::IPSInterface
{
public:

    virtual void UpdateItemState(const ::InfoProcess::IPSItemStatePtr&, const ::Ice::Context&);

    virtual void UpdateBatchItemStates(const ::std::pair<const ::InfoProcess::IPSItemStatePtr*, const ::InfoProcess::IPSItemStatePtr*>&, const ::Ice::Context&);

    virtual ::Ice::Int GetAllItemStates(::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&);

    virtual ::Ice::Int GetSpecfiedItemStates(const ::Ice::StringSeq&, ::InfoProcess::IPSItemStateSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);
};

class IPSItemMgt : virtual public ::IceDelegate::InfoProcess::IPSItemMgt,
		   virtual public ::IceDelegateD::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int AddItems(const ::InfoProcess::IPSItemDefSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int ModifyItems(const ::InfoProcess::IPSItemDefSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int RemoveItems(const ::Ice::StringSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);
};

class IPSSysStateMng : virtual public ::IceDelegate::InfoProcess::IPSSysStateMng,
		       virtual public ::IceDelegateD::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int GetCurSysState(::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&);
};

class IPSItemPropertyMgt : virtual public ::IceDelegate::InfoProcess::IPSItemPropertyMgt,
			   virtual public ::IceDelegateD::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int AddItemProperties(const ::InfoProcess::IPSItemPropertySeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int ModifyItemProperties(const ::InfoProcess::IPSItemPropertySeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int RemoveItemProperties(const ::InfoProcess::IPSItemPropertySeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, ::Ice::IntSeq&, const ::Ice::Context&);
};

class IPSBrowser : virtual public ::IceDelegate::InfoProcess::IPSBrowser,
		   virtual public ::IceDelegateD::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int GetProperties(const ::std::string&, const ::Ice::IntSeq&, ::InfoProcess::IPSItemPropertySeq&, ::Ice::IntSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int GetPropertyDesc(const ::Ice::IntSeq&, ::InfoProcess::PropertyDescDict&, ::Ice::IntSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int GetVariantTypeDesc(const ::InfoProcess::VARTYPESeq&, ::InfoProcess::VarTypeDescDict&, ::InfoProcess::VARTYPESeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int Browse(const ::std::string&, ::InfoProcess::IPSBROWSEFILTER, const ::std::string&, bool, const ::Ice::IntSeq&, ::InfoProcess::IPSBrowseElementSeq&, const ::Ice::Context&);

    virtual ::Ice::Int Browse4Seq(const ::Ice::StringSeq&, ::InfoProcess::IPSBROWSEFILTER, const ::std::string&, bool, const ::Ice::IntSeq&, ::InfoProcess::IPSBrowseElementSeq&, const ::Ice::Context&);

    virtual ::Ice::Int GetItemIDsByItemProperty(const ::std::string&, ::InfoProcess::IPSCMPOP, const ::Ice::IntSeq&, const ::InfoProcess::IPSCMPTYPESeq&, const ::InfoProcess::VariantSeq&, ::Ice::StringSeq&, const ::Ice::Context&);

    virtual ::Ice::Int GetItemStatesByItemProperty(const ::std::string&, ::InfoProcess::IPSCMPOP, const ::Ice::IntSeq&, const ::InfoProcess::IPSCMPTYPESeq&, const ::InfoProcess::VariantSeq&, ::Ice::Long, ::Ice::Long, ::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&);

    virtual ::Ice::Int GetItemStatesByItemState(const ::std::string&, ::InfoProcess::IPSCMPOP, const ::InfoProcess::IPSItemStateSeq&, const ::InfoProcess::IPSCMPTYPESeq&, ::Ice::Long, ::Ice::Long, ::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&);
};

class IPSAlarmMng : virtual public ::IceDelegate::InfoProcess::IPSAlarmMng,
		    virtual public ::IceDelegateD::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int ReadAlarm(const ::Ice::StringSeq&, ::InfoProcess::IPSAlarmItemSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int ConfirmAlarm(const ::std::string&, ::Ice::Int&, const ::Ice::Context&);

    virtual ::Ice::Int BatchConfirmAlarm(const ::Ice::StringSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int DeleteAlarm(const ::std::string&, ::Ice::Int&, const ::Ice::Context&);

    virtual ::Ice::Int BatchDeleteAlarm(const ::Ice::StringSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int GetCurAlarm(::InfoProcess::IPSAlarmItemSeq&, const ::Ice::Context&);

    virtual ::Ice::Int ReportAlarm(const ::InfoProcess::IPSAlarmItemSeq&, const ::Ice::Context&);
};

class IPSLoginMng : virtual public ::IceDelegate::InfoProcess::IPSLoginMng,
		    virtual public ::IceDelegateD::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int OperatorLogin(const ::std::string&, const ::std::string&, ::InfoProcess::IPSLOGINTYPE, ::std::string&, ::Ice::Long&, ::InfoProcess::IPSLoginCfgInfo&, const ::Ice::Context&);

    virtual ::Ice::Int OperatorLogout(const ::Ice::Context&);

    virtual ::Ice::Int DeliverLogin(const ::std::string&, const ::std::string&, const ::std::string&, const ::std::string&, ::InfoProcess::IPSLOGINTYPE, const ::std::string&, ::std::string&, ::Ice::Long&, ::InfoProcess::IPSLoginCfgInfo&, const ::Ice::Context&);
};

class IPSControlCmdMng : virtual public ::IceDelegate::InfoProcess::IPSControlCmdMng,
			 virtual public ::IceDelegateD::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int Write(const ::InfoProcess::IPSItemDefSeq&, ::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&);
};

class IPSSupportMng : virtual public ::IceDelegate::InfoProcess::IPSSupportMng,
		      virtual public ::IceDelegateD::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int EnumObj(const ::std::string&, const ::std::string&, ::InfoProcess::IPSRecordset&, const ::Ice::Context&);

    virtual ::Ice::Int AddObj(const ::std::string&, const ::InfoProcess::IPSRecordset&, ::InfoProcess::IPSRecordset&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int ModifyObj(const ::std::string&, const ::InfoProcess::IPSRecordset&, ::InfoProcess::IPSRecordset&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int DelObj(const ::std::string&, const ::InfoProcess::IPSRecordset&, ::InfoProcess::IPSRecordset&, ::Ice::IntSeq&, const ::Ice::Context&);
};

class IPSStatePublisher : virtual public ::IceDelegate::InfoProcess::IPSStatePublisher,
			  virtual public ::IceDelegateD::InfoProcess::IPSInterface
{
public:

    virtual void ReportItemState(const ::InfoProcess::IPSItemStateSeq&, const ::Ice::Context&);
};

class IPSAlarmPublisher : virtual public ::IceDelegate::InfoProcess::IPSAlarmPublisher,
			  virtual public ::IceDelegateD::InfoProcess::IPSInterface
{
public:

    virtual void ReportAlarm(const ::InfoProcess::IPSAlarmItemSeq&, ::InfoProcess::IPSOBJOPERATIONTYPE, const ::Ice::Context&);
};

class IPSItemDefPublisher : virtual public ::IceDelegate::InfoProcess::IPSItemDefPublisher,
			    virtual public ::IceDelegateD::InfoProcess::IPSInterface
{
public:

    virtual void ReportItemDef(const ::InfoProcess::IPSItemDefSeq&, ::InfoProcess::IPSOBJOPERATIONTYPE, const ::Ice::Context&);
};

class IPSItemPropPublisher : virtual public ::IceDelegate::InfoProcess::IPSItemPropPublisher,
			     virtual public ::IceDelegateD::InfoProcess::IPSInterface
{
public:

    virtual void ReportItemProp(const ::InfoProcess::IPSItemPropertySeq&, ::InfoProcess::IPSOBJOPERATIONTYPE, const ::Ice::Context&);
};

class IPSObjPublisher : virtual public ::IceDelegate::InfoProcess::IPSObjPublisher,
			virtual public ::IceDelegateD::InfoProcess::IPSInterface
{
public:

    virtual void ReportObj(const ::InfoProcess::IPSRecordset&, const ::std::string&, ::InfoProcess::IPSOBJOPERATIONTYPE, const ::Ice::Context&);
};

class IPSBackupFile : virtual public ::IceDelegate::InfoProcess::IPSBackupFile,
		      virtual public ::IceDelegateD::InfoProcess::IPSObject
{
public:
};

class IPSBackupMgt : virtual public ::IceDelegate::InfoProcess::IPSBackupMgt,
		     virtual public ::IceDelegateD::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int BackupOriginPacket(const ::Ice::ByteSeq&, ::Ice::Int, const ::Ice::Context&);

    virtual ::Ice::Int BackupFileData(const ::InfoProcess::IPSBackupFileSeq&, const ::Ice::Context&);
};

class IPSRestoreMgt : virtual public ::IceDelegate::InfoProcess::IPSRestoreMgt,
		      virtual public ::IceDelegateD::InfoProcess::IPSInterface
{
public:

    virtual void RestoreFileData(const ::std::string&, ::Ice::Long, ::Ice::Long, ::InfoProcess::IPSBackupFileSeq&, const ::Ice::Context&);
};

class IPSDataIO : virtual public ::IceDelegate::InfoProcess::IPSDataIO,
		  virtual public ::IceDelegateD::InfoProcess::IPSInterface
{
public:

    virtual ::Ice::Int Read(const ::Ice::StringSeq&, ::InfoProcess::IPSItemStateSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);

    virtual ::Ice::Int Write(const ::InfoProcess::IPSItemStateSeq&, ::Ice::StringSeq&, ::Ice::IntSeq&, const ::Ice::Context&);
};

}

}

namespace InfoProcess
{

class IPSEIDSet : virtual public ::InfoProcess::IPSObject
{
public:

    typedef IPSEIDSetPrx ProxyType;
    typedef IPSEIDSetPtr PointerType;
    
    IPSEIDSet() {}
    IPSEIDSet(const ::std::string&, const ::std::string&, const ::std::string&, ::Ice::Long);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::std::string sEID;
    ::std::string sUserDN;
    ::std::string sPwd;
    ::Ice::Long lExpiredDate;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();
};

static ::InfoProcess::IPSEIDSet __IPSEIDSet_init;

void __patch__IPSEIDSetPtr(void*, ::Ice::ObjectPtr&);

class IPSAlarmItem : virtual public ::InfoProcess::IPSObject
{
public:

    typedef IPSAlarmItemPrx ProxyType;
    typedef IPSAlarmItemPtr PointerType;
    
    IPSAlarmItem() {}
    IPSAlarmItem(const ::std::string&, const ::std::string&, ::InfoProcess::VARTYPE, const ::InfoProcess::VariantPtr&, ::Ice::Int, ::Ice::Int, ::Ice::Long, ::Ice::Long, ::Ice::Long, const ::std::string&, const ::std::string&);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void __incRef();
    virtual void __decRef();
    virtual void __addObject(::IceInternal::GCCountMap&);
    virtual bool __usesClasses();
    virtual void __gcReachable(::IceInternal::GCCountMap&) const;
    virtual void __gcClear();
    ::std::string sAlarmUUID;
    ::std::string sItemID;
    ::InfoProcess::VARTYPE vType;
    ::InfoProcess::VariantPtr vValue;
    ::Ice::Int iLevel;
    ::Ice::Int iNumber;
    ::Ice::Long lStart;
    ::Ice::Long lEnd;
    ::Ice::Long lConfirmed;
    ::std::string sConfirmer;
    ::std::string sDescription;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();
};

void __patch__IPSAlarmItemPtr(void*, ::Ice::ObjectPtr&);

class IPSBrowseElement : virtual public ::Ice::Object
{
public:

    typedef IPSBrowseElementPrx ProxyType;
    typedef IPSBrowseElementPtr PointerType;
    
    IPSBrowseElement() {}
    IPSBrowseElement(const ::std::string&, const ::InfoProcess::IPSItemDefPtr&, const ::InfoProcess::IPSItemPropertySeq&);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void __incRef();
    virtual void __decRef();
    virtual void __addObject(::IceInternal::GCCountMap&);
    virtual bool __usesClasses();
    virtual void __gcReachable(::IceInternal::GCCountMap&) const;
    virtual void __gcClear();
    ::std::string szItemID;
    ::InfoProcess::IPSItemDefPtr ItemDef;
    ::InfoProcess::IPSItemPropertySeq ItemProperties;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();
};

void __patch__IPSBrowseElementPtr(void*, ::Ice::ObjectPtr&);

class IPSBackupLogic : virtual public ::Ice::Object
{
public:

    typedef IPSBackupLogicPrx ProxyType;
    typedef IPSBackupLogicPtr PointerType;
    
    IPSBackupLogic() {}
    explicit IPSBackupLogic(const ::std::string&);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::std::string szBody;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();
};

void __patch__IPSBackupLogicPtr(void*, ::Ice::ObjectPtr&);

class Agent : virtual public ::Ice::Object
{
public:

    typedef AgentPrx ProxyType;
    typedef AgentPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__AgentPtr(void*, ::Ice::ObjectPtr&);

class IPSInterface : virtual public ::Ice::Object
{
public:

    typedef IPSInterfacePrx ProxyType;
    typedef IPSInterfacePtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__IPSInterfacePtr(void*, ::Ice::ObjectPtr&);

class IPSServer : virtual public ::InfoProcess::IPSInterface
{
public:

    typedef IPSServerPrx ProxyType;
    typedef IPSServerPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__IPSServerPtr(void*, ::Ice::ObjectPtr&);

class IPSBackupLogicMgt : virtual public ::InfoProcess::IPSInterface
{
public:

    typedef IPSBackupLogicMgtPrx ProxyType;
    typedef IPSBackupLogicMgtPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void UpdateLogic_async(const ::InfoProcess::AMD_IPSBackupLogicMgt_UpdateLogicPtr&, const ::InfoProcess::IPSBackupLogicPtr&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___UpdateLogic(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void CheckLogicValid_async(const ::InfoProcess::AMD_IPSBackupLogicMgt_CheckLogicValidPtr&, const ::InfoProcess::IPSBackupLogicPtr&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___CheckLogicValid(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__IPSBackupLogicMgtPtr(void*, ::Ice::ObjectPtr&);

class IPSItemStateMgt : virtual public ::InfoProcess::IPSInterface
{
public:

    typedef IPSItemStateMgtPrx ProxyType;
    typedef IPSItemStateMgtPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void UpdateItemState_async(const ::InfoProcess::AMD_IPSItemStateMgt_UpdateItemStatePtr&, const ::InfoProcess::IPSItemStatePtr&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___UpdateItemState(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void UpdateBatchItemStates_async(const ::InfoProcess::AMD_IPSItemStateMgt_UpdateBatchItemStatesPtr&, const ::std::pair<const ::InfoProcess::IPSItemStatePtr*, const ::InfoProcess::IPSItemStatePtr*>&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___UpdateBatchItemStates(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void GetAllItemStates_async(const ::InfoProcess::AMD_IPSItemStateMgt_GetAllItemStatesPtr&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___GetAllItemStates(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void GetSpecfiedItemStates_async(const ::InfoProcess::AMD_IPSItemStateMgt_GetSpecfiedItemStatesPtr&, const ::Ice::StringSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___GetSpecfiedItemStates(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__IPSItemStateMgtPtr(void*, ::Ice::ObjectPtr&);

class IPSItemMgt : virtual public ::InfoProcess::IPSInterface
{
public:

    typedef IPSItemMgtPrx ProxyType;
    typedef IPSItemMgtPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void AddItems_async(const ::InfoProcess::AMD_IPSItemMgt_AddItemsPtr&, const ::InfoProcess::IPSItemDefSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___AddItems(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void ModifyItems_async(const ::InfoProcess::AMD_IPSItemMgt_ModifyItemsPtr&, const ::InfoProcess::IPSItemDefSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___ModifyItems(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void RemoveItems_async(const ::InfoProcess::AMD_IPSItemMgt_RemoveItemsPtr&, const ::Ice::StringSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___RemoveItems(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__IPSItemMgtPtr(void*, ::Ice::ObjectPtr&);

class IPSSysStateMng : virtual public ::InfoProcess::IPSInterface
{
public:

    typedef IPSSysStateMngPrx ProxyType;
    typedef IPSSysStateMngPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void GetCurSysState_async(const ::InfoProcess::AMD_IPSSysStateMng_GetCurSysStatePtr&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___GetCurSysState(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__IPSSysStateMngPtr(void*, ::Ice::ObjectPtr&);

class IPSItemPropertyMgt : virtual public ::InfoProcess::IPSInterface
{
public:

    typedef IPSItemPropertyMgtPrx ProxyType;
    typedef IPSItemPropertyMgtPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void AddItemProperties_async(const ::InfoProcess::AMD_IPSItemPropertyMgt_AddItemPropertiesPtr&, const ::InfoProcess::IPSItemPropertySeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___AddItemProperties(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void ModifyItemProperties_async(const ::InfoProcess::AMD_IPSItemPropertyMgt_ModifyItemPropertiesPtr&, const ::InfoProcess::IPSItemPropertySeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___ModifyItemProperties(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void RemoveItemProperties_async(const ::InfoProcess::AMD_IPSItemPropertyMgt_RemoveItemPropertiesPtr&, const ::InfoProcess::IPSItemPropertySeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___RemoveItemProperties(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__IPSItemPropertyMgtPtr(void*, ::Ice::ObjectPtr&);

class IPSBrowser : virtual public ::InfoProcess::IPSInterface
{
public:

    typedef IPSBrowserPrx ProxyType;
    typedef IPSBrowserPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void GetProperties_async(const ::InfoProcess::AMD_IPSBrowser_GetPropertiesPtr&, const ::std::string&, const ::Ice::IntSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___GetProperties(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void GetPropertyDesc_async(const ::InfoProcess::AMD_IPSBrowser_GetPropertyDescPtr&, const ::Ice::IntSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___GetPropertyDesc(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void GetVariantTypeDesc_async(const ::InfoProcess::AMD_IPSBrowser_GetVariantTypeDescPtr&, const ::InfoProcess::VARTYPESeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___GetVariantTypeDesc(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void Browse_async(const ::InfoProcess::AMD_IPSBrowser_BrowsePtr&, const ::std::string&, ::InfoProcess::IPSBROWSEFILTER, const ::std::string&, bool, const ::Ice::IntSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___Browse(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void Browse4Seq_async(const ::InfoProcess::AMD_IPSBrowser_Browse4SeqPtr&, const ::Ice::StringSeq&, ::InfoProcess::IPSBROWSEFILTER, const ::std::string&, bool, const ::Ice::IntSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___Browse4Seq(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void GetItemIDsByItemProperty_async(const ::InfoProcess::AMD_IPSBrowser_GetItemIDsByItemPropertyPtr&, const ::std::string&, ::InfoProcess::IPSCMPOP, const ::Ice::IntSeq&, const ::InfoProcess::IPSCMPTYPESeq&, const ::InfoProcess::VariantSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___GetItemIDsByItemProperty(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void GetItemStatesByItemProperty_async(const ::InfoProcess::AMD_IPSBrowser_GetItemStatesByItemPropertyPtr&, const ::std::string&, ::InfoProcess::IPSCMPOP, const ::Ice::IntSeq&, const ::InfoProcess::IPSCMPTYPESeq&, const ::InfoProcess::VariantSeq&, ::Ice::Long, ::Ice::Long, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___GetItemStatesByItemProperty(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void GetItemStatesByItemState_async(const ::InfoProcess::AMD_IPSBrowser_GetItemStatesByItemStatePtr&, const ::std::string&, ::InfoProcess::IPSCMPOP, const ::InfoProcess::IPSItemStateSeq&, const ::InfoProcess::IPSCMPTYPESeq&, ::Ice::Long, ::Ice::Long, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___GetItemStatesByItemState(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__IPSBrowserPtr(void*, ::Ice::ObjectPtr&);

class IPSAlarmMng : virtual public ::InfoProcess::IPSInterface
{
public:

    typedef IPSAlarmMngPrx ProxyType;
    typedef IPSAlarmMngPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void ReadAlarm_async(const ::InfoProcess::AMD_IPSAlarmMng_ReadAlarmPtr&, const ::Ice::StringSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___ReadAlarm(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void ConfirmAlarm_async(const ::InfoProcess::AMD_IPSAlarmMng_ConfirmAlarmPtr&, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___ConfirmAlarm(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void BatchConfirmAlarm_async(const ::InfoProcess::AMD_IPSAlarmMng_BatchConfirmAlarmPtr&, const ::Ice::StringSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___BatchConfirmAlarm(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void DeleteAlarm_async(const ::InfoProcess::AMD_IPSAlarmMng_DeleteAlarmPtr&, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___DeleteAlarm(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void BatchDeleteAlarm_async(const ::InfoProcess::AMD_IPSAlarmMng_BatchDeleteAlarmPtr&, const ::Ice::StringSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___BatchDeleteAlarm(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void GetCurAlarm_async(const ::InfoProcess::AMD_IPSAlarmMng_GetCurAlarmPtr&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___GetCurAlarm(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void ReportAlarm_async(const ::InfoProcess::AMD_IPSAlarmMng_ReportAlarmPtr&, const ::InfoProcess::IPSAlarmItemSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___ReportAlarm(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__IPSAlarmMngPtr(void*, ::Ice::ObjectPtr&);

class IPSLoginMng : virtual public ::InfoProcess::IPSInterface
{
public:

    typedef IPSLoginMngPrx ProxyType;
    typedef IPSLoginMngPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::Ice::Int OperatorLogin(const ::std::string&, const ::std::string&, ::InfoProcess::IPSLOGINTYPE, ::std::string&, ::Ice::Long&, ::InfoProcess::IPSLoginCfgInfo&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___OperatorLogin(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::Int OperatorLogout(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___OperatorLogout(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::Int DeliverLogin(const ::std::string&, const ::std::string&, const ::std::string&, const ::std::string&, ::InfoProcess::IPSLOGINTYPE, const ::std::string&, ::std::string&, ::Ice::Long&, ::InfoProcess::IPSLoginCfgInfo&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___DeliverLogin(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__IPSLoginMngPtr(void*, ::Ice::ObjectPtr&);

class IPSControlCmdMng : virtual public ::InfoProcess::IPSInterface
{
public:

    typedef IPSControlCmdMngPrx ProxyType;
    typedef IPSControlCmdMngPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void Write_async(const ::InfoProcess::AMD_IPSControlCmdMng_WritePtr&, const ::InfoProcess::IPSItemDefSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___Write(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__IPSControlCmdMngPtr(void*, ::Ice::ObjectPtr&);

class IPSSupportMng : virtual public ::InfoProcess::IPSInterface
{
public:

    typedef IPSSupportMngPrx ProxyType;
    typedef IPSSupportMngPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void EnumObj_async(const ::InfoProcess::AMD_IPSSupportMng_EnumObjPtr&, const ::std::string&, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___EnumObj(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void AddObj_async(const ::InfoProcess::AMD_IPSSupportMng_AddObjPtr&, const ::std::string&, const ::InfoProcess::IPSRecordset&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___AddObj(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void ModifyObj_async(const ::InfoProcess::AMD_IPSSupportMng_ModifyObjPtr&, const ::std::string&, const ::InfoProcess::IPSRecordset&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___ModifyObj(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void DelObj_async(const ::InfoProcess::AMD_IPSSupportMng_DelObjPtr&, const ::std::string&, const ::InfoProcess::IPSRecordset&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___DelObj(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__IPSSupportMngPtr(void*, ::Ice::ObjectPtr&);

class IPSStatePublisher : virtual public ::InfoProcess::IPSInterface
{
public:

    typedef IPSStatePublisherPrx ProxyType;
    typedef IPSStatePublisherPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void ReportItemState(const ::InfoProcess::IPSItemStateSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___ReportItemState(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__IPSStatePublisherPtr(void*, ::Ice::ObjectPtr&);

class IPSAlarmPublisher : virtual public ::InfoProcess::IPSInterface
{
public:

    typedef IPSAlarmPublisherPrx ProxyType;
    typedef IPSAlarmPublisherPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void ReportAlarm(const ::InfoProcess::IPSAlarmItemSeq&, ::InfoProcess::IPSOBJOPERATIONTYPE, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___ReportAlarm(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__IPSAlarmPublisherPtr(void*, ::Ice::ObjectPtr&);

class IPSItemDefPublisher : virtual public ::InfoProcess::IPSInterface
{
public:

    typedef IPSItemDefPublisherPrx ProxyType;
    typedef IPSItemDefPublisherPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void ReportItemDef(const ::InfoProcess::IPSItemDefSeq&, ::InfoProcess::IPSOBJOPERATIONTYPE, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___ReportItemDef(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__IPSItemDefPublisherPtr(void*, ::Ice::ObjectPtr&);

class IPSItemPropPublisher : virtual public ::InfoProcess::IPSInterface
{
public:

    typedef IPSItemPropPublisherPrx ProxyType;
    typedef IPSItemPropPublisherPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void ReportItemProp(const ::InfoProcess::IPSItemPropertySeq&, ::InfoProcess::IPSOBJOPERATIONTYPE, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___ReportItemProp(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__IPSItemPropPublisherPtr(void*, ::Ice::ObjectPtr&);

class IPSObjPublisher : virtual public ::InfoProcess::IPSInterface
{
public:

    typedef IPSObjPublisherPrx ProxyType;
    typedef IPSObjPublisherPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void ReportObj(const ::InfoProcess::IPSRecordset&, const ::std::string&, ::InfoProcess::IPSOBJOPERATIONTYPE, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___ReportObj(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__IPSObjPublisherPtr(void*, ::Ice::ObjectPtr&);

class IPSBackupFile : virtual public ::InfoProcess::IPSObject
{
public:

    typedef IPSBackupFilePrx ProxyType;
    typedef IPSBackupFilePtr PointerType;
    
    IPSBackupFile() {}
    IPSBackupFile(const ::std::string&, const ::std::string&, const ::std::string&, const ::std::string&, ::Ice::Long, ::Ice::Long, ::Ice::Long, ::Ice::Long);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::std::string sBackuper;
    ::std::string sDataID;
    ::std::string sFileName;
    ::std::string sFilePath;
    ::Ice::Long lStartTime;
    ::Ice::Long lEndTime;
    ::Ice::Long lFileSize;
    ::Ice::Long lExpiredTime;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();
};

void __patch__IPSBackupFilePtr(void*, ::Ice::ObjectPtr&);

class IPSBackupMgt : virtual public ::InfoProcess::IPSInterface
{
public:

    typedef IPSBackupMgtPrx ProxyType;
    typedef IPSBackupMgtPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void BackupOriginPacket_async(const ::InfoProcess::AMD_IPSBackupMgt_BackupOriginPacketPtr&, const ::Ice::ByteSeq&, ::Ice::Int, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___BackupOriginPacket(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void BackupFileData_async(const ::InfoProcess::AMD_IPSBackupMgt_BackupFileDataPtr&, const ::InfoProcess::IPSBackupFileSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___BackupFileData(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__IPSBackupMgtPtr(void*, ::Ice::ObjectPtr&);

class IPSRestoreMgt : virtual public ::InfoProcess::IPSInterface
{
public:

    typedef IPSRestoreMgtPrx ProxyType;
    typedef IPSRestoreMgtPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void RestoreFileData_async(const ::InfoProcess::AMD_IPSRestoreMgt_RestoreFileDataPtr&, const ::std::string&, ::Ice::Long, ::Ice::Long, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___RestoreFileData(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__IPSRestoreMgtPtr(void*, ::Ice::ObjectPtr&);

class IPSDataIO : virtual public ::InfoProcess::IPSInterface
{
public:

    typedef IPSDataIOPrx ProxyType;
    typedef IPSDataIOPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void Read_async(const ::InfoProcess::AMD_IPSDataIO_ReadPtr&, const ::Ice::StringSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___Read(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void Write_async(const ::InfoProcess::AMD_IPSDataIO_WritePtr&, const ::InfoProcess::IPSItemStateSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___Write(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__IPSDataIOPtr(void*, ::Ice::ObjectPtr&);

}

#endif
