// **********************************************************************
//
// Copyright (c) 2003-2006 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.1.0
// Generated from file `IPSVariant.ice'

#ifndef __IPSVariant_h__
#define __IPSVariant_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>
#include <Ice/StreamF.h>
#include <Ice/BuiltinSequences.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 301
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

namespace IceProxy
{

namespace InfoProcess
{

class Variant;
bool operator==(const Variant&, const Variant&);
bool operator!=(const Variant&, const Variant&);
bool operator<(const Variant&, const Variant&);
bool operator<=(const Variant&, const Variant&);
bool operator>(const Variant&, const Variant&);
bool operator>=(const Variant&, const Variant&);

class VariantBoolean;
bool operator==(const VariantBoolean&, const VariantBoolean&);
bool operator!=(const VariantBoolean&, const VariantBoolean&);
bool operator<(const VariantBoolean&, const VariantBoolean&);
bool operator<=(const VariantBoolean&, const VariantBoolean&);
bool operator>(const VariantBoolean&, const VariantBoolean&);
bool operator>=(const VariantBoolean&, const VariantBoolean&);

class VariantByte;
bool operator==(const VariantByte&, const VariantByte&);
bool operator!=(const VariantByte&, const VariantByte&);
bool operator<(const VariantByte&, const VariantByte&);
bool operator<=(const VariantByte&, const VariantByte&);
bool operator>(const VariantByte&, const VariantByte&);
bool operator>=(const VariantByte&, const VariantByte&);

class VariantShort;
bool operator==(const VariantShort&, const VariantShort&);
bool operator!=(const VariantShort&, const VariantShort&);
bool operator<(const VariantShort&, const VariantShort&);
bool operator<=(const VariantShort&, const VariantShort&);
bool operator>(const VariantShort&, const VariantShort&);
bool operator>=(const VariantShort&, const VariantShort&);

class VariantInt;
bool operator==(const VariantInt&, const VariantInt&);
bool operator!=(const VariantInt&, const VariantInt&);
bool operator<(const VariantInt&, const VariantInt&);
bool operator<=(const VariantInt&, const VariantInt&);
bool operator>(const VariantInt&, const VariantInt&);
bool operator>=(const VariantInt&, const VariantInt&);

class VariantLong;
bool operator==(const VariantLong&, const VariantLong&);
bool operator!=(const VariantLong&, const VariantLong&);
bool operator<(const VariantLong&, const VariantLong&);
bool operator<=(const VariantLong&, const VariantLong&);
bool operator>(const VariantLong&, const VariantLong&);
bool operator>=(const VariantLong&, const VariantLong&);

class VariantFloat;
bool operator==(const VariantFloat&, const VariantFloat&);
bool operator!=(const VariantFloat&, const VariantFloat&);
bool operator<(const VariantFloat&, const VariantFloat&);
bool operator<=(const VariantFloat&, const VariantFloat&);
bool operator>(const VariantFloat&, const VariantFloat&);
bool operator>=(const VariantFloat&, const VariantFloat&);

class VariantDouble;
bool operator==(const VariantDouble&, const VariantDouble&);
bool operator!=(const VariantDouble&, const VariantDouble&);
bool operator<(const VariantDouble&, const VariantDouble&);
bool operator<=(const VariantDouble&, const VariantDouble&);
bool operator>(const VariantDouble&, const VariantDouble&);
bool operator>=(const VariantDouble&, const VariantDouble&);

class VariantString;
bool operator==(const VariantString&, const VariantString&);
bool operator!=(const VariantString&, const VariantString&);
bool operator<(const VariantString&, const VariantString&);
bool operator<=(const VariantString&, const VariantString&);
bool operator>(const VariantString&, const VariantString&);
bool operator>=(const VariantString&, const VariantString&);

class VariantCString;
bool operator==(const VariantCString&, const VariantCString&);
bool operator!=(const VariantCString&, const VariantCString&);
bool operator<(const VariantCString&, const VariantCString&);
bool operator<=(const VariantCString&, const VariantCString&);
bool operator>(const VariantCString&, const VariantCString&);
bool operator>=(const VariantCString&, const VariantCString&);

class VariantBlob;
bool operator==(const VariantBlob&, const VariantBlob&);
bool operator!=(const VariantBlob&, const VariantBlob&);
bool operator<(const VariantBlob&, const VariantBlob&);
bool operator<=(const VariantBlob&, const VariantBlob&);
bool operator>(const VariantBlob&, const VariantBlob&);
bool operator>=(const VariantBlob&, const VariantBlob&);

class VariantTime;
bool operator==(const VariantTime&, const VariantTime&);
bool operator!=(const VariantTime&, const VariantTime&);
bool operator<(const VariantTime&, const VariantTime&);
bool operator<=(const VariantTime&, const VariantTime&);
bool operator>(const VariantTime&, const VariantTime&);
bool operator>=(const VariantTime&, const VariantTime&);

class VariantShortVec;
bool operator==(const VariantShortVec&, const VariantShortVec&);
bool operator!=(const VariantShortVec&, const VariantShortVec&);
bool operator<(const VariantShortVec&, const VariantShortVec&);
bool operator<=(const VariantShortVec&, const VariantShortVec&);
bool operator>(const VariantShortVec&, const VariantShortVec&);
bool operator>=(const VariantShortVec&, const VariantShortVec&);

class VariantIntVec;
bool operator==(const VariantIntVec&, const VariantIntVec&);
bool operator!=(const VariantIntVec&, const VariantIntVec&);
bool operator<(const VariantIntVec&, const VariantIntVec&);
bool operator<=(const VariantIntVec&, const VariantIntVec&);
bool operator>(const VariantIntVec&, const VariantIntVec&);
bool operator>=(const VariantIntVec&, const VariantIntVec&);

class VariantLongVec;
bool operator==(const VariantLongVec&, const VariantLongVec&);
bool operator!=(const VariantLongVec&, const VariantLongVec&);
bool operator<(const VariantLongVec&, const VariantLongVec&);
bool operator<=(const VariantLongVec&, const VariantLongVec&);
bool operator>(const VariantLongVec&, const VariantLongVec&);
bool operator>=(const VariantLongVec&, const VariantLongVec&);

class VariantFloatVec;
bool operator==(const VariantFloatVec&, const VariantFloatVec&);
bool operator!=(const VariantFloatVec&, const VariantFloatVec&);
bool operator<(const VariantFloatVec&, const VariantFloatVec&);
bool operator<=(const VariantFloatVec&, const VariantFloatVec&);
bool operator>(const VariantFloatVec&, const VariantFloatVec&);
bool operator>=(const VariantFloatVec&, const VariantFloatVec&);

class VariantDoubleVec;
bool operator==(const VariantDoubleVec&, const VariantDoubleVec&);
bool operator!=(const VariantDoubleVec&, const VariantDoubleVec&);
bool operator<(const VariantDoubleVec&, const VariantDoubleVec&);
bool operator<=(const VariantDoubleVec&, const VariantDoubleVec&);
bool operator>(const VariantDoubleVec&, const VariantDoubleVec&);
bool operator>=(const VariantDoubleVec&, const VariantDoubleVec&);

class VariantVarVec;
bool operator==(const VariantVarVec&, const VariantVarVec&);
bool operator!=(const VariantVarVec&, const VariantVarVec&);
bool operator<(const VariantVarVec&, const VariantVarVec&);
bool operator<=(const VariantVarVec&, const VariantVarVec&);
bool operator>(const VariantVarVec&, const VariantVarVec&);
bool operator>=(const VariantVarVec&, const VariantVarVec&);

class VariantVarMap;
bool operator==(const VariantVarMap&, const VariantVarMap&);
bool operator!=(const VariantVarMap&, const VariantVarMap&);
bool operator<(const VariantVarMap&, const VariantVarMap&);
bool operator<=(const VariantVarMap&, const VariantVarMap&);
bool operator>(const VariantVarMap&, const VariantVarMap&);
bool operator>=(const VariantVarMap&, const VariantVarMap&);

}

}

namespace InfoProcess
{

class Variant;
bool operator==(const Variant&, const Variant&);
bool operator!=(const Variant&, const Variant&);
bool operator<(const Variant&, const Variant&);
bool operator<=(const Variant&, const Variant&);
bool operator>(const Variant&, const Variant&);
bool operator>=(const Variant&, const Variant&);

class VariantBoolean;
bool operator==(const VariantBoolean&, const VariantBoolean&);
bool operator!=(const VariantBoolean&, const VariantBoolean&);
bool operator<(const VariantBoolean&, const VariantBoolean&);
bool operator<=(const VariantBoolean&, const VariantBoolean&);
bool operator>(const VariantBoolean&, const VariantBoolean&);
bool operator>=(const VariantBoolean&, const VariantBoolean&);

class VariantByte;
bool operator==(const VariantByte&, const VariantByte&);
bool operator!=(const VariantByte&, const VariantByte&);
bool operator<(const VariantByte&, const VariantByte&);
bool operator<=(const VariantByte&, const VariantByte&);
bool operator>(const VariantByte&, const VariantByte&);
bool operator>=(const VariantByte&, const VariantByte&);

class VariantShort;
bool operator==(const VariantShort&, const VariantShort&);
bool operator!=(const VariantShort&, const VariantShort&);
bool operator<(const VariantShort&, const VariantShort&);
bool operator<=(const VariantShort&, const VariantShort&);
bool operator>(const VariantShort&, const VariantShort&);
bool operator>=(const VariantShort&, const VariantShort&);

class VariantInt;
bool operator==(const VariantInt&, const VariantInt&);
bool operator!=(const VariantInt&, const VariantInt&);
bool operator<(const VariantInt&, const VariantInt&);
bool operator<=(const VariantInt&, const VariantInt&);
bool operator>(const VariantInt&, const VariantInt&);
bool operator>=(const VariantInt&, const VariantInt&);

class VariantLong;
bool operator==(const VariantLong&, const VariantLong&);
bool operator!=(const VariantLong&, const VariantLong&);
bool operator<(const VariantLong&, const VariantLong&);
bool operator<=(const VariantLong&, const VariantLong&);
bool operator>(const VariantLong&, const VariantLong&);
bool operator>=(const VariantLong&, const VariantLong&);

class VariantFloat;
bool operator==(const VariantFloat&, const VariantFloat&);
bool operator!=(const VariantFloat&, const VariantFloat&);
bool operator<(const VariantFloat&, const VariantFloat&);
bool operator<=(const VariantFloat&, const VariantFloat&);
bool operator>(const VariantFloat&, const VariantFloat&);
bool operator>=(const VariantFloat&, const VariantFloat&);

class VariantDouble;
bool operator==(const VariantDouble&, const VariantDouble&);
bool operator!=(const VariantDouble&, const VariantDouble&);
bool operator<(const VariantDouble&, const VariantDouble&);
bool operator<=(const VariantDouble&, const VariantDouble&);
bool operator>(const VariantDouble&, const VariantDouble&);
bool operator>=(const VariantDouble&, const VariantDouble&);

class VariantString;
bool operator==(const VariantString&, const VariantString&);
bool operator!=(const VariantString&, const VariantString&);
bool operator<(const VariantString&, const VariantString&);
bool operator<=(const VariantString&, const VariantString&);
bool operator>(const VariantString&, const VariantString&);
bool operator>=(const VariantString&, const VariantString&);

class VariantCString;
bool operator==(const VariantCString&, const VariantCString&);
bool operator!=(const VariantCString&, const VariantCString&);
bool operator<(const VariantCString&, const VariantCString&);
bool operator<=(const VariantCString&, const VariantCString&);
bool operator>(const VariantCString&, const VariantCString&);
bool operator>=(const VariantCString&, const VariantCString&);

class VariantBlob;
bool operator==(const VariantBlob&, const VariantBlob&);
bool operator!=(const VariantBlob&, const VariantBlob&);
bool operator<(const VariantBlob&, const VariantBlob&);
bool operator<=(const VariantBlob&, const VariantBlob&);
bool operator>(const VariantBlob&, const VariantBlob&);
bool operator>=(const VariantBlob&, const VariantBlob&);

class VariantTime;
bool operator==(const VariantTime&, const VariantTime&);
bool operator!=(const VariantTime&, const VariantTime&);
bool operator<(const VariantTime&, const VariantTime&);
bool operator<=(const VariantTime&, const VariantTime&);
bool operator>(const VariantTime&, const VariantTime&);
bool operator>=(const VariantTime&, const VariantTime&);

class VariantShortVec;
bool operator==(const VariantShortVec&, const VariantShortVec&);
bool operator!=(const VariantShortVec&, const VariantShortVec&);
bool operator<(const VariantShortVec&, const VariantShortVec&);
bool operator<=(const VariantShortVec&, const VariantShortVec&);
bool operator>(const VariantShortVec&, const VariantShortVec&);
bool operator>=(const VariantShortVec&, const VariantShortVec&);

class VariantIntVec;
bool operator==(const VariantIntVec&, const VariantIntVec&);
bool operator!=(const VariantIntVec&, const VariantIntVec&);
bool operator<(const VariantIntVec&, const VariantIntVec&);
bool operator<=(const VariantIntVec&, const VariantIntVec&);
bool operator>(const VariantIntVec&, const VariantIntVec&);
bool operator>=(const VariantIntVec&, const VariantIntVec&);

class VariantLongVec;
bool operator==(const VariantLongVec&, const VariantLongVec&);
bool operator!=(const VariantLongVec&, const VariantLongVec&);
bool operator<(const VariantLongVec&, const VariantLongVec&);
bool operator<=(const VariantLongVec&, const VariantLongVec&);
bool operator>(const VariantLongVec&, const VariantLongVec&);
bool operator>=(const VariantLongVec&, const VariantLongVec&);

class VariantFloatVec;
bool operator==(const VariantFloatVec&, const VariantFloatVec&);
bool operator!=(const VariantFloatVec&, const VariantFloatVec&);
bool operator<(const VariantFloatVec&, const VariantFloatVec&);
bool operator<=(const VariantFloatVec&, const VariantFloatVec&);
bool operator>(const VariantFloatVec&, const VariantFloatVec&);
bool operator>=(const VariantFloatVec&, const VariantFloatVec&);

class VariantDoubleVec;
bool operator==(const VariantDoubleVec&, const VariantDoubleVec&);
bool operator!=(const VariantDoubleVec&, const VariantDoubleVec&);
bool operator<(const VariantDoubleVec&, const VariantDoubleVec&);
bool operator<=(const VariantDoubleVec&, const VariantDoubleVec&);
bool operator>(const VariantDoubleVec&, const VariantDoubleVec&);
bool operator>=(const VariantDoubleVec&, const VariantDoubleVec&);

class VariantVarVec;
bool operator==(const VariantVarVec&, const VariantVarVec&);
bool operator!=(const VariantVarVec&, const VariantVarVec&);
bool operator<(const VariantVarVec&, const VariantVarVec&);
bool operator<=(const VariantVarVec&, const VariantVarVec&);
bool operator>(const VariantVarVec&, const VariantVarVec&);
bool operator>=(const VariantVarVec&, const VariantVarVec&);

class VariantVarMap;
bool operator==(const VariantVarMap&, const VariantVarMap&);
bool operator!=(const VariantVarMap&, const VariantVarMap&);
bool operator<(const VariantVarMap&, const VariantVarMap&);
bool operator<=(const VariantVarMap&, const VariantVarMap&);
bool operator>(const VariantVarMap&, const VariantVarMap&);
bool operator>=(const VariantVarMap&, const VariantVarMap&);

}

namespace IceInternal
{

void incRef(::InfoProcess::Variant*);
void decRef(::InfoProcess::Variant*);

void incRef(::IceProxy::InfoProcess::Variant*);
void decRef(::IceProxy::InfoProcess::Variant*);

void incRef(::InfoProcess::VariantBoolean*);
void decRef(::InfoProcess::VariantBoolean*);

void incRef(::IceProxy::InfoProcess::VariantBoolean*);
void decRef(::IceProxy::InfoProcess::VariantBoolean*);

void incRef(::InfoProcess::VariantByte*);
void decRef(::InfoProcess::VariantByte*);

void incRef(::IceProxy::InfoProcess::VariantByte*);
void decRef(::IceProxy::InfoProcess::VariantByte*);

void incRef(::InfoProcess::VariantShort*);
void decRef(::InfoProcess::VariantShort*);

void incRef(::IceProxy::InfoProcess::VariantShort*);
void decRef(::IceProxy::InfoProcess::VariantShort*);

void incRef(::InfoProcess::VariantInt*);
void decRef(::InfoProcess::VariantInt*);

void incRef(::IceProxy::InfoProcess::VariantInt*);
void decRef(::IceProxy::InfoProcess::VariantInt*);

void incRef(::InfoProcess::VariantLong*);
void decRef(::InfoProcess::VariantLong*);

void incRef(::IceProxy::InfoProcess::VariantLong*);
void decRef(::IceProxy::InfoProcess::VariantLong*);

void incRef(::InfoProcess::VariantFloat*);
void decRef(::InfoProcess::VariantFloat*);

void incRef(::IceProxy::InfoProcess::VariantFloat*);
void decRef(::IceProxy::InfoProcess::VariantFloat*);

void incRef(::InfoProcess::VariantDouble*);
void decRef(::InfoProcess::VariantDouble*);

void incRef(::IceProxy::InfoProcess::VariantDouble*);
void decRef(::IceProxy::InfoProcess::VariantDouble*);

void incRef(::InfoProcess::VariantString*);
void decRef(::InfoProcess::VariantString*);

void incRef(::IceProxy::InfoProcess::VariantString*);
void decRef(::IceProxy::InfoProcess::VariantString*);

void incRef(::InfoProcess::VariantCString*);
void decRef(::InfoProcess::VariantCString*);

void incRef(::IceProxy::InfoProcess::VariantCString*);
void decRef(::IceProxy::InfoProcess::VariantCString*);

void incRef(::InfoProcess::VariantBlob*);
void decRef(::InfoProcess::VariantBlob*);

void incRef(::IceProxy::InfoProcess::VariantBlob*);
void decRef(::IceProxy::InfoProcess::VariantBlob*);

void incRef(::InfoProcess::VariantTime*);
void decRef(::InfoProcess::VariantTime*);

void incRef(::IceProxy::InfoProcess::VariantTime*);
void decRef(::IceProxy::InfoProcess::VariantTime*);

void incRef(::InfoProcess::VariantShortVec*);
void decRef(::InfoProcess::VariantShortVec*);

void incRef(::IceProxy::InfoProcess::VariantShortVec*);
void decRef(::IceProxy::InfoProcess::VariantShortVec*);

void incRef(::InfoProcess::VariantIntVec*);
void decRef(::InfoProcess::VariantIntVec*);

void incRef(::IceProxy::InfoProcess::VariantIntVec*);
void decRef(::IceProxy::InfoProcess::VariantIntVec*);

void incRef(::InfoProcess::VariantLongVec*);
void decRef(::InfoProcess::VariantLongVec*);

void incRef(::IceProxy::InfoProcess::VariantLongVec*);
void decRef(::IceProxy::InfoProcess::VariantLongVec*);

void incRef(::InfoProcess::VariantFloatVec*);
void decRef(::InfoProcess::VariantFloatVec*);

void incRef(::IceProxy::InfoProcess::VariantFloatVec*);
void decRef(::IceProxy::InfoProcess::VariantFloatVec*);

void incRef(::InfoProcess::VariantDoubleVec*);
void decRef(::InfoProcess::VariantDoubleVec*);

void incRef(::IceProxy::InfoProcess::VariantDoubleVec*);
void decRef(::IceProxy::InfoProcess::VariantDoubleVec*);

void incRef(::InfoProcess::VariantVarVec*);
void decRef(::InfoProcess::VariantVarVec*);

void incRef(::IceProxy::InfoProcess::VariantVarVec*);
void decRef(::IceProxy::InfoProcess::VariantVarVec*);

void incRef(::InfoProcess::VariantVarMap*);
void decRef(::InfoProcess::VariantVarMap*);

void incRef(::IceProxy::InfoProcess::VariantVarMap*);
void decRef(::IceProxy::InfoProcess::VariantVarMap*);

}

namespace InfoProcess
{

typedef ::IceInternal::Handle< ::InfoProcess::Variant> VariantPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::Variant> VariantPrx;

void __write(::IceInternal::BasicStream*, const VariantPrx&);
void __read(::IceInternal::BasicStream*, VariantPrx&);
void __write(::IceInternal::BasicStream*, const VariantPtr&);
void __patch__VariantPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const VariantPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const VariantPtr&);
void __decRefUnsafe(VariantPtr&);
void __clearHandleUnsafe(VariantPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::VariantBoolean> VariantBooleanPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::VariantBoolean> VariantBooleanPrx;

void __write(::IceInternal::BasicStream*, const VariantBooleanPrx&);
void __read(::IceInternal::BasicStream*, VariantBooleanPrx&);
void __write(::IceInternal::BasicStream*, const VariantBooleanPtr&);
void __patch__VariantBooleanPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const VariantBooleanPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const VariantBooleanPtr&);
void __decRefUnsafe(VariantBooleanPtr&);
void __clearHandleUnsafe(VariantBooleanPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::VariantByte> VariantBytePtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::VariantByte> VariantBytePrx;

void __write(::IceInternal::BasicStream*, const VariantBytePrx&);
void __read(::IceInternal::BasicStream*, VariantBytePrx&);
void __write(::IceInternal::BasicStream*, const VariantBytePtr&);
void __patch__VariantBytePtr(void*, ::Ice::ObjectPtr&);

void __addObject(const VariantBytePtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const VariantBytePtr&);
void __decRefUnsafe(VariantBytePtr&);
void __clearHandleUnsafe(VariantBytePtr&);

typedef ::IceInternal::Handle< ::InfoProcess::VariantShort> VariantShortPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::VariantShort> VariantShortPrx;

void __write(::IceInternal::BasicStream*, const VariantShortPrx&);
void __read(::IceInternal::BasicStream*, VariantShortPrx&);
void __write(::IceInternal::BasicStream*, const VariantShortPtr&);
void __patch__VariantShortPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const VariantShortPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const VariantShortPtr&);
void __decRefUnsafe(VariantShortPtr&);
void __clearHandleUnsafe(VariantShortPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::VariantInt> VariantIntPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::VariantInt> VariantIntPrx;

void __write(::IceInternal::BasicStream*, const VariantIntPrx&);
void __read(::IceInternal::BasicStream*, VariantIntPrx&);
void __write(::IceInternal::BasicStream*, const VariantIntPtr&);
void __patch__VariantIntPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const VariantIntPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const VariantIntPtr&);
void __decRefUnsafe(VariantIntPtr&);
void __clearHandleUnsafe(VariantIntPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::VariantLong> VariantLongPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::VariantLong> VariantLongPrx;

void __write(::IceInternal::BasicStream*, const VariantLongPrx&);
void __read(::IceInternal::BasicStream*, VariantLongPrx&);
void __write(::IceInternal::BasicStream*, const VariantLongPtr&);
void __patch__VariantLongPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const VariantLongPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const VariantLongPtr&);
void __decRefUnsafe(VariantLongPtr&);
void __clearHandleUnsafe(VariantLongPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::VariantFloat> VariantFloatPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::VariantFloat> VariantFloatPrx;

void __write(::IceInternal::BasicStream*, const VariantFloatPrx&);
void __read(::IceInternal::BasicStream*, VariantFloatPrx&);
void __write(::IceInternal::BasicStream*, const VariantFloatPtr&);
void __patch__VariantFloatPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const VariantFloatPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const VariantFloatPtr&);
void __decRefUnsafe(VariantFloatPtr&);
void __clearHandleUnsafe(VariantFloatPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::VariantDouble> VariantDoublePtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::VariantDouble> VariantDoublePrx;

void __write(::IceInternal::BasicStream*, const VariantDoublePrx&);
void __read(::IceInternal::BasicStream*, VariantDoublePrx&);
void __write(::IceInternal::BasicStream*, const VariantDoublePtr&);
void __patch__VariantDoublePtr(void*, ::Ice::ObjectPtr&);

void __addObject(const VariantDoublePtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const VariantDoublePtr&);
void __decRefUnsafe(VariantDoublePtr&);
void __clearHandleUnsafe(VariantDoublePtr&);

typedef ::IceInternal::Handle< ::InfoProcess::VariantString> VariantStringPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::VariantString> VariantStringPrx;

void __write(::IceInternal::BasicStream*, const VariantStringPrx&);
void __read(::IceInternal::BasicStream*, VariantStringPrx&);
void __write(::IceInternal::BasicStream*, const VariantStringPtr&);
void __patch__VariantStringPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const VariantStringPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const VariantStringPtr&);
void __decRefUnsafe(VariantStringPtr&);
void __clearHandleUnsafe(VariantStringPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::VariantCString> VariantCStringPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::VariantCString> VariantCStringPrx;

void __write(::IceInternal::BasicStream*, const VariantCStringPrx&);
void __read(::IceInternal::BasicStream*, VariantCStringPrx&);
void __write(::IceInternal::BasicStream*, const VariantCStringPtr&);
void __patch__VariantCStringPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const VariantCStringPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const VariantCStringPtr&);
void __decRefUnsafe(VariantCStringPtr&);
void __clearHandleUnsafe(VariantCStringPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::VariantBlob> VariantBlobPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::VariantBlob> VariantBlobPrx;

void __write(::IceInternal::BasicStream*, const VariantBlobPrx&);
void __read(::IceInternal::BasicStream*, VariantBlobPrx&);
void __write(::IceInternal::BasicStream*, const VariantBlobPtr&);
void __patch__VariantBlobPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const VariantBlobPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const VariantBlobPtr&);
void __decRefUnsafe(VariantBlobPtr&);
void __clearHandleUnsafe(VariantBlobPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::VariantTime> VariantTimePtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::VariantTime> VariantTimePrx;

void __write(::IceInternal::BasicStream*, const VariantTimePrx&);
void __read(::IceInternal::BasicStream*, VariantTimePrx&);
void __write(::IceInternal::BasicStream*, const VariantTimePtr&);
void __patch__VariantTimePtr(void*, ::Ice::ObjectPtr&);

void __addObject(const VariantTimePtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const VariantTimePtr&);
void __decRefUnsafe(VariantTimePtr&);
void __clearHandleUnsafe(VariantTimePtr&);

typedef ::IceInternal::Handle< ::InfoProcess::VariantShortVec> VariantShortVecPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::VariantShortVec> VariantShortVecPrx;

void __write(::IceInternal::BasicStream*, const VariantShortVecPrx&);
void __read(::IceInternal::BasicStream*, VariantShortVecPrx&);
void __write(::IceInternal::BasicStream*, const VariantShortVecPtr&);
void __patch__VariantShortVecPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const VariantShortVecPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const VariantShortVecPtr&);
void __decRefUnsafe(VariantShortVecPtr&);
void __clearHandleUnsafe(VariantShortVecPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::VariantIntVec> VariantIntVecPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::VariantIntVec> VariantIntVecPrx;

void __write(::IceInternal::BasicStream*, const VariantIntVecPrx&);
void __read(::IceInternal::BasicStream*, VariantIntVecPrx&);
void __write(::IceInternal::BasicStream*, const VariantIntVecPtr&);
void __patch__VariantIntVecPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const VariantIntVecPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const VariantIntVecPtr&);
void __decRefUnsafe(VariantIntVecPtr&);
void __clearHandleUnsafe(VariantIntVecPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::VariantLongVec> VariantLongVecPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::VariantLongVec> VariantLongVecPrx;

void __write(::IceInternal::BasicStream*, const VariantLongVecPrx&);
void __read(::IceInternal::BasicStream*, VariantLongVecPrx&);
void __write(::IceInternal::BasicStream*, const VariantLongVecPtr&);
void __patch__VariantLongVecPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const VariantLongVecPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const VariantLongVecPtr&);
void __decRefUnsafe(VariantLongVecPtr&);
void __clearHandleUnsafe(VariantLongVecPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::VariantFloatVec> VariantFloatVecPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::VariantFloatVec> VariantFloatVecPrx;

void __write(::IceInternal::BasicStream*, const VariantFloatVecPrx&);
void __read(::IceInternal::BasicStream*, VariantFloatVecPrx&);
void __write(::IceInternal::BasicStream*, const VariantFloatVecPtr&);
void __patch__VariantFloatVecPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const VariantFloatVecPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const VariantFloatVecPtr&);
void __decRefUnsafe(VariantFloatVecPtr&);
void __clearHandleUnsafe(VariantFloatVecPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::VariantDoubleVec> VariantDoubleVecPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::VariantDoubleVec> VariantDoubleVecPrx;

void __write(::IceInternal::BasicStream*, const VariantDoubleVecPrx&);
void __read(::IceInternal::BasicStream*, VariantDoubleVecPrx&);
void __write(::IceInternal::BasicStream*, const VariantDoubleVecPtr&);
void __patch__VariantDoubleVecPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const VariantDoubleVecPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const VariantDoubleVecPtr&);
void __decRefUnsafe(VariantDoubleVecPtr&);
void __clearHandleUnsafe(VariantDoubleVecPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::VariantVarVec> VariantVarVecPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::VariantVarVec> VariantVarVecPrx;

void __write(::IceInternal::BasicStream*, const VariantVarVecPrx&);
void __read(::IceInternal::BasicStream*, VariantVarVecPrx&);
void __write(::IceInternal::BasicStream*, const VariantVarVecPtr&);
void __patch__VariantVarVecPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const VariantVarVecPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const VariantVarVecPtr&);
void __decRefUnsafe(VariantVarVecPtr&);
void __clearHandleUnsafe(VariantVarVecPtr&);

typedef ::IceInternal::Handle< ::InfoProcess::VariantVarMap> VariantVarMapPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::InfoProcess::VariantVarMap> VariantVarMapPrx;

void __write(::IceInternal::BasicStream*, const VariantVarMapPrx&);
void __read(::IceInternal::BasicStream*, VariantVarMapPrx&);
void __write(::IceInternal::BasicStream*, const VariantVarMapPtr&);
void __patch__VariantVarMapPtr(void*, ::Ice::ObjectPtr&);

void __addObject(const VariantVarMapPtr&, ::IceInternal::GCCountMap&);
bool __usesClasses(const VariantVarMapPtr&);
void __decRefUnsafe(VariantVarMapPtr&);
void __clearHandleUnsafe(VariantVarMapPtr&);

}

namespace InfoProcess
{

enum VARTYPE
{
    VTNULL,
    VTBOOL,
    VTBYTE,
    VTSHORT,
    VTINT,
    VTLONG,
    VTFLOAT,
    VTDOUBLE,
    VTSTRING,
    VTCSTRING,
    VTBLOB,
    VTTIME,
    VTSHORTVEC,
    VTINTVEC,
    VTLONGVEC,
    VTFLOATVEC,
    VTDOUBLEVEC,
    VTVARVEC,
    VTVARMAP
};

void __write(::IceInternal::BasicStream*, VARTYPE);
void __read(::IceInternal::BasicStream*, VARTYPE&);

const ::std::string cnsSplitChar = "|";

typedef ::std::vector< ::InfoProcess::VARTYPE> VARTYPESeq;

class __U__VARTYPESeq { };
void __write(::IceInternal::BasicStream*, const ::InfoProcess::VARTYPE*, const ::InfoProcess::VARTYPE*, __U__VARTYPESeq);
void __read(::IceInternal::BasicStream*, VARTYPESeq&, __U__VARTYPESeq);

typedef ::std::vector< ::InfoProcess::VariantPtr> VariantSeq;

class __U__VariantSeq { };
void __write(::IceInternal::BasicStream*, const ::InfoProcess::VariantPtr*, const ::InfoProcess::VariantPtr*, __U__VariantSeq);
void __read(::IceInternal::BasicStream*, VariantSeq&, __U__VariantSeq);

typedef ::std::map< ::InfoProcess::VARTYPE, ::std::string> VarTypeDescDict;

class __U__VarTypeDescDict { };
void __write(::IceInternal::BasicStream*, const VarTypeDescDict&, __U__VarTypeDescDict);
void __read(::IceInternal::BasicStream*, VarTypeDescDict&, __U__VarTypeDescDict);

typedef ::std::map< ::std::string, ::InfoProcess::VariantPtr> VariantMap;

class __U__VariantMap { };
void __write(::IceInternal::BasicStream*, const VariantMap&, __U__VariantMap);
void __read(::IceInternal::BasicStream*, VariantMap&, __U__VariantMap);

}

namespace IceProxy
{

namespace InfoProcess
{

class Variant : virtual public ::IceProxy::Ice::Object
{
public:

    ::std::string toString()
    {
	return toString(__defaultContext());
    }
    ::std::string toString(const ::Ice::Context&);

    ::Ice::Int fromString(const ::std::string& s)
    {
	return fromString(s, __defaultContext());
    }
    ::Ice::Int fromString(const ::std::string&, const ::Ice::Context&);

    ::Ice::ByteSeq toByteSeq()
    {
	return toByteSeq(__defaultContext());
    }
    ::Ice::ByteSeq toByteSeq(const ::Ice::Context&);

    ::Ice::Int fromByteSeq(const ::Ice::ByteSeq& bs)
    {
	return fromByteSeq(bs, __defaultContext());
    }
    ::Ice::Int fromByteSeq(const ::Ice::ByteSeq&, const ::Ice::Context&);

    ::InfoProcess::VARTYPE getType()
    {
	return getType(__defaultContext());
    }
    ::InfoProcess::VARTYPE getType(const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class VariantBoolean : virtual public ::IceProxy::InfoProcess::Variant
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class VariantByte : virtual public ::IceProxy::InfoProcess::Variant
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class VariantShort : virtual public ::IceProxy::InfoProcess::Variant
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class VariantInt : virtual public ::IceProxy::InfoProcess::Variant
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class VariantLong : virtual public ::IceProxy::InfoProcess::Variant
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class VariantFloat : virtual public ::IceProxy::InfoProcess::Variant
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class VariantDouble : virtual public ::IceProxy::InfoProcess::Variant
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class VariantString : virtual public ::IceProxy::InfoProcess::Variant
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class VariantCString : virtual public ::IceProxy::InfoProcess::Variant
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class VariantBlob : virtual public ::IceProxy::InfoProcess::Variant
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class VariantTime : virtual public ::IceProxy::InfoProcess::Variant
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class VariantShortVec : virtual public ::IceProxy::InfoProcess::Variant
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class VariantIntVec : virtual public ::IceProxy::InfoProcess::Variant
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class VariantLongVec : virtual public ::IceProxy::InfoProcess::Variant
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class VariantFloatVec : virtual public ::IceProxy::InfoProcess::Variant
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class VariantDoubleVec : virtual public ::IceProxy::InfoProcess::Variant
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class VariantVarVec : virtual public ::IceProxy::InfoProcess::Variant
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class VariantVarMap : virtual public ::IceProxy::InfoProcess::Variant
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

}

}

namespace IceDelegate
{

namespace InfoProcess
{

class Variant : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual ::std::string toString(const ::Ice::Context&) = 0;

    virtual ::Ice::Int fromString(const ::std::string&, const ::Ice::Context&) = 0;

    virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Context&) = 0;

    virtual ::Ice::Int fromByteSeq(const ::Ice::ByteSeq&, const ::Ice::Context&) = 0;

    virtual ::InfoProcess::VARTYPE getType(const ::Ice::Context&) = 0;
};

class VariantBoolean : virtual public ::IceDelegate::InfoProcess::Variant
{
public:
};

class VariantByte : virtual public ::IceDelegate::InfoProcess::Variant
{
public:
};

class VariantShort : virtual public ::IceDelegate::InfoProcess::Variant
{
public:
};

class VariantInt : virtual public ::IceDelegate::InfoProcess::Variant
{
public:
};

class VariantLong : virtual public ::IceDelegate::InfoProcess::Variant
{
public:
};

class VariantFloat : virtual public ::IceDelegate::InfoProcess::Variant
{
public:
};

class VariantDouble : virtual public ::IceDelegate::InfoProcess::Variant
{
public:
};

class VariantString : virtual public ::IceDelegate::InfoProcess::Variant
{
public:
};

class VariantCString : virtual public ::IceDelegate::InfoProcess::Variant
{
public:
};

class VariantBlob : virtual public ::IceDelegate::InfoProcess::Variant
{
public:
};

class VariantTime : virtual public ::IceDelegate::InfoProcess::Variant
{
public:
};

class VariantShortVec : virtual public ::IceDelegate::InfoProcess::Variant
{
public:
};

class VariantIntVec : virtual public ::IceDelegate::InfoProcess::Variant
{
public:
};

class VariantLongVec : virtual public ::IceDelegate::InfoProcess::Variant
{
public:
};

class VariantFloatVec : virtual public ::IceDelegate::InfoProcess::Variant
{
public:
};

class VariantDoubleVec : virtual public ::IceDelegate::InfoProcess::Variant
{
public:
};

class VariantVarVec : virtual public ::IceDelegate::InfoProcess::Variant
{
public:
};

class VariantVarMap : virtual public ::IceDelegate::InfoProcess::Variant
{
public:
};

}

}

namespace IceDelegateM
{

namespace InfoProcess
{

class Variant : virtual public ::IceDelegate::InfoProcess::Variant,
		virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual ::std::string toString(const ::Ice::Context&);

    virtual ::Ice::Int fromString(const ::std::string&, const ::Ice::Context&);

    virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Context&);

    virtual ::Ice::Int fromByteSeq(const ::Ice::ByteSeq&, const ::Ice::Context&);

    virtual ::InfoProcess::VARTYPE getType(const ::Ice::Context&);
};

class VariantBoolean : virtual public ::IceDelegate::InfoProcess::VariantBoolean,
		       virtual public ::IceDelegateM::InfoProcess::Variant
{
public:
};

class VariantByte : virtual public ::IceDelegate::InfoProcess::VariantByte,
		    virtual public ::IceDelegateM::InfoProcess::Variant
{
public:
};

class VariantShort : virtual public ::IceDelegate::InfoProcess::VariantShort,
		     virtual public ::IceDelegateM::InfoProcess::Variant
{
public:
};

class VariantInt : virtual public ::IceDelegate::InfoProcess::VariantInt,
		   virtual public ::IceDelegateM::InfoProcess::Variant
{
public:
};

class VariantLong : virtual public ::IceDelegate::InfoProcess::VariantLong,
		    virtual public ::IceDelegateM::InfoProcess::Variant
{
public:
};

class VariantFloat : virtual public ::IceDelegate::InfoProcess::VariantFloat,
		     virtual public ::IceDelegateM::InfoProcess::Variant
{
public:
};

class VariantDouble : virtual public ::IceDelegate::InfoProcess::VariantDouble,
		      virtual public ::IceDelegateM::InfoProcess::Variant
{
public:
};

class VariantString : virtual public ::IceDelegate::InfoProcess::VariantString,
		      virtual public ::IceDelegateM::InfoProcess::Variant
{
public:
};

class VariantCString : virtual public ::IceDelegate::InfoProcess::VariantCString,
		       virtual public ::IceDelegateM::InfoProcess::Variant
{
public:
};

class VariantBlob : virtual public ::IceDelegate::InfoProcess::VariantBlob,
		    virtual public ::IceDelegateM::InfoProcess::Variant
{
public:
};

class VariantTime : virtual public ::IceDelegate::InfoProcess::VariantTime,
		    virtual public ::IceDelegateM::InfoProcess::Variant
{
public:
};

class VariantShortVec : virtual public ::IceDelegate::InfoProcess::VariantShortVec,
			virtual public ::IceDelegateM::InfoProcess::Variant
{
public:
};

class VariantIntVec : virtual public ::IceDelegate::InfoProcess::VariantIntVec,
		      virtual public ::IceDelegateM::InfoProcess::Variant
{
public:
};

class VariantLongVec : virtual public ::IceDelegate::InfoProcess::VariantLongVec,
		       virtual public ::IceDelegateM::InfoProcess::Variant
{
public:
};

class VariantFloatVec : virtual public ::IceDelegate::InfoProcess::VariantFloatVec,
			virtual public ::IceDelegateM::InfoProcess::Variant
{
public:
};

class VariantDoubleVec : virtual public ::IceDelegate::InfoProcess::VariantDoubleVec,
			 virtual public ::IceDelegateM::InfoProcess::Variant
{
public:
};

class VariantVarVec : virtual public ::IceDelegate::InfoProcess::VariantVarVec,
		      virtual public ::IceDelegateM::InfoProcess::Variant
{
public:
};

class VariantVarMap : virtual public ::IceDelegate::InfoProcess::VariantVarMap,
		      virtual public ::IceDelegateM::InfoProcess::Variant
{
public:
};

}

}

namespace IceDelegateD
{

namespace InfoProcess
{

class Variant : virtual public ::IceDelegate::InfoProcess::Variant,
		virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual ::std::string toString(const ::Ice::Context&);

    virtual ::Ice::Int fromString(const ::std::string&, const ::Ice::Context&);

    virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Context&);

    virtual ::Ice::Int fromByteSeq(const ::Ice::ByteSeq&, const ::Ice::Context&);

    virtual ::InfoProcess::VARTYPE getType(const ::Ice::Context&);
};

class VariantBoolean : virtual public ::IceDelegate::InfoProcess::VariantBoolean,
		       virtual public ::IceDelegateD::InfoProcess::Variant
{
public:
};

class VariantByte : virtual public ::IceDelegate::InfoProcess::VariantByte,
		    virtual public ::IceDelegateD::InfoProcess::Variant
{
public:
};

class VariantShort : virtual public ::IceDelegate::InfoProcess::VariantShort,
		     virtual public ::IceDelegateD::InfoProcess::Variant
{
public:
};

class VariantInt : virtual public ::IceDelegate::InfoProcess::VariantInt,
		   virtual public ::IceDelegateD::InfoProcess::Variant
{
public:
};

class VariantLong : virtual public ::IceDelegate::InfoProcess::VariantLong,
		    virtual public ::IceDelegateD::InfoProcess::Variant
{
public:
};

class VariantFloat : virtual public ::IceDelegate::InfoProcess::VariantFloat,
		     virtual public ::IceDelegateD::InfoProcess::Variant
{
public:
};

class VariantDouble : virtual public ::IceDelegate::InfoProcess::VariantDouble,
		      virtual public ::IceDelegateD::InfoProcess::Variant
{
public:
};

class VariantString : virtual public ::IceDelegate::InfoProcess::VariantString,
		      virtual public ::IceDelegateD::InfoProcess::Variant
{
public:
};

class VariantCString : virtual public ::IceDelegate::InfoProcess::VariantCString,
		       virtual public ::IceDelegateD::InfoProcess::Variant
{
public:
};

class VariantBlob : virtual public ::IceDelegate::InfoProcess::VariantBlob,
		    virtual public ::IceDelegateD::InfoProcess::Variant
{
public:
};

class VariantTime : virtual public ::IceDelegate::InfoProcess::VariantTime,
		    virtual public ::IceDelegateD::InfoProcess::Variant
{
public:
};

class VariantShortVec : virtual public ::IceDelegate::InfoProcess::VariantShortVec,
			virtual public ::IceDelegateD::InfoProcess::Variant
{
public:
};

class VariantIntVec : virtual public ::IceDelegate::InfoProcess::VariantIntVec,
		      virtual public ::IceDelegateD::InfoProcess::Variant
{
public:
};

class VariantLongVec : virtual public ::IceDelegate::InfoProcess::VariantLongVec,
		       virtual public ::IceDelegateD::InfoProcess::Variant
{
public:
};

class VariantFloatVec : virtual public ::IceDelegate::InfoProcess::VariantFloatVec,
			virtual public ::IceDelegateD::InfoProcess::Variant
{
public:
};

class VariantDoubleVec : virtual public ::IceDelegate::InfoProcess::VariantDoubleVec,
			 virtual public ::IceDelegateD::InfoProcess::Variant
{
public:
};

class VariantVarVec : virtual public ::IceDelegate::InfoProcess::VariantVarVec,
		      virtual public ::IceDelegateD::InfoProcess::Variant
{
public:
};

class VariantVarMap : virtual public ::IceDelegate::InfoProcess::VariantVarMap,
		      virtual public ::IceDelegateD::InfoProcess::Variant
{
public:
};

}

}

namespace InfoProcess
{

class Variant : virtual public ::Ice::Object
{
public:

    typedef VariantPrx ProxyType;
    typedef VariantPtr PointerType;
    
    Variant() {}
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::std::string toString(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___toString(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::Int fromString(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___fromString(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::ByteSeq toByteSeq(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___toByteSeq(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::Int fromByteSeq(const ::Ice::ByteSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___fromByteSeq(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::InfoProcess::VARTYPE getType(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___getType(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__VariantPtr(void*, ::Ice::ObjectPtr&);

class VariantBoolean : virtual public ::InfoProcess::Variant
{
public:

    typedef VariantBooleanPrx ProxyType;
    typedef VariantBooleanPtr PointerType;
    
    VariantBoolean() {}
    explicit VariantBoolean(bool);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    bool value;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__VariantBooleanPtr(void*, ::Ice::ObjectPtr&);

class VariantByte : virtual public ::InfoProcess::Variant
{
public:

    typedef VariantBytePrx ProxyType;
    typedef VariantBytePtr PointerType;
    
    VariantByte() {}
    explicit VariantByte(::Ice::Byte);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::Ice::Byte value;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__VariantBytePtr(void*, ::Ice::ObjectPtr&);

class VariantShort : virtual public ::InfoProcess::Variant
{
public:

    typedef VariantShortPrx ProxyType;
    typedef VariantShortPtr PointerType;
    
    VariantShort() {}
    explicit VariantShort(::Ice::Short);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::Ice::Short value;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__VariantShortPtr(void*, ::Ice::ObjectPtr&);

class VariantInt : virtual public ::InfoProcess::Variant
{
public:

    typedef VariantIntPrx ProxyType;
    typedef VariantIntPtr PointerType;
    
    VariantInt() {}
    explicit VariantInt(::Ice::Int);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::Ice::Int value;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__VariantIntPtr(void*, ::Ice::ObjectPtr&);

class VariantLong : virtual public ::InfoProcess::Variant
{
public:

    typedef VariantLongPrx ProxyType;
    typedef VariantLongPtr PointerType;
    
    VariantLong() {}
    explicit VariantLong(::Ice::Long);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::Ice::Long value;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__VariantLongPtr(void*, ::Ice::ObjectPtr&);

class VariantFloat : virtual public ::InfoProcess::Variant
{
public:

    typedef VariantFloatPrx ProxyType;
    typedef VariantFloatPtr PointerType;
    
    VariantFloat() {}
    explicit VariantFloat(::Ice::Float);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::Ice::Float value;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__VariantFloatPtr(void*, ::Ice::ObjectPtr&);

class VariantDouble : virtual public ::InfoProcess::Variant
{
public:

    typedef VariantDoublePrx ProxyType;
    typedef VariantDoublePtr PointerType;
    
    VariantDouble() {}
    explicit VariantDouble(::Ice::Double);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::Ice::Double value;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__VariantDoublePtr(void*, ::Ice::ObjectPtr&);

class VariantString : virtual public ::InfoProcess::Variant
{
public:

    typedef VariantStringPrx ProxyType;
    typedef VariantStringPtr PointerType;
    
    VariantString() {}
    explicit VariantString(const ::std::string&);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::std::string value;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__VariantStringPtr(void*, ::Ice::ObjectPtr&);

class VariantCString : virtual public ::InfoProcess::Variant
{
public:

    typedef VariantCStringPrx ProxyType;
    typedef VariantCStringPtr PointerType;
    
    VariantCString() {}
    explicit VariantCString(const ::Ice::ByteSeq&);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::Ice::ByteSeq value;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__VariantCStringPtr(void*, ::Ice::ObjectPtr&);

class VariantBlob : virtual public ::InfoProcess::Variant
{
public:

    typedef VariantBlobPrx ProxyType;
    typedef VariantBlobPtr PointerType;
    
    VariantBlob() {}
    explicit VariantBlob(const ::Ice::ByteSeq&);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::Ice::ByteSeq value;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__VariantBlobPtr(void*, ::Ice::ObjectPtr&);

class VariantTime : virtual public ::InfoProcess::Variant
{
public:

    typedef VariantTimePrx ProxyType;
    typedef VariantTimePtr PointerType;
    
    VariantTime() {}
    explicit VariantTime(const ::std::string&);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::std::string value;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__VariantTimePtr(void*, ::Ice::ObjectPtr&);

class VariantShortVec : virtual public ::InfoProcess::Variant
{
public:

    typedef VariantShortVecPrx ProxyType;
    typedef VariantShortVecPtr PointerType;
    
    VariantShortVec() {}
    explicit VariantShortVec(const ::Ice::ShortSeq&);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::Ice::ShortSeq value;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__VariantShortVecPtr(void*, ::Ice::ObjectPtr&);

class VariantIntVec : virtual public ::InfoProcess::Variant
{
public:

    typedef VariantIntVecPrx ProxyType;
    typedef VariantIntVecPtr PointerType;
    
    VariantIntVec() {}
    explicit VariantIntVec(const ::Ice::IntSeq&);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::Ice::IntSeq value;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__VariantIntVecPtr(void*, ::Ice::ObjectPtr&);

class VariantLongVec : virtual public ::InfoProcess::Variant
{
public:

    typedef VariantLongVecPrx ProxyType;
    typedef VariantLongVecPtr PointerType;
    
    VariantLongVec() {}
    explicit VariantLongVec(const ::Ice::LongSeq&);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::Ice::LongSeq value;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__VariantLongVecPtr(void*, ::Ice::ObjectPtr&);

class VariantFloatVec : virtual public ::InfoProcess::Variant
{
public:

    typedef VariantFloatVecPrx ProxyType;
    typedef VariantFloatVecPtr PointerType;
    
    VariantFloatVec() {}
    explicit VariantFloatVec(const ::Ice::FloatSeq&);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::Ice::FloatSeq value;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__VariantFloatVecPtr(void*, ::Ice::ObjectPtr&);

class VariantDoubleVec : virtual public ::InfoProcess::Variant
{
public:

    typedef VariantDoubleVecPrx ProxyType;
    typedef VariantDoubleVecPtr PointerType;
    
    VariantDoubleVec() {}
    explicit VariantDoubleVec(const ::Ice::DoubleSeq&);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    ::Ice::DoubleSeq value;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__VariantDoubleVecPtr(void*, ::Ice::ObjectPtr&);

class VariantVarVec : virtual public ::InfoProcess::Variant
{
public:

    typedef VariantVarVecPrx ProxyType;
    typedef VariantVarVecPtr PointerType;
    
    VariantVarVec() {}
    explicit VariantVarVec(const ::InfoProcess::VariantSeq&);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void __incRef();
    virtual void __decRef();
    virtual void __addObject(::IceInternal::GCCountMap&);
    virtual bool __usesClasses();
    virtual void __gcReachable(::IceInternal::GCCountMap&) const;
    virtual void __gcClear();
    ::InfoProcess::VariantSeq value;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__VariantVarVecPtr(void*, ::Ice::ObjectPtr&);

class VariantVarMap : virtual public ::InfoProcess::Variant
{
public:

    typedef VariantVarMapPrx ProxyType;
    typedef VariantVarMapPtr PointerType;
    
    VariantVarMap() {}
    explicit VariantVarMap(const ::InfoProcess::VariantMap&);
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void __incRef();
    virtual void __decRef();
    virtual void __addObject(::IceInternal::GCCountMap&);
    virtual bool __usesClasses();
    virtual void __gcReachable(::IceInternal::GCCountMap&) const;
    virtual void __gcClear();
    ::InfoProcess::VariantMap value;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void __patch__VariantVarMapPtr(void*, ::Ice::ObjectPtr&);

}

#endif
