// **********************************************************************
//
// Copyright (c) 2003-2006 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

#include <Ice/Application.h>
#include <IceStorm/IceStorm.h>
#include <IceUtil/UUID.h>

// ICEصͷļ
#include <Ice/Ice.h>
#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>
#include <Ice/Application.h>
#include <IceUtil/Base64.h>
#include <IceUtil/Thread.h>
#include <IceUtil/RWRecMutex.h>
#include <IceStorm/IceStorm.h>
#include <IceUtil/UUID.h>



// STLصͷļ
#include <list>
#include <vector>
#include <map>
#include <deque>
#include <algorithm>
#include <iostream>
#include <sstream>

#include "IPSServer/IPSVariant.h"
#include "IPSServer/VariantFactory.h"    //๤
#include "IPSServer/IPSException.h"      //ҵϵͳ쳣ļ

#include <map>


#include <sys/timeb.h>
#include <time.h>
using namespace std;

using namespace Ice;
using namespace InfoProcess;                //Ϣռ

///////////////////////////////////////////////////////////////////////////////
class IPSStatePublisherI : virtual public IPSStatePublisher 
{
public:
virtual void ReportItemState(const IPSItemStateSeq& issSeq,const Ice::Current&) 
{
        ::InfoProcess::IPSItemStateSeq      itemStateSeq;
        itemStateSeq = issSeq;
        
        cout<< "["<< GetCurrTimeStr() << "]յĵĿ״̬Ϣ:"<<endl;
        ::InfoProcess::IPSItemStateSeq::iterator it;
        int i=1;
        for(it=itemStateSeq.begin();it!=itemStateSeq.end();it++)
        {
            cout<<"Ŀ״̬Ϣ = "<<i<<endl;
            cout<<"szItemID               = "<<(*it)->szItemID<<endl;
            cout<<"lTimeStamp             = "<<(*it)->lTimeStamp<<endl;
            cout<<"nQuality               = "<<(*it)->nQuality<<endl;
            cout<<"vDataValue             = "<<PrintVar2Str((*it)->vDataValue,0)<<endl;
            i++;
            cout<<endl;
        }
		
   return;

}
std::string GetCurrTimeStr()
{
    
    time_t tim;
    time( &tim );
    
    struct tm* t = NULL;
#ifdef _WIN32
    t = localtime(&tim);
#else
    struct tm tr;
    localtime_r(&tim, &tr);
    t = &tr;
#endif
    
    //cеstrtime
    //char buf[32];
    //strftime(buf, sizeof(buf), "%Y-%m-%d %H:%M:%S", t);
    //
    //return buf;
    
    ostringstream os;
    os.fill('0');
    os.widen(4);
    os << (t->tm_year+1900) << "-";               //Ǵ1900Ϊ0꿪ʼ
    os.width(2);
    os << (t->tm_mon+1) << "-";               //·Ǵֵ0ʼ
    os.width(2);
    os << t->tm_mday << " ";
    os.width(2);
    os << t->tm_hour << ":";
    os.width(2);
    os << t->tm_min << ":";
    os.width(2);
    os << t->tm_sec;
    
    return os.str();
}
string PrintVar2Str(const InfoProcess::VariantPtr& pV, int iBlankNum)
{
    if ( !pV )  //Variantֵ
    {
        return "";
    }
    ostringstream           os;
    InfoProcess::VARTYPE    vt;         //Variantֵ
    string                  sBlank;     //׵Ŀոִ
    int                     i;
    
    //׵Ŀոִ
    sBlank = "";
    for( i=0; i<iBlankNum; i++)
    {
        sBlank += "   ";
    }
    
    vt = pV->getType();
    os << sBlank << "VariantΪ[" << vt << "] ";
    
    //ֵͷֱдӡ
    switch( vt )
    {
        case VTBOOL:
        case VTBYTE:
        case VTSHORT:
        case VTINT:
        case VTLONG:
        case VTFLOAT:
        case VTDOUBLE:
        case VTSTRING:
        case VTCSTRING:
        case VTBLOB:
        case VTTIME:
        case VTSHORTVEC:
        case VTINTVEC:
        case VTLONGVEC:
        case VTFLOATVEC:
        case VTDOUBLEVEC:
            os << sBlank << " VariantֵΪ" << pV->toString() << endl;
            break;
        case VTVARVEC:
            {
                InfoProcess::VariantSeq::iterator   it;
                VariantVarVecPtr                    pVar  = NULL;
                
                os << sBlank << " VariantVecֵΪ" << endl;
                pVar = VariantVarVecPtr::dynamicCast(pV);
                
                //ÿVecԱӡ
                for (it=pVar->value.begin();pVar->value.end()!=it;++it)
                {
                    os << PrintVar2Str(*it, iBlankNum+1);
                }
            }
            break;
        case VTVARMAP:
            {
                InfoProcess::VariantMap::iterator   it;
                VariantVarMapPtr                    pVar  = NULL;
                
                os << sBlank << " VariantMapֵΪ" << endl;
                pVar = VariantVarMapPtr::dynamicCast(pV);
                
                //ÿMapԱӡ
                for (it=pVar->value.begin();pVar->value.end()!=it;++it)
                {
                    os << sBlank << "  ؼΪ" << it->first << endl;
                    os << PrintVar2Str(it->second,iBlankNum+1);
                }
            }
            break;
        default:
            break;
    }
    
    return os.str();
}
};
///////////////////////////////////////////////////////////////////////////////

class Subscriber : public Ice::Application
{
public:

    virtual int run(int, char*[]);
private:
	   // ICEͨ
    Ice::CommunicatorPtr    _communicator;

};

int
main(int argc, char* argv[])
{
    Subscriber app;
    return app.main(argc, argv, "config.sub");
}



int
Subscriber::run(int argc, char* argv[])
{

    _communicator = communicator();

	//๤
    Ice::ObjectFactoryPtr factory = new CVariantFactory();
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantBoolean");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantByte");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantShort");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantInt");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantLong");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantFloat");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantDouble");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantString");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantCString");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantBlob");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantTime");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantShortVec");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantIntVec");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantLongVec");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantFloatVec");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantDoubleVec");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantVarVec");
    communicator()->addObjectFactory(factory, "::InfoProcess::VariantVarMap");
	
	
	
	Ice::ObjectPrx obj = _communicator->stringToProxy("XCIceStorm/TopicManager:default -p 60000 -h 172.16.16.110");
	IceStorm::TopicManagerPrx topicManager = IceStorm::TopicManagerPrx::checkedCast(obj);
	
	Ice::ObjectAdapterPtr adapter =
	_communicator->createObjectAdapter("IPSServer.Subscriber");
	
	IPSStatePublisherPtr publisher = new IPSStatePublisherI;
	Ice::ObjectPrx proxy = adapter->addWithUUID(publisher);
	IceStorm::TopicPrx topic;
	try { 
	topic = topicManager->retrieve("IPS_DEFAULT_ITEM_STATE");
	IceStorm::QoS qos;
	topic->subscribe(qos, proxy);
	}
	catch (const IceStorm::NoSuchTopic&) {
		cout << "Error! No topic found!" << endl;
	}
		    

    
    // These methods can be used to set a Ctrl+C Handler callback.
    //һIceUtil::CtrlCHandlerڸɾعرӦáȱʡΪ
    //This function creates an IceUtil::CtrlCHandler that shuts down the
    //    communicator when one of the monitored signals is raised.
    shutdownOnInterrupt();
    //destroyOnInterrupt();
    
    ///////////////////////////////////////////////////////////////////////////////
    //ӿ
    try
    {
        //ͨӿ
        adapter->activate();
        
    }
    catch(const Ice::ObjectAdapterDeactivatedException& ex)
    {
        ostringstream os;
        os << "ʧܣ" << ex << "";
        cout << os << endl;
    }
    catch ( exception* e) 
    {
        string sReason;
        sReason = "ʱ˴";
        sReason += e->what();
        cout << sReason << endl;

    }
    catch ( ... ) 
    {
        string sReason;
        sReason = "ʱ˴";
        cout << sReason << endl;

    }
    
    try
    {
        cout << "̨׼" << endl;
        _communicator->waitForShutdown();
        topic->unsubscribe(proxy);
    }
    catch ( exception* e) 
    {
        string sReason;
        sReason = "̨ʱ˴";
        sReason += e->what();
        cout << sReason << endl;

    }
    catch ( ... ) 
    {
        string sReason;
        sReason = "̨ʱ˴";
        cout << sReason << endl;

    }
    
    cout << "ڴͷŹʼ" << endl;
       
    
    //ʹźűԡ
    ignoreInterrupt();
    cout << "̨ϵͳ˳׼ȫɣ˳С" << endl;

    
    //return 0;
    return EXIT_SUCCESS;
}
